diff --git a/.gitignore b/.gitignore
index ba19389dc..afeca1d58 100644
--- a/.gitignore
+++ b/.gitignore
@@ -63,6 +63,7 @@
 /third_party/qemu-linux-x64
 /third_party/qemu-mac-x64
 /third_party/r8/lib
+third_party/r8/*.jar
 /third_party/rapidjson/src
 /third_party/requests/src
 /third_party/six
diff --git a/ChangeLog-2022-02-22 b/ChangeLog-2022-02-22
new file mode 100644
index 000000000..ca67026bc
--- /dev/null
+++ b/ChangeLog-2022-02-22
@@ -0,0 +1,19278 @@
+2022-02-18  Robert Jenner  <Jenner@apple.com>
+
+        Unreviewed, reverting r290149.
+
+        Broke Debug Builds.
+
+        Reverted changeset:
+
+        "Generate compile_commands.json on macOS Builds"
+        https://bugs.webkit.org/show_bug.cgi?id=235686
+        https://commits.webkit.org/r290149
+
+2022-02-18  Brandon Stewart  <brandonstewart@apple.com>
+
+        Generate compile_commands.json on macOS Builds
+        https://bugs.webkit.org/show_bug.cgi?id=235686
+
+        Reviewed by Saam Barati.
+
+        Add support for generating compile_commands.json file to WebKit.
+        
+        compile_commands.json can be used by tools like clangd to provide code complete,
+        refactoring, formatting, and cross references.
+
+        Steps to generate the compile commands file:
+        make r EXPORT_COMPILE_COMMANDS=YES
+        generate-compile-commands WebKitBuild/Release
+
+        * Configurations/DebugRelease.xcconfig:
+
+2022-02-18  Saam Barati  <sbarati@apple.com>
+
+        Remove ANGLE-static.xcconfig
+        https://bugs.webkit.org/show_bug.cgi?id=236827
+
+        Reviewed by Dean Jackson.
+
+        It was unused.
+
+        * ANGLE.xcodeproj/project.pbxproj:
+        * Configurations/ANGLE-static.xcconfig: Removed.
+        * Configurations/Base.xcconfig:
+
+2022-02-18  Adrian Perez de Castro  <aperez@igalia.com>
+
+        [CMake] Cannot find OpenGL when system provides opengl.pc instead of gl.pc
+        https://bugs.webkit.org/show_bug.cgi?id=236592
+
+        Reviewed by Michael Catanzaro.
+
+        * PlatformGTK.cmake: Use the OpenGL::OpenGL imported target instead of the
+        OPENGL_LIBRARIES variable.
+        * PlatformWPE.cmake: Remove linking againt OpenGL libraries; the WPE port is not
+        supposed to link to any of them directly.
+
+2022-02-18  Zan Dobersek  <zdobersek@igalia.com>
+
+        [GTK][WPE] Don't use ANGLE's GBM-based display
+        https://bugs.webkit.org/show_bug.cgi?id=236772
+
+        Reviewed by Alejandro G. Castro.
+
+        With DisplayGbm functionality not necessary anymore, we can stop
+        building the associated code and linking against libgbm and libdrm at
+        the ANGLE level. These two libraries are still dependencies that have
+        since become necessary in WebCore.
+
+        * CMakeLists.txt:
+        * PlatformGTK.cmake:
+        * PlatformWPE.cmake:
+
+2022-02-18  Saam Barati  <sbarati@apple.com>
+
+        Add LC_SOURCE_VERSION to compile targets
+        https://bugs.webkit.org/show_bug.cgi?id=236720
+        <rdar://84984140>
+
+        Reviewed by Michael Saboff.
+
+        * Configurations/Base.xcconfig:
+        * Configurations/Version.xcconfig:
+
+2022-02-17  Kyle Piddington  <kpiddington@apple.com>
+
+        Metal ANGLE: vertex array does not correctly observe contents of data buffers
+        https://bugs.webkit.org/show_bug.cgi?id=236733
+        <rdar://problem/88713302>
+        <rdar://problem/88499073>
+
+        Reviewed by Dean Jackson.
+
+        Similar to previous bug (236427), we were not correctly observing changes to the
+        vertex buffer data. This caused us to miss rebinding vertex buffers
+        when data was updated without causing conversion
+
+        * src/libANGLE/renderer/metal/VertexArrayMtl.h:
+        * src/libANGLE/renderer/metal/VertexArrayMtl.mm:
+        (rx::VertexArrayMtl::syncState):
+        (rx::VertexArrayMtl::setupDraw):
+        (rx::VertexArrayMtl::syncDirtyAttrib):
+
+2022-02-17  Adrian Perez de Castro  <aperez@igalia.com>
+
+        [GTK] Build broken with ENABLE_X11_TARGET=OFF and no X11 headers present
+        https://bugs.webkit.org/show_bug.cgi?id=236770
+
+        Reviewed by Alejandro G. Castro.
+
+        * PlatformGTK.cmake: The USE_SYSTEM_EGL definition detaches the type definitions
+        from the EGL headers generic and prevents ANGLE's headers from including system X11
+        or Wayland headers from the system, so apply it always independently of whether the
+        USE_ANGLE_{EGL,WEBGL} options are enabled. While at it, fix a missing dollar sign in
+        the expansion of the ${GBM_INCLUDE_DIR} variable.
+
+2022-02-17  Kimmo Kinnunen  <kkinnunen@apple.com>
+
+        REGRESSION (iOS 15.4b3): Catastrophic (20x) performance regression in texImage2D from mp4 video
+        https://bugs.webkit.org/show_bug.cgi?id=236699
+
+        Reviewed by Darin Adler.
+
+        Disable the validation for IOSurface pixel formats.
+        We might pass non-public formats that do not have sensible IOSurfaceGetBytesPerElementOfPlane
+        to verify with this logic.
+
+        Will add test in bug 236759.
+
+        Previous bugs of the same:
+        EAGL:
+        Textures Fail to Render in WebGL from HLS Stream on iPhone 12 [iOS 14.2]
+        bug 218637, r273582, 234632@main
+        CGL:
+        REGRESSION(Safari 15, BigSur): Poor video texture upload performance with MacBook M1, ANGLE OpenGL backend
+        bug 232235, r286960, 245183@main
+
+        * src/libANGLE/renderer/metal/IOSurfaceSurfaceMtl.mm:
+        (rx::IOSurfaceSurfaceMtl::ValidateAttributes):
+
+2022-02-17  Commit Queue  <commit-queue@webkit.org>
+
+        Unreviewed, reverting r289949.
+        https://bugs.webkit.org/show_bug.cgi?id=236757
+
+        Breaks WPE builds with -DUSE_ANGLE_WEBGL=ON
+
+        Reverted changeset:
+
+        "[CMake] Cannot find OpenGL when system provides opengl.pc
+        instead of gl.pc"
+        https://bugs.webkit.org/show_bug.cgi?id=236592
+        https://commits.webkit.org/r289949
+
+2022-02-16  Adrian Perez de Castro  <aperez@igalia.com>
+
+        [CMake] Cannot find OpenGL when system provides opengl.pc instead of gl.pc
+        https://bugs.webkit.org/show_bug.cgi?id=236592
+
+        Reviewed by Don Olmstead.
+
+        * PlatformGTK.cmake: Use the OpenGL::OpenGL imported target instead of the
+        OPENGL_LIBRARIES variable.
+        * PlatformWPE.cmake: Ditto, plus replace a spurious use of OPENGLES_LIBRARIES
+        with the OpenGL::GLES target.
+
+2022-02-11  Kyle Piddington  <kpiddington@apple.com>
+
+        Cocoa2d-HTLM5 game apepars to use wrong vertex buffer data
+        https://bugs.webkit.org/show_bug.cgi?id=236427
+        <rdar://problem/87136345>
+
+        Reviewed by Kimmo Kinnunen.
+
+        Render encoder appears to carry stale state when a vertex array's element
+        buffer is updated, but no other parts of the buffer are updated. Reassign
+        vertex buffer bindings in this case, which clears up corruption
+        (Squished rendering elements, incorrect UV's)
+
+        * src/libANGLE/renderer/metal/VertexArrayMtl.h:
+        * src/libANGLE/renderer/metal/VertexArrayMtl.mm:
+        (rx::VertexArrayMtl::syncState):
+        (rx::VertexArrayMtl::setupDraw):
+
+2022-02-03  Michael Saboff  <msaboff@apple.com>
+
+        WebKit projects have incorrect install name for the frameworks for Catalyst builds with the system content path
+        https://bugs.webkit.org/show_bug.cgi?id=236105
+
+        Reviewed by Saam Barati.
+
+        Updated DYLIB_INSTALL_NAME_BASE for Catalyst builds to not use the system content path prefix.
+
+        * Configurations/ANGLE-dynamic.xcconfig:
+
+2022-01-18  Alex Christensen  <achristensen@webkit.org>
+
+        Use c++2a instead of gnu++2a for Cocoa builds
+        https://bugs.webkit.org/show_bug.cgi?id=234936
+
+        Reviewed by Sam Weinig.
+
+        * Configurations/Base.xcconfig:
+
+2022-01-17  David Kilzer  <ddkilzer@apple.com>
+
+        REGRESSION (r249823): gl::Context::onProgramLink() leaks gl::Framebuffer object due early return when an error occurs in ANGLE_TRY() macro
+        <https://webkit.org/b/235284>
+        <rdar://problem/87656747>
+
+        Reviewed by Darin Adler.
+
+        * src/libANGLE/Context.cpp:
+        (gl::Context::setDefaultFramebuffer):
+        - Use std::unique_ptr<> to store gl::Framebuffer so the object
+          is released on early return.
+        * src/libANGLE/Surface.cpp:
+        (egl::Surface::createDefaultFramebuffer):
+        - Update to return std::unique_ptr<gl::Framebuffer>.
+        * src/libANGLE/Surface.h:
+        (egl::Surface::createDefaultFramebuffer):
+        - Update declaration to return std::unique_ptr<gl::Framebuffer>.
+        (egl::Surface::createDefaultFramebuffer): Delete.
+        - Remove the second, protected method that is currently
+          unimplemented.
+
+2022-01-17  David Kilzer  <ddkilzer@apple.com>
+
+        REGRESSION (r286603): rx::ProgramMtl::getSpecializedShader() leaks MTLFunctionConstantValues object due early return when an error occurs in ANGLE_TRY() macro
+        <https://webkit.org/b/235281>
+        <rdar://problem/87656387>
+
+        Reviewed by Darin Adler.
+
+        * src/libANGLE/renderer/metal/ProgramMtl.mm:
+        (rx::ProgramMtl::getSpecializedShader):
+        - Use mtl::AutoObjCObj<> to release MTLFunctionConstantValues
+          object on early return.
+
+2022-01-17  David Kilzer  <ddkilzer@apple.com>
+
+        Follow-up: REGRESSION (r286603): Leak of three NSMutableDictionary objects each time rx::DisplayMtl::getMetalDeviceMatchingAttribute() is called
+        <https://webkit.org/b/235278>
+        <rdar://problem/87653812>
+
+        Unreviewed follow-up fix from Bug 235281, Comment #5.
+
+        * src/libANGLE/renderer/metal/DisplayMtl.mm:
+        (rx::DisplayMtl::getMetalDeviceMatchingAttribute):
+        - Remove unneeded calls to .get().
+
+2022-01-16  David Kilzer  <ddkilzer@apple.com>
+
+        REGRESSION (r286603): Leak of three NSMutableDictionary objects each time rx::DisplayMtl::getMetalDeviceMatchingAttribute() is called
+        <https://webkit.org/b/235278>
+        <rdar://problem/87653812>
+
+        Reviewed by Darin Adler.
+
+        * src/libANGLE/renderer/metal/DisplayMtl.mm:
+        (rx::DisplayMtl::getMetalDeviceMatchingAttribute):
+        - Make use of mtl::adoptObjCObj<> so these objects are relaseed
+          when the method returns.
+
+2022-01-14  Kyle Piddington  <kpiddington@apple.com>
+
+        ANGLE: Supports32BitFloatFiltering is not supported on TVOS
+        https://bugs.webkit.org/show_bug.cgi?id=235239
+        
+        Reviewed by Darin Adler.
+
+        <rdar://86457081>
+        Broke an internal build. Caused by https://trac.webkit.org/changeset/286323/webkit
+
+        * src/libANGLE/renderer/metal/DisplayMtl.mm:
+        (rx::DisplayMtl::supports32BitFloatFiltering const):
+
+2022-01-12  Chris Lord  <clord@igalia.com>
+
+        [WPE] Enable WebGL ANGLE support
+        https://bugs.webkit.org/show_bug.cgi?id=235064
+
+        Reviewed by Alejandro G. Castro.
+
+        Enable building on WPE (mostly copying the GTK build file).
+
+        * PlatformWPE.cmake:
+
+2022-01-11  Kyle Piddington  <kpiddington@apple.com>
+
+        ANGLE: ASTC-HDR is not available on TVOS
+        https://bugs.webkit.org/show_bug.cgi?id=235076
+
+        Reviewed by Dean Jackson.
+
+        <rdar://87384038>
+        This is a follow on patch to https://bugs.webkit.org/show_bug.cgi?id=234164,
+        ASTC-HDR is only available on macOS and iOS, not tvOS or watchOS	
+	This patch fixes an internal build.
+
+        * scripts/code_generation_hashes/Metal_format_table.json:
+        * src/libANGLE/renderer/metal/gen_mtl_format_table.py:
+        (gen_image_map_switch_astc_case_tv_watchos):
+        (gen_image_map_switch_string):
+        (gen_image_mtl_to_angle_switch_string):
+        (gen_image_map_switch_astc_case_watchos): Deleted.
+        (gen_image_map_switch_astc_case_watchos.gen_format_assign_code): Deleted.
+        * src/libANGLE/renderer/metal/mtl_format_table_autogen.mm:
+        (rx::mtl::Format::MetalToAngleFormatID):
+        (rx::mtl::Format::init):
+
+2022-01-10  Alex Christensen  <achristensen@webkit.org>
+
+        Start using C++20
+        https://bugs.webkit.org/show_bug.cgi?id=233963
+
+        Reviewed by Yusuke Suzuki.
+
+        * Configurations/Base.xcconfig:
+
+2022-01-09  Sam Weinig  <weinig@apple.com>
+
+        Remove support for Direct2D
+        https://bugs.webkit.org/show_bug.cgi?id=234999
+
+        Reviewed by Darin Adler.
+
+        Direct2D and FTW have not been building for over a year. It is
+        time to remove them.
+
+        * PlatformFTW.cmake: Removed.
+
+2022-01-07  Alex Christensen  <achristensen@webkit.org>
+
+        Unreviewed, reverting r287698.
+
+        Broke an internal build
+
+        Reverted changeset:
+
+        "Start using C++20"
+        https://bugs.webkit.org/show_bug.cgi?id=233963
+        https://commits.webkit.org/r287698
+
+2022-01-06  Alex Christensen  <achristensen@webkit.org>
+
+        Start using C++20
+        https://bugs.webkit.org/show_bug.cgi?id=233963
+
+        Reviewed by Yusuke Suzuki.
+
+        * Configurations/Base.xcconfig:
+
+2022-01-05  Kyle Piddington  <kpiddington@apple.com>
+
+        Roll ANGLE to aabfe8747d 12-17-2021
+        https://bugs.webkit.org/show_bug.cgi?id=234523
+
+        Reviewed by Kenneth Russell.
+
+        The changelog has been removed to improve readability.
+        The following ANGLE commits were merged: 
+
+        aabfe8747 Metal: Use the context device to Texture::resize
+        34ea81111 Reland "Vulkan: Don't expose MSRTT on SwiftShader"
+        624e3c3d5 Fix dangerous use of AutoObjCPtr after ownership identity change
+        4a148e9d9 Revert "Vulkan: Suppress VUID-vkCmdDraw-blendEnable"
+        ede0b8b71 Avoid ANGLE_MTL_AUTORELEASE inside ASSERT, it leaks on Release
+        cb4f441c8 Roll vulkan-deps from 39f3a18bdfbe to 5568048d205e (8 revisions)
+        2f78b48db Roll Chromium from 14ca75d254a5 to 81decb7250e1 (191 revisions)
+        001221f0e Metal: upstream fix from WebKit for texture leak.
+        dca434bdc Roll Chromium from 3f6c88f5581a to 14ca75d254a5 (401 revisions)
+        b9f2d9cc1 Use text expectations to skip a test
+        6c894e829 Vulkan: Replace BufferVk::getBufferAndOffset() with getBuffer()
+        f2736f6dc Tests: Add My Talking Tom Friends trace.
+        a93a3930b Vulkan: Track enabled in VertexArray
+        83a670ab0 Vulkan: Implement BufferPool using VMA's virtual allocator
+        836797166 Vulkan: Dirty vertex buffers if default attrib values changed
+        543f5750f (origin/chromium/4771) Vulkan: Disable protected memory for ARM
+        c7446ac42 Add support for GL_MESA_framebuffer_flip_y 1/*
+        60383b41e Tests: Add Dota Underlords trace.
+        f26687a03 Tests: Add My Talking Tom 2 trace.
+        438de17ee Roll vulkan-deps from a8221eed5970 to 39f3a18bdfbe (5 revisions)
+        e7413adff system_utils_posix: Check for SEGV_MAPERR si_code.
+        6e5fd8165 Support more ImageLayout in ConvertImageLayoutToGLImageLayout
+        b26bb13ab Metal: Remove references to xfbActiveUnpaused uniform
+        bb5bab031 Roll Chromium from 2dae07eeb163 to 3f6c88f5581a (414 revisions)
+        c4d434b91 Metal: Enable OES_fbo_render_mipmap
+        670679918 Metal: Fix Webkit warnings in ANGLE build
+        bda493258 Add guards for 64 bit types on 32bit systems
+        e7c9dbb88 Skip SimpleStateChangeTestES3.OutOfBoundsByteAttribute on Pixel4 GLES
+        89e11878b Vulkan: Fix the UAF issue with BufferData
+        ee1d3cf74 Metal: Integrate Metal Binary Shader generation
+        3e7e2758f Metal: Fix macOS ANGLE build on Catalina (10.15) SDK
+        05a44dd24 Vulkan: Set content undefined on eglSwapBuffers
+        26fa0fe68 Tests: Add Asphalt 9 trace
+        5275f487e Vulkan: Disable async command queue with Vulkan SCBs
+        feb599ad8 Invalidate EGL handles during eglTerminate
+        32e23bb9d Expand WebGLCompressedTextureAvailabilityTest
+        d6b9a2597 end2end_tests: Add SwS + AsyncQueue testing.
+        a0eb6146c Update warning message for invalid include
+        cac81f077 Return full error info when opening a library with dlopen
+        90c3038e5 Vulkan: Fix desc set updates with Vulkan SCBs
+        8419f4fcd Roll vulkan-deps from c03890076954 to a8221eed5970 (2 revisions)
+        db367bd71 Roll Chromium from 0c0a3654694f to 2dae07eeb163 (450 revisions)
+        bfc7f09ae Revert "Upgrade restricted traces to new trace format."
+        800c6971c Modified buffer fallback format to smaller storage format
+        709d87278 Revert "Trace Tests: Remove auto-generated code."
+        3da54250b Skip MultithreadingTest.MultiContextDrawWithSwapBuffers
+        7f1a0f89b Switch to non-deprecated bbagent, remove defunct experiments.
+        9d49d8438 Add WebGLCompressedTextureAvailabilityTest
+	
+2022-01-05  Michael Saboff  <msaboff@apple.com>
+
+        REGRESSION (r287382): libANGLE is built into a wrong location on iOS
+        https://bugs.webkit.org/show_bug.cgi?id=234857
+
+        Reviewed by Saam Barati.
+
+        Reverted to the prior logic to compute INSTALL_PATH.  Then added an optional prefix
+        for the alternate root framework location.
+
+        * Configurations/ANGLE-dynamic.xcconfig:
+
+2021-12-22  Michael Saboff  <msaboff@apple.com>
+
+        Fix WebKit Build issues when using system content path
+        https://bugs.webkit.org/show_bug.cgi?id=234624
+
+        Reviewed by Filip Pizlo.
+
+        Changed INSTALL_PATH on macOS builds to use a fully qualified .../WebCore.framework/Versions/A/Frameworks.
+        Deleted unused create-symlink-to-altroot.sh script.
+
+        * Configurations/ANGLE-dynamic.xcconfig:
+        * scripts/create-symlink-to-altroot.sh: Removed.
+
+2021-12-21  Michael Saboff  <msaboff@apple.com>
+
+        Fix symlinks for alternate root framework locations
+        https://bugs.webkit.org/show_bug.cgi?id=234567
+
+        Reviewed by Filip Pizlo.
+
+        Eliminated the creation of symlinks for ANGLE as it is under WebCore.
+
+        * ANGLE.xcodeproj/project.pbxproj:
+        * Configurations/ANGLE-dynamic.xcconfig:
+
+2021-12-21  Arcady Goldmints-Orlov  <agoldmints@igalia.com>
+
+        [GTK] build fails with undefined symbol in ANGLE if USE_ANGLE_WEBGL is enabled.
+        https://bugs.webkit.org/show_bug.cgi?id=234239
+
+        Reviewed by Kenneth Russell.
+
+        Add a new linux.cmake file that defines angle_dma_buf_sources.
+        This list gets appended it into ANGLE_SOURCES in PlatformGTK.cmake.
+
+        * linux.cmake: Added. Manual translation of src/common/linux/BUILD.gn.
+        * PlatformGTK.cmake:
+
+2021-12-17  Fujii Hironori  <Hironori.Fujii@sony.com>
+
+        [ANGLE] "WARN: driver_utils.cpp:169 (rx::GetVendorString):! Unimplemented: rx::GetVendorString" on WinCairo debug testing bot
+        https://bugs.webkit.org/show_bug.cgi?id=234371
+
+        Reviewed by Kenneth Russell.
+
+        After r286603 updated ANGLE, WinCairo debug testing bot was
+        observing annoying warning message for all WebGL tessts.
+        > WARN: driver_utils.cpp:169 (rx::GetVendorString): 	! Unimplemented: rx::GetVendorString(..\..\Source\ThirdParty\ANGLE\src\libANGLE\renderer\driver_utils.cpp:169)
+
+        The vendor ID was 0x1414 (Microsoft).
+        <https://pcisig.com/membership/member-companies>
+
+        * src/libANGLE/renderer/driver_utils.cpp:
+        (rx::GetVendorString): Added more vendor strings for vendor IDs.
+        * src/libANGLE/renderer/driver_utils.h: Added VENDOR_ID_MICROSOFT.
+
+2021-12-17  Kimmo Kinnunen  <kkinnunen@apple.com>
+
+        REGRESSION (r287068): [macOS arm64] TestWebKitAPI.GraphicsContextGLCocoaTest.UnrecycledDisplayBuffersNoLeaks is failing
+        https://bugs.webkit.org/show_bug.cgi?id=234356
+        <rdar://problem/86533892>
+
+        Reviewed by Antti Koivisto.
+
+        Avoid leaking MTLTexture instances for render targets. Leak would happen through
+        temporary render pass descriptor that would ref the render target texture.
+        The descriptor was created without autoreleasepool in call stack.
+        Also fixes the error string leaks.
+
+        UnrecycledDisplayBuffersNoLeaks would report leaks of iosurface-backed
+        GraphicsContextGL default framebuffer bound textures if glClear was called.
+
+        * src/libANGLE/renderer/metal/ContextMtl.mm:
+        (rx::ContextMtl::getRenderPassCommandEncoder):
+
+2021-12-16  John Cunningham  <johncunningham@apple.com>
+
+        Add support to attribute ownership of ANGLE Metal's resources
+        https://bugs.webkit.org/show_bug.cgi?id=233941
+
+        Reviewed by Kimmo Kinnunen.
+
+        Add SPI to mtl_resource_spi.h to attribute memory to another task.
+
+        * Configurations/ANGLE-dynamic.xcconfig:
+        * Configurations/ANGLE-static.xcconfig:
+        * src/libANGLE/renderer/metal/mtl_resource_spi.h:
+        (rx::mtl::setOwnerWithIdentity):
+
+2021-12-16  Michael Saboff  <msaboff@apple.com>
+
+        https://bugs.webkit.org/show_bug.cgi?id=234173
+        Update Install Paths for build system changes
+
+        Reviewed by Filip Pizlo.
+
+        Added build variables and build step to create symlinks pointing to the alternate
+        build locations from the current framework install location.
+
+        * ANGLE.xcodeproj/project.pbxproj:
+        * Configurations/ANGLE-dynamic.xcconfig:
+        * scripts/create-symlink-to-altroot.sh: Added.
+
+2021-12-15  Dean Jackson  <dino@apple.com>
+
+        [ANGLE] clang with -Wunknown-warning-option will fail on -Wweak-template-vtables
+        https://bugs.webkit.org/show_bug.cgi?id=233837
+        <rdar://problem/86335819>
+
+        Reviewed by Antoine Quint.
+
+        Turn off unknown-warning-option on Apple builds. This shouldn't need to be
+        upstreamed - the Xcode configurations for ANGLE are specific to WebKit.
+
+        * Configurations/Base.xcconfig:
+
+2021-12-15  Chris Lord  <clord@igalia.com>
+
+        [GTK] Use libgbm and the ANGLE gbm backend to fix initialisation
+        https://bugs.webkit.org/show_bug.cgi?id=234293
+
+        Reviewed by Don Olmstead.
+
+        Use GBM backend for GTK platform.
+
+        * CMakeLists.txt:
+        * GL.cmake:
+        * PlatformGTK.cmake:
+
+2021-12-15  Kyle Piddington  <kpiddington@apple.com>
+
+        [ANGLE] Roll ANGLE to 12-14-2021 (5ee7dfbd5a3)
+        https://bugs.webkit.org/show_bug.cgi?id=234317
+
+        Reviewed by Kenneth Russell.
+
+        Roll ANGLE to 12-14-2021 to include new memory-attribution
+        Metal device, merge up fixes, EAC/ ASTC support on M1
+
+        The changelog has been removed to promote readability       
+
+2021-12-13  Alejandro G. Castro  <alex@igalia.com>
+
+        [GTK] Fix ANGLE compilation
+        https://bugs.webkit.org/show_bug.cgi?id=233327
+
+        Reviewed by Kenneth Russell.
+
+        There is a define with a typo in the name and activating EGL and
+        X11 does not work at the same time.
+
+        * PlatformGTK.cmake:
+
+2021-12-13  Kyle Piddington  <kpiddington@apple.com>
+
+        [MacCatalyst] fix iOSMac after refactor in r286899
+        https://bugs.webkit.org/show_bug.cgi?id=234250
+
+        Reviewed by Dean Jackson.
+
+        Also includes a longer term fix for 
+        https://bugs.webkit.org/show_bug.cgi?id=233977
+
+        Tested builds on mac, iOS, TV SDKs, plus iOSMac
+
+        * src/common/platform.h:
+        * src/libANGLE/renderer/metal/gen_mtl_format_table.py:
+        (gen_image_map_switch_string):
+        * src/libANGLE/renderer/metal/mtl_format_table_autogen.mm:
+        (rx::mtl::Format::init):
+
+2021-12-13  Kimmo Kinnunen  <kkinnunen@apple.com>
+
+        REGRESSION(Safari 15, BigSur): Poor video texture upload performance with MacBook M1, ANGLE OpenGL backend 
+        https://bugs.webkit.org/show_bug.cgi?id=232235
+        <rdar://problem/84878815>
+        Reviewed by Dean Jackson.
+
+        Remove validation for IOSurface element size when a IOSurface is bound
+        to a pbuffer. The IOSurfaceGetBytesPerElementOfPlane is not valid for some internal formats
+        that might be compressed.
+
+        Will add a WebKit level test in subsequent fix.
+        Will add an ANGLE level test during upstreaming of the patch.
+
+        Same as "Textures Fail to Render in WebGL from HLS Stream on iPhone 12 [iOS 14.2]"
+        but this time for CGL.
+        https://webkit.org/b/218637  rdar://problem/71102126
+
+        Remove incorrect validation that IOSurface pixel format matches
+        the pixel format of the texture image being specified.
+
+        The "Element" in IOSurface is a block of pixels, while the validation assumed
+        it means one pixel. The validation failed for a compressed format.
+
+        Currently we map non-public YUV formats, to which there is no elequent way
+        of implementing the validation.
+
+
+        * src/libANGLE/renderer/gl/cgl/IOSurfaceSurfaceCGL.cpp:
+        (rx::IOSurfaceSurfaceCGL::validateAttributes):
+
+2021-12-10  Kyle Piddington  <kpiddington@apple.com>
+
+        [ANGLE] ASTC-HDR is unavailable on some platforms
+        https://bugs.webkit.org/show_bug.cgi?id=234164
+
+        Reviewed by Kenneth Russell.
+
+        Update autogenerated format table to avoid using ASTC_HDR on
+        platforms that don't have the enum. 
+
+        * src/libANGLE/renderer/metal/gen_mtl_format_table.py:
+        (gen_image_map_switch_astc_case_iosmac):
+        (gen_image_map_switch_astc_case_tvos):
+        (gen_image_map_switch_astc_case_tvos.gen_format_assign_code):
+        (gen_image_map_switch_string):
+        (gen_image_mtl_to_angle_switch_string):
+        (gen_mtl_format_caps_init_string):
+        (gen_image_map_switch_astc_case): Deleted.
+        (gen_image_map_switch_astc_case.gen_format_assign_code): Deleted.
+        * src/libANGLE/renderer/metal/mtl_format_map.json:
+        * src/libANGLE/renderer/metal/mtl_format_table_autogen.mm:
+        (rx::mtl::Format::MetalToAngleFormatID):
+        (rx::mtl::Format::init):
+        (rx::mtl::FormatTable::initNativeFormatCapsAutogen):
+
+2021-12-10  Michael Saboff  <msaboff@apple.com>
+
+        https://bugs.webkit.org/show_bug.cgi?id=234173
+        Update Install Paths for build system changes
+
+        Reviewed by Yusuke Suzuki.
+
+        Updated install paths for changes in the build system that use a system path prefix.
+
+        * Configurations/ANGLE-dynamic.xcconfig:
+
+2021-12-09  Dean Jackson  <dino@apple.com>
+
+        [ANGLE] Code generation happens on each build and produces SCM diffs
+        https://bugs.webkit.org/show_bug.cgi?id=234025
+
+        Reviewed by Kimmo Kinnunen.
+
+        Temporarily remove the build phase that generates the
+        mtl_default_shaders_src_autogen files because they are producing
+        diffs.
+
+        We either need to generate these manually, or fix the Xcode project
+        to generate them into Derived Sources so they don't appear in our
+        repository.
+
+        * ANGLE.xcodeproj/project.pbxproj:
+
+2021-12-08  Kyle Piddington  <kpiddington@apple.com>
+
+        Update ANGLE changes.diff with new roll.
+        https://bugs.webkit.org/show_bug.cgi?id=233952
+
+        Reviewed by Kenneth Russell.
+
+        * changes.diff:
+
+2021-12-08  Adrian Perez de Castro  <aperez@igalia.com>
+
+        Avoid noisy Wcomment warnings after ANGLE update in r286603
+        https://bugs.webkit.org/show_bug.cgi?id=233964
+        <rdar://problem/86186455>
+
+        Reviewed by Michael Catanzaro.
+
+        * CMakeLists.txt: Pass also -Wno-comment when building with GCC or Clang; arrange to
+        set compiler flags for any of the ANGLE library targets instead of only for libANGLE.
+        * src/compiler/translator/tree_util/IntermTraverse.h: Revert change from 233964 to
+        avoid having differences with the upstream version of the file.
+
+2021-12-07  Myles C. Maxfield  <mmaxfield@apple.com>
+
+        [MacCatalyst] Fix build after r286603
+        https://bugs.webkit.org/show_bug.cgi?id=233977
+
+        Unreviewed.
+
+        Previously, TARGET_OS_IOS and TARGET_OS_MACCATALYST were never on at the same time.
+        Now, they're on at the same time, and ANGLE doesn't expect that. This patch turns
+        off TARGET_OS_IOS when TARGET_OS_MACCATALYST is on, just to get ANGLE to build.
+        The long-term fix is to either update all the sites to use correct macros, or to
+        use the ANGLE_PLATFORM_* defines instead.
+
+        * src/common/platform.h:
+
+2021-12-07  Yusuke Suzuki  <ysuzuki@apple.com>
+
+        Unreviewed, these files are modified after building ANGLE
+        https://bugs.webkit.org/show_bug.cgi?id=220896
+        <rdar://problem/73539682>
+
+        * src/libANGLE/renderer/metal/shaders/mtl_default_shaders_src_autogen.inc:
+        * src/libANGLE/renderer/metal/shaders/mtl_default_shaders_src_autogen.metal:
+
+2021-12-07  Lauro Moura  <lmoura@igalia.com>
+
+        Avoid noisy Wcomment warnings after ANGLE update in r286603
+        https://bugs.webkit.org/show_bug.cgi?id=233964
+
+        Unreviewed warning removal.
+
+        * src/compiler/translator/tree_util/IntermTraverse.h:
+
+2021-12-07  Kyle Piddington  <kpiddington@apple.com>
+        
+        Roll ANGLE to include upstreamed Metal backend
+        https://bugs.webkit.org/show_bug.cgi?id=220896
+        <rdar://problem/73539682>
+
+        Reviewed by Ken Russell and Dean Jackson.
+
+        Update ANGLE to ce854632690e505551414f80d01d864df6118882
+        
+        The changelog has been intentionally deleted to preserve
+        readability
+       
+        The following additional changes were made in the mergeup.
+
+        Update ShaderMtl get debug info to return translated source.
+        
+        Fix crashes in webgl/2.0.y/conformance/extensions/webgl-compressed-texture-s3tc-srgb.html
+        Fix angle-instanced-arrays-out-of-bounds.html
+        Skip additional validation when primitive count in drawArraysInstanced is zero
+
+
+        Fix Clear-Invalidate-Render bug for multisample attachments. 
+        Clearing a multisample texture, and then invalidating the render pass would lead
+        to the next pass not loading the cleared texture.
+
+        Fix exports and includes for egl_autogen.h files.
+
+        Fix webgl/2.0.0/deqp/functional/gles3/fboinvalidate/default.html 
+        Add synchronization when reading pixels back from shared framebuffers
+
+2021-11-30  Kyle Piddington  <kpiddington@apple.com>
+
+        Hardware PCF filtering does not work on iOS 15 when using WebGL2
+        https://bugs.webkit.org/show_bug.cgi?id=232071
+
+	Lower restrictions on sampling D32F formats, and allow filtering
+	of Depth16F on iOS hardware, as it was previously restricted.
+	
+        Reviewed by Kenneth Russell.
+
+        * include/platform/FeaturesMtl.h:
+        * src/libANGLE/renderer/metal/DisplayMtl.h:
+        * src/libANGLE/renderer/metal/DisplayMtl.mm:
+        (rx::DisplayMtl::initializeFeatures):
+        (rx::DisplayMtl::supports32BitFloatFiltering const):
+        (rx::DisplayMtl::supportsDepth24Stencil8PixelFormat const):
+        * src/libANGLE/renderer/metal/TextureMtl.mm:
+        (rx::TextureMtl::ensureSamplerStateCreated):
+        * src/libANGLE/renderer/metal/mtl_format_map.json:
+        * src/libANGLE/renderer/metal/mtl_format_table_autogen.mm:
+        (rx::mtl::FormatTable::initNativeFormatCapsAutogen):
+
+2021-11-17  Dean Jackson  <dino@apple.com>
+
+        ANGLE build failure - sprintf is deprecated
+        https://bugs.webkit.org/show_bug.cgi?id=233279
+
+        Reviewed by Wenson Hsieh.
+
+        Replace sprintf with snprintf.
+
+        * src/compiler/translator/TranslatorMetalDirect/IdGen.cpp:
+        (IdGen::createNewName):
+        * src/compiler/translator/TranslatorMetalDirect/ModifyStruct.cpp:
+        * src/compiler/translator/TranslatorMetalDirect/SymbolEnv.cpp:
+        (SymbolEnv::TemplateName::fullName const):
+
+2021-11-06  David Kilzer  <ddkilzer@apple.com>
+
+        Remove empty directories from from svn.webkit.org repository as of r285357
+        <https://webkit.org/b/232773>
+
+        Unreviewed clean up.
+
+        * src/id: Removed.
+        * src/libANGLE/renderer/metal/shaders/compiled: Removed.
+        * src/tests/perf_tests/restricted_traces: Removed.
+
+2021-11-03  Kyle Piddington  <kpiddington@apple.com>
+
+        REGRESSION (iOS 15): Tab crashes when trying to render Projector stories
+        https://bugs.webkit.org/show_bug.cgi?id=231607
+
+	Rework vertex buffer caching to allow us to reuse parts
+	of converted buffers. This dramatically drops the memory usage 
+	of this tab from 4.5 gb to roughly 1.3gb
+
+        Reviewed by Dean Jackson.
+
+        * src/libANGLE/renderer/metal/BufferMtl.mm:
+        (rx::BufferMtl::getVertexConversionBuffer):
+        * src/libANGLE/renderer/metal/VertexArrayMtl.mm:
+        (rx::VertexArrayMtl::convertVertexBuffer):
+        (rx::VertexArrayMtl::convertVertexBufferCPU):
+        (rx::VertexArrayMtl::convertVertexBufferGPU):
+
+2021-11-01  David Kilzer  <ddkilzer@apple.com>
+
+        [ANGLE] Enable -Wformat=2 warnings
+        <https://webkit.org/b/232358>
+        <rdar://problem/84568935>
+
+        Reviewed by Kimmo Kinnunen.
+
+        * Configurations/Base.xcconfig:
+        (WARNING_CFLAGS):
+        - Add -Wformat=2 switch, which includes -Wformat-nonliteral.
+        * src/common/angleutils.h:
+        (FormatStringIntoVector):
+        - Move below definition of ANGLE_FORMAT_PRINTF() and add macro
+          to the function declaration to fix -Wformat-nonliteral
+          warning.
+        * src/compiler/translator/Common.h:
+        (sh::str):
+        - Make `formatStr` a constexpr to fix -Wformat-nonliteral
+          warning.
+
+2021-10-27  Kimmo Kinnunen  <kkinnunen@apple.com>
+
+        REGRESSION (Safari 15): Poor WebGL performance on https://downloads.scirra.com/labs/particles
+        https://bugs.webkit.org/show_bug.cgi?id=230749
+        <rdar://problem/83576271>
+
+        Reviewed by Kenneth Russell.
+
+        The site would draw indexed per frame with each frame increasing the size of the draw.
+        This would cause index buffer range cache update for each draw.
+        Range computation needs to look inside the index buffer.
+        Mapping the index buffer for read would cause command buffer flush for each computation,
+        since previous frame would have used the index buffer for reading. This would cause
+        performance degradation for the duration where the range cache would need update.
+
+        Since the buffer is read by the draw but not written, the map should be a no-op.
+        Consult the "CPU memory needs synchronizing" flag of the mtl::Resource when
+        mapping. Only synchronize with GPU if the memory needs synchronizing.
+
+        * src/libANGLE/renderer/metal/mtl_resources.mm:
+        (rx::mtl::Buffer::mapWithOpt):
+
+2021-10-25  Kyle Piddington  <kpiddington@apple.com>
+
+        REGRESSION (iOS 15), safari604.1: Could not link the shader program
+        https://bugs.webkit.org/show_bug.cgi?id=231475
+
+        Renaming regex incorrectly substituted an attribute. 
+        Update to require exact attribute match
+
+        Reviewed by Dean Jackson
+
+        * src/libANGLE/renderer/metal/mtl_glslang_mtl_utils.mm:
+        (rx::mtl::updateShaderAttributes):
+
+2021-10-15  Ross Kirsling  <ross.kirsling@sony.com>
+
+        Realize Mac CMake build of WebCore and WebKit
+        https://bugs.webkit.org/show_bug.cgi?id=231749
+
+        Reviewed by Alex Christensen.
+
+        * Compiler.cmake:
+
+2021-10-15  Kyle Piddington  <kpiddington@apple.com>
+
+        REGRESSION (r283667): webgl/2.0.0/deqp/functional/gles3/lifetime.html fails
+        https://bugs.webkit.org/show_bug.cgi?id=231682
+
+        Transform feedback should avoid appending _u for 
+        builtin output variables.
+
+        Reviewed by Kimmo Kinnunen.
+
+        * src/libANGLE/renderer/metal/mtl_glslang_mtl_utils.mm:
+        (rx::mtl::GenerateTransformFeedbackVaryingOutput):
+
+2021-10-14  Kyle Piddington  <kpiddington@apple.com>
+
+        https://tankionline.com/play/ html5 engine not working: crashes. (Metal shader not working)
+        https://bugs.webkit.org/show_bug.cgi?id=231490
+
+        Add argument to RemoveInactiveInterfaceVariables to keep
+        output fragment variables, even if they are
+        Add a new test to  verify that this problem is fixed. 
+
+        Reviewed by Kenneth Russell.
+
+        * src/compiler/translator/TranslatorMetalDirect.cpp:
+        (sh::TranslatorMetalDirect::translateImpl):
+        * src/compiler/translator/TranslatorVulkan.cpp:
+        (sh::TranslatorVulkan::translateImpl):
+        * src/compiler/translator/tree_ops/RemoveInactiveInterfaceVariables.cpp:
+        (sh::RemoveInactiveInterfaceVariables):
+        * src/compiler/translator/tree_ops/RemoveInactiveInterfaceVariables.h:
+
+2021-10-14  Myles C. Maxfield  <mmaxfield@apple.com>
+
+        All the SDKVariant.xcconfig files should match
+        https://bugs.webkit.org/show_bug.cgi?id=231663
+
+        Reviewed by Youenn Fablet.
+
+        * Configurations/SDKVariant.xcconfig:
+
+2021-10-13  Kyle Piddington  <kpiddington@apple.com>
+
+        Upstream ANGLE: PrimitiveRestart tests fail due to incorrect draw commands
+        https://bugs.webkit.org/show_bug.cgi?id=231626
+        <rdar:/problem/84167241>
+   
+        Primitive restart draw commands were being encoded
+        incorrectly. Single element ranges were being disregarded,
+        and a maximum draw size was not being enforced when the
+        index buffer was aliased / reused.
+
+        Cherry-pick from upstream anglebug.com/6535
+    
+        Reviewed by Kenneth Russell.
+
+        * src/libANGLE/renderer/metal/VertexArrayMtl.mm:
+        (rx::VertexArrayMtl::getDrawIndices):
+
+2021-10-12  Alexey Proskuryakov  <ap@apple.com>
+
+        Invoke ThirdParty build scripts with python3 explicitly
+        https://bugs.webkit.org/show_bug.cgi?id=231605
+
+        Reviewed by Dean Jackson.
+
+        * ANGLE.xcodeproj/project.pbxproj:
+        * adjust-angle-include-paths.py:
+        * src/libANGLE/renderer/metal/shaders/create_mtl_internal_shaders.py:
+
+2021-10-06  Kyle Piddington  <kpiddington@apple.com>
+
+        Shadertoy "truchet district" fails to compile with error: Internal error compiling shader with Metal backend"
+        https://bugs.webkit.org/show_bug.cgi?id=229378
+        <rdar://problem/82299053>
+
+        Reviewed by Kenneth Russell.
+
+        Change TranslatorMetalDirect to prefix '_u' to all user defined variables.
+        Clean up builtins like samplers and ANGLE structs that were being
+        accidently promoted to userDefined variables.
+
+        * src/compiler/translator/TranslatorMetalDirect.cpp:
+        (sh::GetMslKeywords):
+        * src/compiler/translator/TranslatorMetalDirect/Name.cpp:
+        (Name::emit const):
+        * src/compiler/translator/TranslatorMetalDirect/SymbolEnv.cpp:
+        (SymbolEnv::getTextureEnv):
+        (SymbolEnv::getSamplerStruct):
+        (sh::GetTextureTypeName):
+        * src/libANGLE/renderer/metal/mtl_glslang_mtl_utils.mm:
+        (rx::mtl::GenerateTransformFeedbackVaryingOutput):
+
+2021-09-28  Alex Christensen  <achristensen@webkit.org>
+
+        Mostly fix Mac CMake build
+        https://bugs.webkit.org/show_bug.cgi?id=230868
+
+        Reviewed by Don Olmstead.
+
+        * Compiler.cmake:
+        * Metal.cmake:
+
+2021-09-23  Kyle Piddington  <kpiddington@apple.com>
+
+        [WebGL2, Safari 15 - iOS15] Problems with drawElements in some conditions
+        https://bugs.webkit.org/show_bug.cgi?id=230107
+
+        Index buffer rewrite was dispatching too many threads. 
+        Reviewed by Dean Jackson.
+
+        * src/libANGLE/renderer/metal/ProvokingVertexHelper.mm:
+        (rx::ProvokingVertexHelper::preconditionIndexBuffer):
+
+2021-09-20  Kimmo Kinnunen  <kkinnunen@apple.com>
+
+        ANGLE Metal: single-component swizzles do not compile
+        https://bugs.webkit.org/show_bug.cgi?id=230472
+        <rdar://problem/83310780>
+
+        Reviewed by Dean Jackson.
+
+        Fix metal compiler compile errors when using 
+        single value swizles (glslvariable.r) in position where lvalues would
+        be needed. Use the variable instead of single element array 
+        (copy-paste typo).
+
+        * src/compiler/translator/TranslatorMetalDirect/ProgramPrelude.cpp:
+
+2021-09-16  Kyle Piddington  <kpiddington@apple.com>
+
+        webgl/2.0.y/conformance/extensions/webgl-compressed-texture-s3tc-srgb.html fails on Intel+AMD Metal
+        https://bugs.webkit.org/show_bug.cgi?id=229941
+
+        Zero-initialize compressed textures explicitly, as they aren't implicitly initalized in Metal.
+        Reviewed by Kenneth Russell <kbr@chromium.org>.
+
+        * src/libANGLE/renderer/metal/mtl_utils.h:
+        * src/libANGLE/renderer/metal/mtl_utils.mm:
+        (rx::mtl::GetCompressedBufferForTextureWithFormat):
+        (rx::mtl::InitializeCompressedTextureContents):
+        (rx::mtl::InitializeTextureContents):
+
+2021-08-31  Kimmo Kinnunen  <kkinnunen@apple.com>
+
+        webgl/1.0.x/conformance/glsl/misc/fragcolor-fragdata-invariant.html fails
+        https://bugs.webkit.org/show_bug.cgi?id=223317
+        <rdar://problem/75772659>
+
+        Reviewed by Kenneth Russell.
+
+        The parser maintains invariance metadata for each input and output
+        with the help of the symbol table, during parsing.
+
+        Use this metadata through the collection phase done by CollectVariables
+        section of shader compilation.
+
+        Remove the manual tree rewrite section that collected the invariance
+        information. The implementation had following problems:
+        1) It would declare the variables present. This would fail the test case
+        fixed here, due to the test case using invariant declarations to both
+        FragColor and FragData, which would cause both to be present as outputs
+        to the MSL.
+        2) It would operate on rewritten variables. For example, FragCoord would
+        be replaced with different variable, causing the invariance be marked
+        based on the rewritten name but the later lookup intended to be done
+        with the original name.
+
+        Remove logic to mark FragCoord as invariant, as MSL specification explicitly
+        says that only the vertex [[position]] output can be marked as [[invariant]].
+        As noted above, this never worked.
+
+        Fix cases where the tree rewriters assume that all variable references are
+        done within functions. The global qualifier declarations are now left
+        in the tree and as such can refer to variables but do not belong to any
+        function.
+
+        Fixes:
+        webgl/1.0.x/conformance/glsl/misc/fragcolor-fragdata-invariant.html
+        webgl/2.0.y/conformance/glsl/misc/fragcolor-fragdata-invariant.html
+
+        * ANGLE.xcodeproj/project.pbxproj:
+        * src/compiler/translator/TranslatorMetalDirect.cpp:
+        (sh::TranslatorMetalDirect::translateImpl):
+        * src/compiler/translator/TranslatorMetalDirect/DiscoverDependentFunctions.cpp:
+        * src/compiler/translator/TranslatorMetalDirect/EmitMetal.cpp:
+        (GenMetalTraverser::GenMetalTraverser):
+        (GenMetalTraverser::emitPostQualifier):
+        (GenMetalTraverser::visitGlobalQualifierDeclaration):
+        (sh::EmitMetal):
+        * src/compiler/translator/TranslatorMetalDirect/EmitMetal.h:
+        * src/compiler/translator/TranslatorMetalDirect/RewriteGlobalQualifierDecls.cpp: Removed.
+        * src/compiler/translator/TranslatorMetalDirect/RewriteGlobalQualifierDecls.h: Removed.
+        * src/compiler/translator/TranslatorMetalDirect/RewritePipelines.cpp:
+        (sh::IsVariableInvariant):
+        (sh::GeneratePipelineStruct::Exec):
+        (sh::GeneratePipelineStruct::GeneratePipelineStruct):
+        (sh::GeneratePipelineStruct::createInternalPipelineStruct):
+        (sh::UpdatePipelineSymbols):
+        (sh::RewritePipeline):
+        (sh::RewritePipelines):
+        * src/compiler/translator/TranslatorMetalDirect/RewritePipelines.h:
+        * src/compiler/translator/TranslatorMetalDirect/SeparateCompoundExpressions.cpp:
+
+2021-08-25  Kimmo Kinnunen  <kkinnunen@apple.com>
+
+        ANGLE Metal index buffer restart range cache is could be maintained more consistently
+        https://bugs.webkit.org/show_bug.cgi?id=227451
+
+        Reviewed by Kenneth Russell.
+
+        * src/libANGLE/renderer/metal/BufferMtl.h:
+        (rx::BufferMtl::RestartRangeCache::RestartRangeCache):
+        Add optional<RestartRangeCache> which contains the ranges and
+        the index type used to build the ranges.
+
+        * src/libANGLE/renderer/metal/BufferMtl.mm:
+        (rx::BufferMtl::markConversionBuffersDirty):
+        (rx::BufferMtl::clearConversionBuffers):
+        Invalidate the range cache when clearing conversion buffers.
+        Otherwise the cache would be left in inconsistent state vs.
+        the contents of the index buffer in cases of code like:
+        BufferMtl::setDataImpl() ...
+           if (...) {
+               markConversionBufferDirty();
+           } else {
+               clearConversionBuffers();
+           }
+        (rx::BufferMtl::getRestartIndices):
+
+2021-08-24  Kimmo Kinnunen  <kkinnunen@apple.com>
+
+        ANGLE Metal infinities and NaNs generated with incorrect syntax
+        https://bugs.webkit.org/show_bug.cgi?id=229439
+        <rdar://81033366>
+
+        Reviewed by Dean Jackson.
+
+        Generate NaN and infinity constant values correctly.
+        An else was missing from if-block, causing double processing.
+
+        * src/compiler/translator/TranslatorMetalDirect/EmitMetal.cpp:
+        (GenMetalTraverser::emitSingleConstant):
+        * src/libANGLE/renderer/metal/mtl_utils.mm:
+        (rx::mtl::CreateShaderLibrary):
+
+2021-08-17  David Kilzer  <ddkilzer@apple.com>
+
+        [Metal ANGLE] Fix over-autorelease of rx::DisplayMtl::getMetalDeviceMatchingAttribute() and various Objective-C leaks
+        <https://webkit.org/b/229128>
+        <rdar://problem/81964007>
+
+        Reviewed by Alex Christensen.
+
+        * src/libANGLE/renderer/metal/DisplayMtl.h:
+        (rx::DisplayMtl::getMetalDeviceMatchingAttribute):
+        - Change to return mtl::AutoObjCPtr<> to make ownership clear.
+        (rx::DisplayMtl::mMetalDevice):
+        - No need to initialize to nil.
+
+        * src/libANGLE/renderer/metal/DisplayMtl.mm:
+        (rx::DisplayMtl::initializeImpl):
+        - Update for changes to getMetalDeviceMatchingAttribute().
+        (rx::DisplayMtl::getMetalDeviceMatchingAttribute):
+        - Change to return mtl::AutoObjCPtr<> to make ownership clear.
+        - Fix leak of `deviceList`, `externalGPUs`, `integratedGPUs`, and
+          `discreteGPUs`.
+        - Use mtl::adoptObjCObj<>() to prevent leak of
+          MTLCreateSystemDefaultDevice().
+
+        * src/libANGLE/renderer/metal/IOSurfaceSurfaceMtl.mm:
+        - Fix leak of `captureDescriptor` in two different if blocks.
+
+        * src/libANGLE/renderer/metal/ProgramMtl.mm:
+        - Fix leak of `funcConstants` in early return on error path.
+
+        * src/libANGLE/renderer/metal/ProvokingVertexHelper.mm:
+        (rx::ProvokingVertexHelper::getSpecializedShader):
+        - Fix leak of `fcValues`.
+
+        * src/libANGLE/renderer/metal/SurfaceMtl.mm:
+        - Fix leak of `captureDescriptor` in two different if blocks.
+
+        * src/libANGLE/renderer/metal/mtl_common.h:
+        (rx::mtl::WrappedObject::retainAssign):
+        - Move statement inside #if/#endif that isn't needed for ARC.
+        (rx::mtl::WrappedObject::unretainAssign): Add.
+        (rx::mtl::AutoObjCPtr::AutoObjCPtr): Add.
+        (rx::mtl::adoptObjCObj): Add.
+        - Add a helper method to adopt an Objective-C object to
+          eliminate the need to autorelease a +1 retained object before
+          an mtl::AutoObjCPtr<> object wraps it.  Modeled after
+          WTF::RetainPtr<> in WebKit.
+
+        * src/libANGLE/renderer/metal/mtl_state_cache.mm:
+        (rx::mtl::RenderPipelineCache::createRenderPipelineState):
+        (rx::mtl::ProvokingVertexComputePipelineCache::createComputePipelineState):
+        - Use adoptObjCObj<>() to fix potential leak on the early return
+          path since these methods return an mtl::AutoObjCPtr<>.
+
+2021-08-16  David Kilzer  <ddkilzer@apple.com>
+
+        "make analyze" should run clang static analyzer in deep mode
+        <https://webkit.org/b/229127>
+        <rdar://problem/81960587>
+
+        Reviewed by Alexey Proskuryakov.
+
+        * ANGLE.xcodeproj/project.pbxproj:
+        - Treat "analyze" the same as "build" for "ACTION" environment
+          variable.
+
+2021-08-12  Kimmo Kinnunen  <kkinnunen@apple.com>
+
+        ANGLE Cocoa compiles contents of ContextEAGL on mac
+        https://bugs.webkit.org/show_bug.cgi?id=228987
+
+        Reviewed by Kenneth Russell.
+
+        Add include guards that are consistent with other EAGL files.
+
+        * src/libANGLE/renderer/gl/eagl/ContextEAGL.cpp:
+
+2021-08-12  Kimmo Kinnunen  <kkinnunen@apple.com>
+
+        ANGLE Cocoa compiles parts of HLSL translator, vulkan translator, libgl api, capture redundantly
+        https://bugs.webkit.org/show_bug.cgi?id=228986
+
+        Reviewed by Kenneth Russell.
+
+        Remove following from ANGLE (dynamic) target:
+        - HLSL translator and tree ops used only by it
+        - Vulkan translator output
+        - libgl API validation implementation
+        - API trace capture implementation (was only partially compiled)
+
+        The features are not part of Cocoa use of ANGLE, and should
+        not be compiled as such.
+        Does not affect the binary size more than few kilobytes.
+
+        * ANGLE.xcodeproj/project.pbxproj:
+        * Configurations/ANGLE-dynamic.xcconfig:
+
+2021-08-11  Kyle Piddington  <kpiddington@apple.com>
+
+        Avoid infinite recursion when command buffer creation fails
+        https://bugs.webkit.org/show_bug.cgi?id=228978
+        <rdar://79224824>
+ 
+        Reviewed by Kenneth Russell.
+ 
+        In cases where the MTLCommandBuffer is not a valid metal object,
+        we can end up in an infinite recursive loop during draw call setup. Refactor setupDraw to take no more than two attempts through the setup function. 
+
+        Testing: Ran WebGL tests, use case samples. Set up synthetic 
+        repro forcing bail out path, saw WebGL content fail to render 
+        instead of a web process crash.
+
+        * src/libANGLE/renderer/metal/ContextMtl.h:
+        * src/libANGLE/renderer/metal/ContextMtl.mm:
+        (rx::ContextMtl::setupDraw):
+        (rx::ContextMtl::setupDrawImpl):
+
+2021-08-11  Kimmo Kinnunen  <kkinnunen@apple.com>
+
+        Cherry-pick ANGLE: Revise WebGL's shaderSource validation
+        https://bugs.webkit.org/show_bug.cgi?id=228951
+
+        Reviewed by Kenneth Russell.
+
+        Cherry-pick ANGLE commit: b4fd46288aa65d61dc9c7140c7d1cdba3f4cdf9a
+        From: Kenneth Russell <kbr@chromium.org>
+        Date: Wed, 27 Jan 2021 15:56:58 -0800
+        Revise WebGL's shaderSource validation.
+
+        Per discussion in the WebGL working group, shaderSource no longer
+        generates INVALID_VALUE for sources containing characters outside the
+        ESSL character set. Compilation and/or linking is still specified to
+        fail when illegal constructs are used.
+
+        With this change, https://github.com/KhronosGroup/WebGL/pull/3206
+        passes with the passthrough command decoder.
+
+        Revise WebGL compatibility tests to follow the new rules.
+
+        * src/libANGLE/validationES2.cpp:
+        (gl::ValidateShaderSource):
+        * src/tests/gl_tests/WebGLCompatibilityTest.cpp:
+
+2021-07-23  Dean Jackson  <dino@apple.com>
+
+        3.5 MB system-wide footprint impact due to thread-locals in libANGLE
+        https://bugs.webkit.org/show_bug.cgi?id=228240
+        rdar://79504783
+
+        Reviewed by Ken Russell and Geoff Garen.
+
+        Apple's dyld has a bug where thread_local variables are dirtied on
+        process launch, causing a memory regression. Work around this
+        temporarily in ANGLE by using pthread thread local storage.
+
+        I don't expect this to be upstreamed to ANGLE unless they
+        want it. If it isn't, this patch will have to be applied until
+        the dyld bug is fixed.
+
+        * src/libANGLE/Context.cpp: Implement some methods to get/set what was
+        the global variable gCurrentValidContext.
+        (gl::GetCurrentValidContextTLSIndex):
+        (gl::GetCurrentValidContextTLS):
+        (gl::SetCurrentValidContextTLS):
+        (gl::Context::setContextLost):
+        * src/libANGLE/Context.h:
+        * src/libGLESv2/global_state.cpp: Ditto, but for gCurrentThread.
+        (egl::GetCurrentThreadTLSIndex):
+        (egl::GetCurrentThreadTLS):
+        (egl::SetCurrentThreadTLS):
+        (egl::GetCurrentThread):
+        (egl::SetContextCurrent):
+        * src/libGLESv2/global_state.h:
+        (gl::GetGlobalContext):
+        (gl::GetValidGlobalContext):
+
+2021-07-16  Kyle Piddington  <kpiddington@apple.com>
+
+        Build Default Metal library offline
+        https://bugs.webkit.org/show_bug.cgi?id=227333
+
+        <rdar://79923371>
+
+        This patch compiles and creates a Metal library at build time, storing
+        the library as a compiled binary file. This library is baked into the dylib,
+        and is loaded at context creation time.
+
+        Unlike the previous version of this patch, this patch does not save or store the .metallib on disk, but rather
+        bakes it into a binary.
+
+        Fixed internal build breaks by skipping Metallib bake script.
+
+        Reviewed by Kenneth Russell.
+
+        * ANGLE.xcodeproj/project.pbxproj:
+        * Configurations/ANGLE-dynamic.xcconfig:
+        * src/libANGLE/renderer/metal/DisplayMtl.mm:
+        (rx::DisplayMtl::initializeShaderLibrary):
+        * src/libANGLE/renderer/metal/mtl_utils.h:
+
+2021-07-16  Truitt Savell  <tsavell@apple.com>
+
+        Unreviewed, reverting r279980.
+
+        Broke Internal Builds
+
+        Reverted changeset:
+
+        "Build Default Metal library offline"
+        https://bugs.webkit.org/show_bug.cgi?id=227333
+        https://commits.webkit.org/r279980
+
+2021-07-16  Kyle Piddington  <kpiddington@apple.com>
+
+        Build Default Metal library offline
+        https://bugs.webkit.org/show_bug.cgi?id=227333
+
+        <rdar://79923371>
+
+        This patch compiles and creates a Metal library at build time, storing
+        the library as a compiled binary file. This library is baked into the dylib, 
+        and is loaded at context creation time.
+
+        Unlike the previous version of this patch, this patch does not save or store the .metallib on disk, but rather
+        bakes it into a binary.
+        
+        Reviewed by Kenneth Russell.
+
+        * ANGLE.xcodeproj/project.pbxproj:
+        * Configurations/ANGLE-dynamic.xcconfig:
+        * src/libANGLE/renderer/metal/DisplayMtl.mm:
+        (rx::DisplayMtl::initializeShaderLibrary):
+        * src/libANGLE/renderer/metal/mtl_utils.h:
+
+2021-07-15  Kyle Piddington  <kpiddington@apple.com>
+
+        WebGL2 demo doesn't work due to failing compilation to metal backend
+        https://bugs.webkit.org/show_bug.cgi?id=226865
+	
+        Fix translation of struct-arrays to contain the array type as well.
+        Reviewed by Dean Jackson.
+
+        * src/compiler/translator/TranslatorMetalDirect/SeparateCompoundStructDeclarations.cpp:
+
+2021-07-13  Kyle Piddington  <kpiddington@apple.com>
+
+        rAF driven WebGL submits excessive amount of GPU work when frames are slow
+        https://bugs.webkit.org/show_bug.cgi?id=227059
+
+        Reviewed by Dean Jackson.
+
+        Advertise GL_ARB_sync for the Metal backend.
+    Since GL_ARB_sync is core in OpenGL ES 3.0 and the Metal backend advertises OpenGL ES 3.0,
+    the API must be working already.
+
+        Limit in-flight WebGL frames to three frames. Do not continue preparation for display
+    until the commands for the oldest frame have been executed by the GPU.
+
+        This limits the impact slow frames have, especially in the
+    case where the compositor skip frames and WebKit would issue a new slow frame
+    on top of the skipped frame.
+
+	An additional change ensures that Nvidia configs, which do not support MTLEvents
+	to a level of conformance required (See http://crbug.com/1136673), continue to run. The more powerful eGPUs will not experience throttling to the same level as integrated GPUS.
+        * src/libANGLE/renderer/metal/DisplayMtl.mm:
+        (rx::DisplayMtl::initializeExtensions const):
+
+2021-07-07  Kyle Piddington  <kpiddington@apple.com>
+
+        WebGL shader link error in iOS 15 beta: "Internal error compiling shader with Metal backend"
+        https://bugs.webkit.org/show_bug.cgi?id=227723
+
+        The sequence operator can be used to combine statements. Our initial
+        logic did not account for this. 
+        Reviewed by Dean Jackson.
+
+        * src/compiler/translator/TranslatorMetalDirect/SeparateCompoundExpressions.cpp:
+        (sh::Separator::isStandaloneExpr):
+
+2021-07-06  Kyle Piddington  <kpiddington@apple.com>
+
+        REGRESSION (r279466):  [Big Sur] webgl/1.0.3/conformance & webgl/2.0.0/conformance are failing
+        https://bugs.webkit.org/show_bug.cgi?id=227596
+        Provide Intel workaround for Big Sur systems. Atan and invariant have 
+        issues on older systems, and require us to disable fastmath to produce correct results. 
+
+        Reviewed by Kenneth Russell.
+
+        * include/platform/FeaturesMtl.h:
+        * src/compiler/translator/TranslatorMetalDirect.h:
+        (sh::TranslatorMetalReflection::reset):
+        * src/compiler/translator/TranslatorMetalDirect/EmitMetal.cpp:
+        (GenMetalTraverser::emitPostQualifier):
+        (GenMetalTraverser::visitUnary):
+        (GenMetalTraverser::visitAggregate):
+        * src/libANGLE/renderer/metal/DisplayMtl.mm:
+        (rx::DisplayMtl::initializeFeatures):
+        * src/libANGLE/renderer/metal/ProgramMtl.h:
+        (rx::ProgramMtl::getTranslatedShaderInfo const):
+        * src/libANGLE/renderer/metal/ProgramMtl.mm:
+        * src/libANGLE/renderer/metal/mtl_glslang_mtl_utils.h:
+        * src/libANGLE/renderer/metal/mtl_glslang_mtl_utils.mm:
+        (rx::mtl::GlslangGetMSL):
+        * src/libANGLE/renderer/metal/mtl_render_utils.h:
+        * src/libANGLE/renderer/metal/mtl_render_utils.mm:
+        (rx::mtl::TransformFeedbackUtils::createMslXfbLibrary):
+        (rx::mtl::TransformFeedbackUtils::getTransformFeedbackRenderPipeline):
+        * src/libANGLE/renderer/metal/mtl_utils.h:
+        * src/libANGLE/renderer/metal/mtl_utils.mm:
+        (rx::mtl::CreateShaderLibrary):
+
+2021-07-01  Ben Nham  <nham@apple.com>
+
+        Unreviewed, reverting r279172.
+
+        Broke WebGL context construction on some devices.
+
+        Reverted changeset:
+
+        "rAF driven WebGL submits excessive amount of GPU work when frames are slow"
+        https://bugs.webkit.org/show_bug.cgi?id=227059
+        https://commits.webkit.org/r279172
+
+2021-07-01  Kyle Piddington  <kpiddington@apple.com>
+
+        BabylonJS Under water demo is slower than it should be on Intel
+        https://bugs.webkit.org/show_bug.cgi?id=227226
+
+        Remove fastMath restriction on Intel
+        Removing fastmath in all scenarios leads to unacceptable performance on integrated graphics
+        Currently, webgl conformance tests and the Safari tests don't have any invariance tests that show invariance issues. deQP tests are similarly passing.
+        In Metal-ANGLE, gl_position and gl_fragcoord are valid attributes to be marked as invariant. All others will be ignored.
+
+        Reviewed by Kenneth Russell.
+
+        * src/compiler/translator/TranslatorMetalDirect/EmitMetal.cpp:
+        (GenMetalTraverser::emitPostQualifier):
+        * src/libANGLE/renderer/metal/mtl_utils.mm:
+        (rx::mtl::CreateShaderLibrary):
+
+2021-06-30  Kimmo Kinnunen  <kkinnunen@apple.com>
+
+        ASSERT in  webgl/1.0.x/conformance/glsl/misc/uninitialized-local-global-variables.html   IdGen ASSERT(*base != '_');
+        https://bugs.webkit.org/show_bug.cgi?id=227482
+
+        Reviewed by Kenneth Russell.
+
+        Give unnamed structs normal "_<number>" name.
+        The original code thought it gave "ANGLE__unnamed<number>", but in reality it
+        gave "__unnamed<number>".
+        Since other constructs already create names of form "_<number>", it is unwarranted to
+        special case this particular case to give "_unnamed<number>" or "ANGLE_unnamed<number" or
+        "ANGLE_<number>".
+
+        * src/compiler/translator/TranslatorMetalDirect/SeparateCompoundStructDeclarations.cpp:
+        * src/tests/compiler_tests/MSLOutput_test.cpp:
+        (TEST_F):
+
+2021-06-29  Kimmo Kinnunen  <kkinnunen@apple.com>
+
+        ANGLE Metal primitive restart range computation could index with size_t
+        https://bugs.webkit.org/show_bug.cgi?id=227449
+
+        Reviewed by Kenneth Russell.
+
+        Make the `calculateRestartRanges()` a bit simpler in order
+        for it to be easier to understand.
+
+        * src/libANGLE/renderer/metal/BufferMtl.h:
+        (rx::IndexRange::IndexRange):
+        Add documentation what the mtl::IndexRange is.
+        Add constructor so that `std::vector::emplace_back()` works.
+
+        * src/libANGLE/renderer/metal/BufferMtl.mm:
+        (rx::calculateRestartRanges):
+        Index with size_t to make it simpler to understand if the index
+        overflows or not.
+        Use reinterpret_cast in order to not accidentally cast away
+        const from `mtl::BufferRef::mapReadOnly()`.
+        Skip the non-marker elements with `continue` to avoid deep nesting.
+        Give a name to the restart range marker value.
+        Remove intermediate variable `value = bufferData[i]` as it is never
+        used more than once. This simplifies the code as the do-while loop
+        does not need to check the if condition as the loop ending condition
+        already checks.
+        Make the array a returned result instead of out variable.
+
+        (rx::BufferMtl::getRestartIndices):
+
+2021-06-29  Kimmo Kinnunen  <kkinnunen@apple.com>
+
+        ANGLE Metal primitive restart range computation should not be done unless primitive restart is enabled
+        https://bugs.webkit.org/show_bug.cgi?id=227452
+
+        Reviewed by Kenneth Russell.
+
+        Primitive restart needs to scan the whole index buffer for values.
+        This should not be done unless needed.
+
+        * src/libANGLE/renderer/metal/VertexArrayMtl.mm:
+        (rx::VertexArrayMtl::getDrawIndices):
+        First check for primitive restart enabledness.
+        Compute the primitive restart values after this.
+        The algoritm should succeed when the count of primitive
+        restart ranges is zero, and it does not do much of work.
+        Use the restart range vector as reference, so that no copy
+        would be done.
+        Add spaces the if statements, comments and references.
+        Move the else arm of the if statement with return statement
+        to body of the function to reduce nesting.
+
+2021-06-28  Kimmo Kinnunen  <kkinnunen@apple.com>
+
+        iPhone 6S - iOS 15.0 - unable to retrieve WebGL2 context
+        https://bugs.webkit.org/show_bug.cgi?id=226975
+        rdar://78966563
+
+        Reviewed by Kenneth Russell.
+
+        Limit the OpenGL ES 3.0 contexts to iOS GPU Family 3, not
+        4.
+
+        The limit was most likely added to guard sample_compare
+        lod_options properties .lod and .gradient. However, these
+        are always supported on iOS.
+
+        Currently there is already ES 3.0 features implemented
+        in ANGLE that are guarded by iOS GPU Family 3.
+
+        Fixes WebGL 2.0 to work on iPhone6s and similar
+        devices  (A9, A9X).
+
+        * src/libANGLE/renderer/metal/DisplayMtl.mm:
+        (rx::DisplayMtl::getMaxSupportedESVersion const):
+
+2021-06-28  Kimmo Kinnunen  <kkinnunen@apple.com>
+
+        ANGLE Metal index buffer left mapped when building primitive restart ranges
+        https://bugs.webkit.org/show_bug.cgi?id=227371
+
+        Reviewed by Kenneth Russell.
+
+        * src/libANGLE/renderer/metal/BufferMtl.mm:
+        (rx::calculateRestartRanges):
+        Add unmap.
+
+2021-06-25  Myles C. Maxfield  <mmaxfield@apple.com>
+
+        [macOS] WebGL content is unable to use the discrete GPU
+        https://bugs.webkit.org/show_bug.cgi?id=227408
+        <rdar://problem/79216506>
+
+        Reviewed by Dean Jackson.
+
+        There appears to be a key collision:
+
+        Source/ThirdParty/ANGLE/include/platform/PlatformMethods.h:#define EGL_PLATFORM_ANGLE_PLATFORM_METHODS_ANGLEX 0x3482
+        Source/ThirdParty/ANGLE/include/EGL/eglext_angle.h:#define EGL_POWER_PREFERENCE_ANGLE 0x3482
+
+        Both these keys seem to be accepted by EGL_GetPlatformDisplayEXT().
+
+        This patch just changes the value of one of them to a value I picked out of a hat, just so they don't conflict.
+        We should work with upstream to either:
+        A) Find a better solution (maybe disambiguate these values based on which function is accepting them), or
+        B) Make a robust way to make sure keys don't collide in the future.
+
+        * include/platform/PlatformMethods.h:
+
+2021-06-24  John Cunningham  <johncunningham@apple.com>
+
+        [ANGLE Metal] - Set barriers on transform feedback buffers only up to the in use buffer count
+        https://bugs.webkit.org/show_bug.cgi?id=227272
+        <rdar://79587861>
+
+        Reviewed by Dean Jackson.
+
+        * src/libANGLE/renderer/metal/ContextMtl.mm:
+        (rx::ContextMtl::onEndTransformFeedback):
+
+2021-06-23  Kyle Piddington  <kpiddington@apple.com>
+
+        Fix incorrect indexing / out of bounds access in getRestartIndices
+        https://bugs.webkit.org/show_bug.cgi?id=227274
+        <rdar://79244789>
+
+        In the case where a restart index is present in the last element of an index array, we can accidently
+        access out of bounds. Fix this by checking boundaries, and fixing other indexing errors
+
+        Tests: Ran deqp/functional/gles3/primitiverestart suite. Passed 8 tests.
+
+        Reviewed by Dean Jackson.
+
+        * src/libANGLE/renderer/metal/BufferMtl.mm:
+        (rx::calculateRestartRanges):
+
+2021-06-23  Kyle Piddington  <kpiddington@apple.com>
+
+        Guard against compile failures of the default libraries
+        https://bugs.webkit.org/show_bug.cgi?id=227239
+        <rdar://79037623>
+
+        Under certain events (High memory usage), the MTLCompilerService can fail when creating the default library.
+        Guard against nil pipelines by failing GL calls instead, if this happens. While this can create rendering artifacts
+        due to missing blits / conversions, this can at least avoid crashing the process.
+
+        Reviewed by Dean Jackson.
+
+        * src/libANGLE/renderer/metal/mtl_render_utils.h:
+        * src/libANGLE/renderer/metal/mtl_render_utils.mm:
+        (rx::mtl::ClearUtils::setupClearWithDraw):
+        (rx::mtl::ClearUtils::clearWithDraw):
+        (rx::mtl::ColorBlitUtils::setupColorBlitWithDraw):
+        (rx::mtl::ColorBlitUtils::blitColorWithDraw):
+        (rx::mtl::DepthStencilBlitUtils::setupDepthStencilBlitWithDraw):
+        (rx::mtl::DepthStencilBlitUtils::blitDepthStencilWithDraw):
+        (rx::mtl::VertexFormatConversionUtils::setupCommonConvertVertexFormatToFloat):
+        (rx::mtl::VertexFormatConversionUtils::expandVertexFormatComponentsVS):
+        (rx::mtl::VertexFormatConversionUtils::setupCommonExpandVertexFormatComponents):
+
+2021-06-23  Kimmo Kinnunen  <kkinnunen@apple.com>
+
+        rAF driven WebGL submits excessive amount of GPU work when frames are slow
+        https://bugs.webkit.org/show_bug.cgi?id=227059
+        <rdar://problem/79385858>
+
+        Reviewed by Kenneth Russell.
+
+        Advertise GL_ARB_sync for the Metal backend.
+        Since GL_ARB_sync is core in OpenGL ES 3.0 and the Metal backend advertises OpenGL ES 3.0,
+        the API must be working already.
+
+        * src/libANGLE/renderer/metal/DisplayMtl.mm:
+        (rx::DisplayMtl::initializeExtensions const):
+
+2021-06-22  Dean Jackson  <dino@apple.com>
+
+        [ANGLE] Support importing external MTLTextures
+        https://bugs.webkit.org/show_bug.cgi?id=226690
+
+        Reviewed by Tim Horton.
+
+        Support MTLTextures as GL textures.
+        Merge https://chromium-review.googlesource.com/c/angle/angle/+/2820178
+
+        * ANGLE.xcodeproj/project.pbxproj:
+        * extensions/EGL_ANGLE_metal_texture_client_buffer.txt: Added.
+        * include/EGL/eglext_angle.h:
+        * src/common/utilities.cpp:
+        (egl::IsExternalImageTarget):
+        * src/libANGLE/Caps.cpp:
+        (egl::DisplayExtensions::getStrings const):
+        * src/libANGLE/Caps.h:
+        * src/libANGLE/renderer/metal/BUILD.gn:
+        * src/libANGLE/renderer/metal/DisplayMtl.h:
+        * src/libANGLE/renderer/metal/DisplayMtl.mm:
+        (rx::DisplayMtl::createImage):
+        (rx::DisplayMtl::createExternalImageSibling):
+        (rx::DisplayMtl::generateExtensions const):
+        (rx::DisplayMtl::validateImageClientBuffer const):
+        (rx::DisplayMtl::initializeExtensions const):
+        * src/libANGLE/renderer/metal/ImageMtl.h: Added.
+        (rx::TextureImageSiblingMtl::getTexture const):
+        (rx::TextureImageSiblingMtl::getFormatMtl const):
+        (rx::ImageMtl::getTexture const):
+        (rx::ImageMtl::getImageTextureType const):
+        (rx::ImageMtl::getImageLevel const):
+        (rx::ImageMtl::getImageLayer const):
+        * src/libANGLE/renderer/metal/ImageMtl.mm: Added.
+        (rx::TextureImageSiblingMtl::TextureImageSiblingMtl):
+        (rx::TextureImageSiblingMtl::~TextureImageSiblingMtl):
+        (rx::TextureImageSiblingMtl::ValidateClientBuffer):
+        (rx::TextureImageSiblingMtl::initialize):
+        (rx::TextureImageSiblingMtl::initImpl):
+        (rx::TextureImageSiblingMtl::onDestroy):
+        (rx::TextureImageSiblingMtl::getFormat const):
+        (rx::TextureImageSiblingMtl::isRenderable const):
+        (rx::TextureImageSiblingMtl::isTexturable const):
+        (rx::TextureImageSiblingMtl::getSize const):
+        (rx::TextureImageSiblingMtl::getSamples const):
+        (rx::ImageMtl::ImageMtl):
+        (rx::ImageMtl::~ImageMtl):
+        (rx::ImageMtl::onDestroy):
+        (rx::ImageMtl::initialize):
+        (rx::ImageMtl::orphan):
+        * src/libANGLE/renderer/metal/RenderBufferMtl.mm:
+        (rx::RenderbufferMtl::setStorageEGLImageTarget):
+        * src/libANGLE/renderer/metal/TextureMtl.mm:
+        (rx::TextureMtl::setEGLImageTarget):
+        * src/libANGLE/renderer/metal/gen_mtl_format_table.py:
+        (gen_image_map_switch_mac_case.gen_format_assign_code):
+        (gen_image_mtl_to_angle_switch_string):
+        (main):
+        * src/libANGLE/renderer/metal/mtl_common.h:
+        * src/libANGLE/renderer/metal/mtl_format_table_autogen.mm:
+        (rx::mtl::Format::MetalToAngleFormatID):
+        * src/libANGLE/renderer/metal/mtl_format_utils.h:
+        * src/libANGLE/validationEGL.cpp:
+        (egl::ValidateCreateImage):
+        * src/tests/BUILD.gn:
+        * src/tests/gl_tests/ImageTest.cpp:
+        (angle::TEST_P):
+        * src/tests/gl_tests/ImageTestMetal.mm: Added.
+        (angle::ScopeMetalTextureRef::ScopeMetalTextureRef):
+        (angle::ScopeMetalTextureRef::~ScopeMetalTextureRef):
+        (angle::ScopeMetalTextureRef::get const):
+        (angle::ScopeMetalTextureRef::operator id<MTLTexture> const):
+        (angle::ScopeMetalTextureRef::operator=):
+        (angle::ScopeMetalTextureRef::release):
+        (angle::CreateMetalTexture2D):
+        (angle::ImageTestMetal::ImageTestMetal):
+        (angle::ImageTestMetal::getMtlDevice):
+        (angle::ImageTestMetal::createMtlTexture2D):
+        (angle::ImageTestMetal::verifyResultsTexture):
+        (angle::ImageTestMetal::verifyResults2D):
+        (angle::ImageTestMetal::reinterpretHelper):
+        (angle::ImageTestMetal::hasImageNativeMetalTextureExt const):
+        (angle::ImageTestMetal::hasOESExt const):
+        (angle::ImageTestMetal::hasBaseExt const):
+        (angle::ImageTestMetal::sourceMetalTarget2D_helper):
+        (angle::TEST_P):
+
+2021-06-17  Kyle Piddington  <kpiddington@apple.com>
+
+        [Metal ANGLE] Shaders with reserved metal keywords do not translate, nor do shaders with struct and variable names that are the same except prefixed by an underscore
+        https://bugs.webkit.org/show_bug.cgi?id=226660
+
+        Fix keyword translation problem by correcting symbol space. This avoids renaming structs unnecessarily 
+
+        Reviewed by Dean Jackson.
+
+        * src/compiler/translator/TranslatorMetalDirect/RewriteKeywords.cpp:
+        (sh::Rewriter::createRenamed):
+
+2021-06-16  Kimmo Kinnunen  <kkinnunen@apple.com>
+
+        ANGLE Metal gl sync objects do not work in case of listener being needed
+        https://bugs.webkit.org/show_bug.cgi?id=227024
+
+        Reviewed by Per Arne Vollan.
+
+        Add an assert to notice when MTLSharedEventListener instantiation
+        fails. Without this, the fence implementation would not signal
+        the completion until the timeout would pass.
+
+        * src/libANGLE/renderer/metal/DisplayMtl.mm:
+        (rx::DisplayMtl::getOrCreateSharedEventListener):
+
+2021-06-16  Kimmo Kinnunen  <kkinnunen@apple.com>
+
+        ANGLE Metal AutoObjCPtr == nullptr comparison is inverted
+        https://bugs.webkit.org/show_bug.cgi?id=227026
+
+        Reviewed by Anders Carlsson.
+
+        Make it more correct and add != nullptr variant for
+        consistency.
+
+        Use std::nullptr_t instead of const std::nullptr_t &
+        in all functions for consistency.
+
+        * src/libANGLE/renderer/metal/mtl_common.h:
+        (rx::mtl::AutoObjCPtr::operator== const):
+        (rx::mtl::AutoObjCPtr::operator!= const):
+
+2021-06-15  Kyle Piddington  <kpiddington@apple.com>
+
+        Tensorflow.js Broken in Safari 15
+        https://bugs.webkit.org/show_bug.cgi?id=226953
+
+        Tensorflow shaders use a 'NAN' uniform. This is a reserved keyword
+        in metal. Add NAN to the reserved list.
+
+        'inf' constants need to be replaced with INFINITY, much like nan constants need to be replaced with NAN
+        Reviewed by Kenneth Russell.
+
+        * src/compiler/translator/TranslatorMetalDirect.cpp:
+        (sh::GetMslKeywords):
+
+2021-06-15  Alex Christensen  <achristensen@webkit.org>
+
+        Fix typo in r276318
+        https://bugs.webkit.org/show_bug.cgi?id=227041
+        <rdar://76284889>
+
+        Reviewed by Chris Dumez.
+
+        @ uses the string @(DYLIB_INSTALL_NAME_BASE)
+        $ uses the value of the environment variable.
+        This turns out to be an important difference.
+
+        * Configurations/ANGLE-dynamic.xcconfig:
+
+2021-06-11  Eleni Maria Stea  <estea@igalia.com>
+
+        ANGLE EGL and GLES libraries should link with lib dl.
+        https://bugs.webkit.org/show_bug.cgi?id=226920
+
+        Reviewed by Kenneth Russell.
+
+        GLES and EGL that are generated from ANGLE should link
+        with libdl because they use dlsym and dlopen. Also,
+        with the updated CMakeLists.txt we can safely link with libEGL
+        when USE_ANGLE_WEBGL is set because the symbols of EGL are now
+        found.
+
+        * CMakeLists.txt:
+
+2021-06-10  Don Olmstead  <don.olmstead@sony.com>
+
+        [CMake] Make ANGLE library types configurable
+        https://bugs.webkit.org/show_bug.cgi?id=226840
+
+        Reviewed by Kenneth Russell.
+
+        The type for ANGLE's libraries was being hard coded. Now the libraries can be set by
+        specifying the _LIBRARY_TYPE which defaults to STATIC. Windows platforms override this
+        and use SHARED libraries.
+
+        Additionally make compiling ANGLE's EGL library contingent on USE_ANGLE_EGL being enabled
+        since its not used otherwise.
+
+        * CMakeLists.txt:
+        * PlatformFTW.cmake:
+        * PlatformWin.cmake:
+
+2021-06-02  Kyle Piddington  <kpiddington@apple.com>
+
+        Add 'mix' override with bool-vectors to MSL translator
+        https://bugs.webkit.org/show_bug.cgi?id=226366
+
+        Reviewed by Dean Jackson.
+
+        Add in 'mix' overrides, and logic for selecting mix with bool when necessary.
+
+        * src/compiler/translator/TranslatorMetalDirect/EmitMetal.cpp:
+        (GetOperatorString):
+        (GenMetalTraverser::visitAggregate):
+        * src/compiler/translator/TranslatorMetalDirect/ProgramPrelude.cpp:
+
+2021-06-01  Kyle Piddington  <kpiddington@apple.com>
+
+        [Metal ANGLE] transformFeedback samples on webglsamples.org do not render correctly
+        https://bugs.webkit.org/show_bug.cgi?id=226285
+        <rdar://78524773>
+
+        Reviewed by Dean Jackson.
+
+        Metal ANGLE does not render these samples correctly, for a number of reasons. 
+        For transform_feedback_interleaved and seperated, We need to start a new renderEncoder to get the results from the transform feedback. 
+        for transform_feedback-seperated_2, we need to invalidate the current render pass descriptor in order to switch to the rasterizer-enabled version of the shader.
+        Testing: Ran all transform feedback tests from deqp suite to ensure no regressions are present.
+
+        * src/libANGLE/renderer/metal/ContextMtl.h:
+        * src/libANGLE/renderer/metal/ContextMtl.mm:
+        (rx::ContextMtl::drawTriFanArraysWithBaseVertex):
+        (rx::ContextMtl::drawArraysImpl):
+        (rx::ContextMtl::drawTriFanElements):
+        (rx::ContextMtl::prepareForTransformFeedbackPassTwo):
+        (rx::ContextMtl::drawLineLoopElements):
+        (rx::ContextMtl::drawElementsImpl):
+        (rx::ContextMtl::onEndTransformFeedback):
+        * src/libANGLE/renderer/metal/TransformFeedbackMtl.mm:
+        (rx::TransformFeedbackMtl::end):
+
+2021-06-01  Kimmo Kinnunen  <kkinnunen@apple.com>
+
+        ANGLE Metal translator pre-rotation code is unused and it asserts when used
+        https://bugs.webkit.org/show_bug.cgi?id=226262
+
+        Reviewed by Dean Jackson.
+
+        Remove the pre-rotation code. It is Android specific and most likely it is useful
+        only when ANGLE is used as the drawing mechanism for the primary app window picture.
+        Thus most likely it is not useful in WebKit on Cocoa platforms where the window
+        server does the compositing.
+
+        * src/compiler/translator/TranslatorMetalDirect.cpp:
+        (sh::TranslatorMetalDirect::translateImpl):
+        * src/compiler/translator/TranslatorMetalDirect.h:
+        * src/libANGLE/renderer/metal/ContextMtl.h:
+        * src/libANGLE/renderer/metal/ContextMtl.mm:
+        (rx::ContextMtl::handleDirtyDriverUniforms):
+
+2021-05-31  Kimmo Kinnunen  <kkinnunen@apple.com>
+
+        Cherry-pick ANGLE: Add array bounds checks for WebGL shaders
+        https://bugs.webkit.org/show_bug.cgi?id=226397
+
+        Reviewed by Dean Jackson.
+
+        Cherry-pick ANGLE commit b0d39ba2aba218402ff2f32f6e16f18cf4975ff4
+        At the moment does not affect any WebKit client.
+        Makes the code consistent with OpenGL.
+        Makes it easier to understand same change in Metal backend.
+
+        Upstream description:
+        Add array bounds checks for WebGL shaders
+        WebGL shaders may contain OOB array accesses which in turn
+        cause undefined behavior, which may result in security
+        issues. This was detected as an UNKNOWN READ by UBSAN while
+        testing with SwANGLE.
+
+        * src/libANGLE/renderer/vulkan/ShaderVk.cpp:
+        (rx::ShaderVk::compile):
+
+2021-05-28  Kimmo Kinnunen  <kkinnunen@apple.com>
+
+        ANGLE Metal translator should always collect variables
+        https://bugs.webkit.org/show_bug.cgi?id=226261
+
+        Reviewed by Dean Jackson.
+
+        Always collect the variables when translating GLSL to Metal.
+        This way tests that invoke translation without SH_VARIABLES still
+        work.
+
+        * src/compiler/translator/TranslatorMetalDirect.cpp:
+        (sh::TranslatorMetalDirect::translateImpl):
+        * src/compiler/translator/TranslatorMetalDirect.h:
+
+2021-05-27  Kimmo Kinnunen  <kkinnunen@apple.com>
+
+        ANGLE could be compiled with "aggressive uninitialised variable" setting
+        https://bugs.webkit.org/show_bug.cgi?id=226260
+
+        Reviewed by Alexey Proskuryakov.
+
+        Turn on compiler flag to warn about uninitialized variables that might be
+        conditionally uninitialized. This is the same flag as upstream ANGLE uses.
+        Fix a spurious warning produced by this flag.
+        This helps in scenarios where custom targets compile ANGLE sources and
+        this flag set, such as tests.
+
+        * Configurations/Base.xcconfig:
+        * src/compiler/translator/TranslatorMetalDirect/FixTypeConstructors.cpp:
+
+2021-05-27  Kimmo Kinnunen  <kkinnunen@apple.com>
+
+        Cherry-pick ANGLE: D3D11: Skip blits if there is no intersection of dest areas
+        https://bugs.webkit.org/show_bug.cgi?id=225190
+        <rdar://77084155>
+
+        Reviewed by David Kilzer.
+
+        Cherry-pick ANGLE commit b574643ef28c92fcea5122dd7a72acb42a514eed
+        Fixes a security issue on D3D11.
+        Potential a correctness issue on some OpenGL drivers.
+        No effect on Metal, but the nodiscard part is still useful.
+
+        Upstream description:
+        D3D11: Skip blits if there is no intersection of dest areas
+
+        Blit11 would clip the destination rectangle with the destination size
+        but ignore the result. gl::ClipRectangle returns false when the
+        rectangles do not intersect at all, indicating the blit can be skipped.
+
+        This could lead to an out-of-bounds write to the GPU memory for the
+        destination texture.
+
+        Mark ClipRectangle as nodiscard to prevent future issues.
+        * src/libANGLE/angletypes.h:
+        * src/libANGLE/renderer/d3d/d3d11/Blit11.cpp:
+        * src/libANGLE/renderer/gl/FramebufferGL.cpp:
+        (rx::FramebufferGL::clipSrcRegion):
+        * src/libANGLE/renderer/metal/ContextMtl.mm:
+        (rx::ContextMtl::updateScissor):
+        * src/libANGLE/renderer/vulkan/ContextVk.cpp:
+        (rx::ContextVk::updateScissor):
+        * src/tests/gl_tests/BlitFramebufferANGLETest.cpp:
+        (TEST_P):
+
+2021-05-26  Don Olmstead  <don.olmstead@sony.com>
+
+        [CMake] Support USE_ANGLE_EGL on additional platforms
+        https://bugs.webkit.org/show_bug.cgi?id=224888
+        <rdar://problem/77280211>
+
+        Reviewed by Ken Russell.
+
+        Support ANGLE using the OpenGL backend for GTK. Support ANGLE using Metal
+        backend for Mac. Add the generated sources for these two backends.
+
+        Clean up the CMake and introduce additional targets.
+
+        * CMakeLists.txt:
+        * Compiler.cmake:
+        * GL.cmake: Added.
+        * Metal.cmake: Added.
+        * PlatformFTW.cmake:
+        * PlatformGTK.cmake:
+        * PlatformMac.cmake:
+        * PlatformWin.cmake:
+
+2021-05-20  Kyle Piddington  <kpiddington@apple.com>
+
+        [Metal ANGLE] Handle NAN constant folding correctly
+        https://bugs.webkit.org/show_bug.cgi?id=226052
+
+        NAN values (0.0f/0.0f) were being handled incorrectly. MSL was being emitted as lowercase 'nanf', instead of NAN
+        Check for an unlikely NAN case, and emit correct MSL
+
+        Reviewed by Dean Jackson.
+
+        * src/compiler/translator/TranslatorMetalDirect/EmitMetal.cpp:
+        (GenMetalTraverser::emitSingleConstant):
+
+2021-05-20  Kyle Piddington  <kpiddington@apple.com>
+
+        Red flashes zooming on Google Maps when using external monitor on multi-gpu systems
+        https://bugs.webkit.org/show_bug.cgi?id=225956
+        <rdar://77024179>        
+
+        Reviewed by Dean Jackson.
+        IOSurface presentation swaps require that a command buffer is queued for execution before
+        swapping. Otherwise, we're liable to drop frames, or present old IOSurface buffers. 
+        Ensure work flushed via glFlush completes before presenation by waiting for it to enqueue before 
+        swapping a surface.
+
+        * src/libANGLE/renderer/metal/ContextMtl.mm:
+        (rx::ContextMtl::flush):
+        * src/libANGLE/renderer/metal/mtl_command_buffer.h:
+        * src/libANGLE/renderer/metal/mtl_command_buffer.mm:
+        (rx::mtl::CommandBuffer::waitUntilScheduled):
+        (rx::mtl::CommandBuffer::commitImpl):
+
+2021-05-19  Kyle Piddington  <kpiddington@apple.com>
+
+        ASSERT(!toType.isArray()) failure in sh::CoerceSimple due to vector array dereference
+        https://bugs.webkit.org/show_bug.cgi?id=225864
+        <rdar://77968214> 
+
+        Reviewed by Dean Jackson.
+
+        Fixed program translation error, additional issues with transform feedback shaders
+
+        * src/compiler/translator/TranslatorMetalDirect/AddExplicitTypeCasts.cpp:
+        * src/libANGLE/renderer/metal/ProgramMtl.mm:
+        (rx::ProgramMtl::reset):
+
+2021-05-19  Kyle Piddington  <kpiddington@apple.com>
+
+        [ANGLE Metal] Support Provoking Vertex Emulation, Pass Fragment Output test suite.
+        https://bugs.webkit.org/show_bug.cgi?id=225842
+
+        Reviewed by Dean Jackson.
+
+        Add support for provoking vertex emulation. Metal only supports using the first vertex
+        of a primitive as a provoking vertex. To adapt, rewrite the index buffer on the fly when provoking vertex support is required. This method does not rewrite any primitives that would be 
+        culled by primitive restart, such as simple triangles and lines. Triangle and line strips are re-written to line and triangle buffers. Tri fans and line loops are not supported for this
+        rewrite as of this patch.
+
+        * ANGLE.xcodeproj/project.pbxproj:
+        * src/libANGLE/renderer/metal/ContextMtl.h:
+        * src/libANGLE/renderer/metal/ContextMtl.mm:
+        (rx::ContextMtl::ContextMtl):
+        (rx::ContextMtl::initialize):
+        (rx::ContextMtl::onDestroy):
+        (rx::ContextMtl::drawElementsImpl):
+        (rx::ContextMtl::flushCommandBufer):
+        (rx::ContextMtl::present):
+        (rx::ContextMtl::ensureCommandBufferReady):
+        (rx::ContextMtl::requiresIndexRewrite):
+        * src/libANGLE/renderer/metal/ProgramMtl.h:
+        * src/libANGLE/renderer/metal/ProgramMtl.mm:
+        (rx::ProgramMtl::ProgramMtl):
+        (rx::ProgramMtl::programHasFlatAttributes const):
+        (rx::ProgramMtl::linkImpl):
+        * src/libANGLE/renderer/metal/ProvokingVertexHelper.h: Added.
+        * src/libANGLE/renderer/metal/ProvokingVertexHelper.mm: Added.
+        (rx::primCountForIndexCount):
+        (rx::ProvokingVertexHelper::ProvokingVertexHelper):
+        (rx::ProvokingVertexHelper::onDestroy):
+        (rx::ProvokingVertexHelper::commitPreconditionCommandBuffer):
+        (rx::ProvokingVertexHelper::getComputeCommandEncoder):
+        (rx::ProvokingVertexHelper::ensureCommandBufferReady):
+        (rx::buildIndexBufferKey):
+        (rx::ProvokingVertexHelper::getSpecializedShader):
+        (rx::ProvokingVertexHelper::hasSpecializedShader):
+        (rx::ProvokingVertexHelper::prepareCommandEncoderForDescriptor):
+        (rx::ProvokingVertexHelper::preconditionIndexBuffer):
+        * src/libANGLE/renderer/metal/mtl_state_cache.h:
+        (std::hash<rx::mtl::ProvokingVertexComputePipelineDesc>::operator() const):
+        * src/libANGLE/renderer/metal/mtl_state_cache.mm:
+        (rx::mtl::ProvokingVertexComputePipelineDesc::ProvokingVertexComputePipelineDesc):
+        (rx::mtl::ProvokingVertexComputePipelineDesc::operator=):
+        (rx::mtl::ProvokingVertexComputePipelineDesc::operator== const):
+        (rx::mtl::ProvokingVertexComputePipelineDesc::operator!= const):
+        (rx::mtl::ProvokingVertexComputePipelineDesc::hash const):
+        (rx::mtl::ProvokingVertexComputePipelineCache::ProvokingVertexComputePipelineCache):
+        (rx::mtl::ProvokingVertexComputePipelineCache::setComputeShader):
+        (rx::mtl::ProvokingVertexComputePipelineCache::clearPipelineStates):
+        (rx::mtl::ProvokingVertexComputePipelineCache::clear):
+        (rx::mtl::ProvokingVertexComputePipelineCache::getComputePipelineState):
+        (rx::mtl::ProvokingVertexComputePipelineCache::insertComputePipelineState):
+        (rx::mtl::ProvokingVertexComputePipelineCache::recreatePipelineStates):
+        (rx::mtl::ProvokingVertexComputePipelineCache::createComputePipelineState):
+        (rx::mtl::ProvokingVertexComputePipelineCache::~ProvokingVertexComputePipelineCache):
+        * src/libANGLE/renderer/metal/mtl_utils.h:
+        * src/libANGLE/renderer/metal/mtl_utils.mm:
+        (rx::mtl::CreateMslShader):
+        * src/libANGLE/renderer/metal/shaders/mtl_default_shaders_src_autogen.inc:
+        * src/libANGLE/renderer/metal/shaders/rewrite_indices.metal: Added.
+        * src/libANGLE/renderer/metal/shaders/rewrite_indices_shared.h: Added.
+
+2021-05-18  Alex Christensen  <achristensen@webkit.org>
+
+        Stop compiling ANGLE metal files twice
+        https://bugs.webkit.org/show_bug.cgi?id=225919
+        <rdar://78013511>
+
+        Reviewed by Dean Jackson.
+
+        ANGLE currently generates an unused default.metallib that conflicts with other default.metallibs being built.
+        Since it is unused, remove it.
+        What we currently do is put all the source bytes into gDefaultMetallibSrc and compile it at runtime.
+        This could be optimized to do it at compile time and use newLibraryWithData instead of newLibraryWithSource,
+        but that should be done separately.
+
+        * ANGLE.xcodeproj/project.pbxproj:
+
+2021-05-12  Kyle Piddington  <kpiddington@apple.com>
+
+        [Angle METAL] Remove thread qualifiers and pass-by-reference qualifiers for cast functions
+        https://bugs.webkit.org/show_bug.cgi?id=225702
+        <rdar://76799461>
+
+        Cast functions fail to compile when casting from user uniforms. Update cast functions to remove pass-by-reference
+        qualifiers. 
+
+        Reviewed by Dean Jackson.
+
+        * src/compiler/translator/TranslatorMetalDirect/ProgramPrelude.cpp:
+
+2021-05-08  Basuke Suzuki  <basuke.suzuki@sony.com>
+
+        [WinCairo] Remove linker warning on ANGLE
+        https://bugs.webkit.org/show_bug.cgi?id=225501
+
+        Reviewed by Darin Adler.
+
+        libANGLE is statically linked to libGLESv2.dll so that __declspec(dllimport) is not required here.
+
+        * include/platform/PlatformMethods.h:
+
+2021-05-06  Kyle Piddington  <kpiddington@apple.com>
+
+        [Metal ANGLE] Only clear dirty state bits after all state has been successfully set
+        https://bugs.webkit.org/show_bug.cgi?id=225468
+        <rdar://77066752>
+
+        When running in release, if any ANGLE calls fail, we eventually return to this part of the code.
+        We can be left with an incomplete state, where we have an incomplete program or attachment, 
+        but a 'clean' state. This can lead to errors such as setting nil render pipeline states, leading to
+        crashes.
+
+        To mitigate this, hold off on setting state bits until we've completly set up a program.
+
+        Reviewed by Dean Jackson.
+
+        * src/libANGLE/renderer/metal/ContextMtl.mm:
+        (rx::ContextMtl::setupDraw):
+        * src/libANGLE/renderer/metal/ProgramMtl.mm:
+
+2021-05-03  Kyle Piddington  <kpiddington@apple.com>
+
+        [Metal ANGLE]: Fix conversions tests and remove failing test expectations
+        https://bugs.webkit.org/show_bug.cgi?id=225261
+        <rdar://77349615>
+                  
+        bool conversion workaround was being applied to all shaders. Correct shader translation to generate
+        better conversion code on platforms that don't need a workaround. 
+
+        Conversions for basic types like vec2, ivec2, uvec2 were only using the first components when workaround
+        was active. Correct swizzle logic to get all components when doing a conversion.
+
+        Reviewed by Dean Jackson.
+
+        * src/compiler/translator/TranslatorMetalDirect/AddExplicitTypeCasts.cpp:
+        * src/compiler/translator/TranslatorMetalDirect/AstHelpers.cpp:
+        (sh::CoerceSimple):
+        * src/compiler/translator/TranslatorMetalDirect/AstHelpers.h:
+
+2021-04-30  Kyle Piddington  <kpiddington@apple.com>
+
+        [Metal ANGLE]: fix webgl/2.0.0/deqp/functional/gles3/negativebufferapi 
+        https://bugs.webkit.org/show_bug.cgi?id=225222
+        <rdar://77349908>
+
+        Arbitrary alignments are not allowed in Metal. Update UBO alignment to 
+        a platform-dependant offset to match specifications.
+        Reviewed by Dean Jackson.
+
+        * src/libANGLE/renderer/metal/DisplayMtl.mm:
+        (rx::DisplayMtl::ensureCapsInitialized const):
+
+2021-04-29  Kyle Piddington  <kpiddington@apple.com>
+
+        Metal-ANGLE: Shared memory texture tests failing in iOS Simulator
+        https://bugs.webkit.org/show_bug.cgi?id=222685
+        <rdar://75001722>
+
+        Using replaceRegion to perform texture uploads on simulator causes issues on some workflows.
+        As a workaround, use a GPU-driven upload instead of a CPU driven upload. 
+        Reviewed by Kenneth Russell.
+
+        * src/libANGLE/renderer/metal/TextureMtl.mm:
+
+2021-04-29  Kyle Piddington  <kpiddington@apple.com>
+
+        [ANGLE-Metal] Fix 17 textureshadow tests
+        https://bugs.webkit.org/show_bug.cgi?id=224965
+        <rdar://77053085> 
+
+        Depth24Stencil8 copies were being incorrectly managed when dealing with D24S8 emulation.
+        Fix conversion functions 
+
+        Reviewed by Dean Jackson.
+
+        * src/libANGLE/renderer/metal/mtl_format_utils.h:
+        * src/libANGLE/renderer/metal/mtl_format_utils.mm:
+        (rx::mtl::priv::OffsetDataPointer):
+        (rx::mtl::LoadS8D24S8ToD32FX24S8):
+        (rx::mtl::DEPTH24_STENCIL8_to_D32_FLOAT_X24S8_UINT):
+        (rx::mtl::GetLoadFunctionsMap):
+        (rx::mtl::FormatTable::initialize):
+        (): Deleted.
+
+2021-04-28  Alex Christensen  <achristensen@webkit.org>
+
+        Stop building libANGLE.a
+        https://bugs.webkit.org/show_bug.cgi?id=225162
+        <rdar://problem/57349384>
+
+        Reviewed by Alexey Proskuryakov.
+
+        Now that everyone's linking against the dylib, we don't need to build the static library any more.
+
+        * ANGLE.xcodeproj/project.pbxproj:
+        * Configurations/ANGLE-dynamic.xcconfig:
+        * src/empty.cpp: Removed.
+
+2021-04-28  Kimmo Kinnunen  <kkinnunen@apple.com>
+
+        ANGLE should be compiled with thread-safe statics
+        https://bugs.webkit.org/show_bug.cgi?id=224854
+
+        Reviewed by Kenneth Russell.
+
+        Compile ANGLE with normal thread-safe c++ local statics.
+        No known threading failures. Based on ad-hoc risk vs benefit
+        evaluation of today and after future merges, it appears
+        better to err in the side of caution.
+
+        * Configurations/Base.xcconfig:
+
+2021-04-26  Alex Christensen  <achristensen@webkit.org>
+
+        Update Mac-specific CMake files
+        https://bugs.webkit.org/show_bug.cgi?id=225064
+
+        Rubber-stamped by Tim Horton.
+
+        * PlatformMac.cmake:
+
+2021-04-25  Kyle Piddington  <kpiddington@apple.com>
+
+        [Metal ANGLE] support primitive restart behavior with simple data types
+        https://bugs.webkit.org/show_bug.cgi?id=225011
+
+        Primitive restart behavior for simple data types is not defined in Metal. Add a pre-draw pass to 
+        create a set of restart indices, rather than re-write the index buffer. This pass avoids 
+        storing more copies of the index buffer: instead, we cache the location of restart indices, and
+        use them to build draw lists.
+ 
+        Reviewed by Dean Jackson.
+
+        * src/libANGLE/renderer/metal/BufferMtl.h:
+        * src/libANGLE/renderer/metal/BufferMtl.mm:
+        (rx::IndexConversionBufferMtl::IndexConversionBufferMtl):
+        (rx::BufferMtl::markConversionBuffersDirty):
+        (rx::calculateRestartRanges):
+        (rx::BufferMtl::getRestartIndices):
+        * src/libANGLE/renderer/metal/ContextMtl.h:
+        * src/libANGLE/renderer/metal/ContextMtl.mm:
+        (rx::ContextMtl::drawLineLoopElements):
+        (rx::ContextMtl::drawElementsImpl):
+        (rx::ContextMtl::drawElementsSimpleTypesPrimitiveRestart): Deleted.
+        * src/libANGLE/renderer/metal/VertexArrayMtl.h:
+        * src/libANGLE/renderer/metal/VertexArrayMtl.mm:
+        (rx::VertexArrayMtl::getIndexBuffer):
+        (rx::VertexArrayMtl::getDrawIndices):
+        (rx::VertexArrayMtl::convertIndexBuffer):
+        (rx::VertexArrayMtl::streamIndexBufferFromClient):
+
+2021-04-25  John Cunningham  <johncunningham@apple.com>
+
+        [Metal ANGLE] Temporarily remove AST validation even for debug builds
+        https://bugs.webkit.org/show_bug.cgi?id=224991
+        rdar://76299178
+ 
+        Reviewed by Kenneth Russell.
+
+        * src/libANGLE/renderer/metal/ShaderMtl.mm:
+        (rx::ShaderMtl::compileImplMtl):
+
+2021-04-25  Kyle Piddington  <kpiddington@apple.com>
+
+        [Metal ANGLE] Select proper IOSurface backing format for WebGL environment
+        https://bugs.webkit.org/show_bug.cgi?id=224948
+        <rdar://76284889>
+
+        Depending on the architecture, WebCore expects different 
+        IOSurface texture targets for the main buffer. When running catalyst on 
+        Arm64 devices, Metal-ANGLE needs to select the TEXTURE_2D texture target for our
+        IOSurface/Pbuffer bind point, rather than TEXTURE_RECTANGLE.
+
+	Reviewed by Dean Jackson.
+
+        * src/libANGLE/renderer/metal/DisplayMtl.h:
+        * src/libANGLE/renderer/metal/DisplayMtl.mm:
+        (rx::needsEAGLOnMac):
+        (rx::DisplayMtl::EGLDrawingBufferTextureTarget):
+        (rx::DisplayMtl::generateConfigs):
+
+2021-04-23  Truitt Savell  <tsavell@apple.com>
+
+        Unreviewed, reverting r276190.
+
+        broke a test internally.
+
+        Reverted changeset:
+
+        "Metal-ANGLE: Shared memory texture tests failing in iOS
+        Simulator"
+        https://bugs.webkit.org/show_bug.cgi?id=222685
+        https://commits.webkit.org/r276190
+
+2021-04-22  Lauro Moura  <lmoura@igalia.com>
+
+        [CMake][ANGLE] Silence -Wreturn-type for gcc and clang
+        https://bugs.webkit.org/show_bug.cgi?id=224949
+
+        Reviewed by Don Olmstead.
+
+        Avoid "control reaches end of non-void function" in
+        sh::TIntermRebuild::traverseChildren(...)
+
+        * CMakeLists.txt:
+
+2021-04-22  Philippe Normand  <pnormand@igalia.com>
+
+        Unreviewed, WPE build fix after r276390
+
+        Fix namespacing issues in nullptr_t invocations.
+
+        * src/compiler/translator/tree_util/IntermRebuild.cpp:
+        (sh::TIntermRebuild::BaseResult::BaseResult):
+        (sh::PreResult::PreResult):
+        (sh::PostResult::PostResult):
+        * src/compiler/translator/tree_util/IntermRebuild.h:
+
+2021-04-21  Don Olmstead  <don.olmstead@sony.com>
+
+        [Python 3] Update gni-to-cmake.py
+        https://bugs.webkit.org/show_bug.cgi?id=224880
+
+        Reviewed by Kenneth Russell.
+
+        Update gni-to-cmake.py to run on Python 3. Added ArgumentParser support to be able to run
+        the script on Windows since the script assumed it would be called through a UNIX style
+        shell.
+
+        Ran the .gni files through the converter to verify output. It appears that the
+        Compiler.cmake file wasn't generated in the last update to ANGLE so it has many changes.
+
+        * Compiler.cmake:
+        * D3D.cmake:
+        * gni-to-cmake.py:
+
+2021-04-21  Don Olmstead  <don.olmstead@sony.com>
+
+        [CMake] Add OpenGLES2 targets
+        https://bugs.webkit.org/show_bug.cgi?id=224786
+
+        Reviewed by Adrian Perez de Castro.
+
+        Add an ALIAS target mapping ANGLE's GLESv2 target to OpenGL::GLES if the target is not
+        already present. This is the case for Windows which uses ANGLE as its sole OpenGL ES
+        implementation.
+
+        * CMakeLists.txt:
+
+2021-04-20  Alex Christensen  <achristensen@webkit.org>
+
+        MacCatalyst ANGLE is linked with @loader_path/../../../libANGLE-shared.dylib
+        https://bugs.webkit.org/show_bug.cgi?id=224602
+
+        Reviewed by Alexey Proskuryakov.
+
+        * Configurations/ANGLE-dynamic.xcconfig:
+
+2021-04-19  Alex Christensen  <achristensen@webkit.org>
+
+        Build ANGLE dylib into WK_OVERRIDE_FRAMEWORKS_DIR in builds that use it
+        https://bugs.webkit.org/show_bug.cgi?id=224785
+        <rdar://76641662>
+
+        Reviewed by Alexey Proskuryakov.
+
+        * Configurations/ANGLE-dynamic.xcconfig:
+
+2021-04-16  Kyle Piddington  <kpiddington@apple.com>
+
+        Metal-ANGLE: Shared memory texture tests failing in iOS Simulator
+        https://bugs.webkit.org/show_bug.cgi?id=222685
+
+        Reviewed by Dean Jackson.
+
+        Simulator-only path drives filling textures via Blit encoders instead of mapped memory.
+        This workaround fixes dropped texture writes when using replaceRegion
+
+        * src/libANGLE/renderer/metal/TextureMtl.mm:
+        * src/libANGLE/renderer/metal/mtl_utils.mm:
+        (rx::mtl::InitializeTextureContents):
+
+2021-04-15  Alex Christensen  <achristensen@webkit.org>
+
+        Use kIOMainPortDefault where available
+        https://bugs.webkit.org/show_bug.cgi?id=224632
+
+        Reviewed by Alexey Proskuryakov.
+
+        In ANGLE we don't include WTF headers, so we can't use the HAVE macro like we do elsewhere in WebKit,
+        but this is pretty close.
+
+        * src/gpu_info_util/SystemInfo_macos.mm:
+        (angle::GetVendorIDFromMetalDeviceRegistryID):
+
+2021-04-15  Alex Christensen  <achristensen@webkit.org>
+
+        Add deprecation macros
+        https://bugs.webkit.org/show_bug.cgi?id=224624
+
+        * src/gpu_info_util/SystemInfo_macos.mm:
+        (angle::GetVendorIDFromMetalDeviceRegistryID):
+
+2021-04-12  Dean Jackson  <dino@apple.com>
+
+        REGRESSION (Metal ANGLE): [Catalina] 6 consistent WebGL failures / timeouts
+        https://bugs.webkit.org/show_bug.cgi?id=224016
+        <rdar://problem/76070325>
+
+        Patch by John Cunningham <johncunnigham@apple.com>
+        Reviewed by Dean Jackson.
+
+        Implement a workaround for Intel GPUs where we explicitly type cast floating
+        point values to booleans. This is only needed for Catalina systems.
+
+        * include/GLSLANG/ShaderLang.h:
+        * include/platform/FeaturesMtl.h:
+        * src/compiler/translator/TranslatorMetalDirect.cpp:
+        (sh::TranslatorMetalDirect::translateImpl):
+        * src/compiler/translator/TranslatorMetalDirect/AddExplicitTypeCasts.cpp:
+        (sh::Rewriter::Rewriter):
+        (sh::AddExplicitTypeCasts):
+        * src/compiler/translator/TranslatorMetalDirect/AddExplicitTypeCasts.h:
+        * src/compiler/translator/TranslatorMetalDirect/AstHelpers.cpp:
+        (sh::SubVector):
+        (sh::CoerceSimple):
+        * src/compiler/translator/TranslatorMetalDirect/AstHelpers.h:
+        * src/libANGLE/renderer/metal/DisplayMtl.mm:
+        (rx::DisplayMtl::initializeFeatures):
+        * src/libANGLE/renderer/metal/ShaderMtl.mm:
+        (rx::ShaderMtl::compile):
+
+2021-04-12  Kyle Piddington  <kpiddington@apple.com>
+
+        Crash in webgl/2.0.y/conformance/glsl/misc/uninitialized-local-global-variables.html ANGLE+METAL
+        https://bugs.webkit.org/show_bug.cgi?id=223923
+	
+        Anonymous structs require a name in MSL, add a default name ANGLE__unnamed$id to any structs.
+        Also add a unit test to ensure this works.
+        Reviewed by Kenneth Russell.
+
+        * src/compiler/translator/TranslatorMetalDirect.cpp:
+        (sh::TranslatorMetalDirect::translateImpl):
+        * src/compiler/translator/TranslatorMetalDirect/SeparateCompoundStructDeclarations.cpp:
+        (sh::Separator::Separator):
+        (sh::SeparateCompoundStructDeclarations):
+        * src/compiler/translator/TranslatorMetalDirect/SeparateCompoundStructDeclarations.h:
+        * src/tests/BUILD.gn:
+        * src/tests/angle_unittests.gni:
+        * src/tests/compiler_tests/MSLOutput_Test.cpp:
+
+2021-04-08  Kyle Piddington  <kpiddington@apple.com>
+
+        [Metal-ANGLE] Support GPU power preferences, select low-power GPU by default.
+        Respond to GPU power preference flags, expose extension, and avoid creating a high-powered GPU by default.
+        https://bugs.webkit.org/show_bug.cgi?id=224337
+
+        Reviewed by Dean Jackson.
+
+        * src/libANGLE/renderer/metal/DisplayMtl.h:
+        * src/libANGLE/renderer/metal/DisplayMtl.mm:
+        (rx::DisplayMtl::initializeImpl):
+        (rx::DisplayMtl::getMetalDeviceMatchingAttribute):
+        (rx::DisplayMtl::generateExtensions const):
+
+2021-04-07  Kyle Piddington  <kpiddington@apple.com>
+
+        Crash in conformance2/textures/misc/compressed-tex-image.html with ANGLE+METAL
+        Handle uploading a compressed texture with a non-aligned offset. Path requires that we still fill the entire level of a 
+        compressed texture.
+        https://bugs.webkit.org/show_bug.cgi?id=223925
+
+        Reviewed by Dean Jackson.
+
+        * src/libANGLE/renderer/metal/TextureMtl.mm:
+        (rx::TextureMtl::convertAndSetPerSliceSubImage):
+
+2021-04-07  John Cunningham  <johncunnigham@apple.com>
+
+        [METAL ANGLE] Interface block declerations need to have children marked as struct accesses. Add implicit backing textures for multisample render targets
+        https://bugs.webkit.org/show_bug.cgi?id=224265
+
+        Reviewed by Dean Jackson.
+
+        * src/compiler/translator/TranslatorMetalDirect/ReduceInterfaceBlocks.cpp:
+        * src/libANGLE/renderer/metal/FrameBufferMtl.h:
+        * src/libANGLE/renderer/metal/FrameBufferMtl.mm:
+        (rx::FramebufferMtl::setLoadStoreActionOnRenderPassFirstStart):
+        (rx::FramebufferMtl::onStartedDrawingToFrameBuffer):
+        * src/libANGLE/renderer/metal/RenderBufferMtl.mm:
+        (rx::RenderbufferMtl::setStorageImpl):
+
+2021-04-05  Alex Christensen  <achristensen@webkit.org>
+
+        Resurrect Mac CMake build
+        https://bugs.webkit.org/show_bug.cgi?id=224084
+
+        Reviewed by Tim Horton.
+
+        * PlatformMac.cmake: Added.
+
+2021-04-05  John Cunningham  <johncunnigham@apple.com>
+
+        [METAL ANGLE] Stencil only formats being used as the depth attachment.
+        https://bugs.webkit.org/show_bug.cgi?id=224183
+
+        Reviewed by Jon Lee.
+
+        * src/compiler/translator/TranslatorMetalDirect/ProgramPrelude.cpp:
+        * src/compiler/translator/TranslatorMetalDirect/RewriteOutArgs.cpp:
+        (sh::Rewriter::argAlreadyProcessed):
+        * src/libANGLE/renderer/metal/ContextMtl.mm:
+        (rx::ContextMtl::setupDraw):
+        * src/libANGLE/renderer/metal/mtl_command_buffer.h:
+        * src/libANGLE/renderer/metal/mtl_command_buffer.mm:
+        (rx::mtl::RenderCommandEncoder::reset):
+        (rx::mtl::RenderCommandEncoder::setRenderPipelineState):
+        (rx::mtl::RenderCommandEncoder::draw):
+        (rx::mtl::RenderCommandEncoder::drawInstanced):
+        (rx::mtl::RenderCommandEncoder::drawIndexed):
+        (rx::mtl::RenderCommandEncoder::drawIndexedInstanced):
+        (rx::mtl::RenderCommandEncoder::drawIndexedInstancedBaseVertex):
+        * src/libANGLE/renderer/metal/mtl_utils.mm:
+        (rx::mtl::InitializeDepthStencilTextureContentsGPU):
+
+2021-03-30  Kyle Piddington  <kpiddington@apple.com>
+
+        Enable sample_compare operations in Metal ANGLE
+        Sample_compare operations, and shadow sampling was accidently switched off when initially
+        setting up ANGLE_Metal. Enabling shadow sampling fixes most of the 
+        webgl/2.0.0/deqp/functional/gles3/textureshadow/ test suite, which is currently failing.
+
+        https://bugs.webkit.org/show_bug.cgi?id=223833
+
+        Reviewed by Jon Lee.
+
+        * src/libANGLE/renderer/metal/DisplayMtl.mm:
+        (rx::DisplayMtl::initializeFeatures):
+
+2021-03-26  Jessie Berlin  <jberlin@webkit.org>
+
+        Update the BEFORE/SINCE, SYSTEM_VERSION_PREFIX, and MACOSX_DEPLOYMENT_TARGET flags
+        https://bugs.webkit.org/show_bug.cgi?id=223779
+
+        Reviewed by Tim Horton.
+
+        * Configurations/DebugRelease.xcconfig:
+        * Configurations/Version.xcconfig:
+        * Configurations/WebKitTargetConditionals.xcconfig:
+
+2021-03-25  Kyle Piddington  <kpiddington@apple.com>
+
+        ANGLE Metal crash ASAN webgl/1.0.3/conformance/misc/object-deletion-behaviour.html
+        https://bugs.webkit.org/show_bug.cgi?id=223739
+
+        Reviewed by Dean Jackson.
+
+        Previously, ANGLE would try to read color attachments off of the
+        cached render targets. However, since validation happens before
+        state sync, the cached render targets may be out of date.
+
+        For non-surface backed render targets, we instead get a fresh copy
+        of the render target when determening the native pixel format.
+
+        * src/libANGLE/renderer/metal/FrameBufferMtl.h:
+        * src/libANGLE/renderer/metal/FrameBufferMtl.mm:
+        (rx::FramebufferMtl::getImplementationColorReadFormat const):
+        (rx::FramebufferMtl::getColorReadRenderTargetNoCache const):
+
+
+2021-03-25  Kyle Piddington  <kpiddington@apple.com>
+
+        [Metal ANGLE] Add CPU mipmap generation for workaround on Intel devices.
+        https://bugs.webkit.org/show_bug.cgi?id=223778
+
+        Reviewed by Dean Jackson.
+
+        Mipmap generation on Intel does not reliably work for textures with
+        width less than four. To reliably pass webGL conformance, we need
+        to switch to CPU mipmap generation when generating mipmaps in this
+        specific circumstance.
+
+        This patch fixes the following four tests on Intel
+        webgl/1.0.3/conformance/limits/gl-max-texture-dimensions.html
+        webgl/1.0.3/conformance/textures/texture-size.html
+        webgl/2.0.0/conformance/limits/gl-max-texture-dimensions.html
+        webgl/2.0.0/conformance/textures/misc/texture-size.html
+
+        * include/platform/Feature.h:
+        (angle::FeatureCategoryToString):
+        * include/platform/FeaturesMtl.h:
+        * src/libANGLE/renderer/metal/DisplayMtl.mm:
+        (rx::DisplayMtl::initializeFeatures):
+        * src/libANGLE/renderer/metal/TextureMtl.mm:
+        (rx::TextureMtl::generateMipmap):
+
+2021-03-25  Jessie Berlin  <jberlin@webkit.org>
+
+        Remove 10.13 DEPLOYMENT_TARGETs and SYSTEM_VERSION_PREFIXs
+        https://bugs.webkit.org/show_bug.cgi?id=223765
+
+        Reviewed by Tim Horton.
+
+        * Configurations/Base.xcconfig:
+        * Configurations/DebugRelease.xcconfig:
+        * Configurations/Version.xcconfig:
+
+2021-03-24  Kyle Piddington  <kpiddington@apple.com>
+
+        Metal ANGLE non-blockers: Fix webgl/1.0.3/conformance/uniforms/uniform-default-values.html, Stencil debug layer assertions
+        https://bugs.webkit.org/show_bug.cgi?id=223667
+
+        https://bugs.webkit.org/show_bug.cgi?id=223667
+
+        On Release, uniformDefaultValues was resetting program memory
+        either early, or oddly. Since program reflection should be constant
+        per Shader anyway, drop the 'reset' after assigning reflection data.
+
+        In addition, clamp stencil rectangle to always be within framebuffer bounds. Code taken from upstream ANGLE.
+
+
+        Reviewed by Dean Jackson.
+
+        * src/libANGLE/renderer/metal/ProgramMtl.mm:
+        (rx::ProgramMtl::linkImplDirect):
+        * src/libANGLE/renderer/metal/mtl_command_buffer.mm:
+        (rx::mtl::RenderCommandEncoder::initAttachmentWriteDependencyAndScissorRect):
+        (rx::mtl::RenderCommandEncoder::restart):
+        (rx::mtl::RenderCommandEncoder::setScissorRect):
+        * src/libANGLE/renderer/metal/mtl_glslang_mtl_utils.mm:
+        (rx::mtl::TranslatedShaderInfo::reset):
+        (rx::mtl::GlslangGetMSL):
+
+2021-03-24  Kyle Piddington  <kpiddington@apple.com>
+
+        Metal ANGLE crashes LayoutTests/inspector/canvas/updateShader-webgl.html
+        Rather than rely on an instance variable in a C++ class, just query the dictionary constant when needed.
+
+        https://bugs.webkit.org/show_bug.cgi?id=223695
+
+        Reviewed by Dean Jackson.
+
+        * src/libANGLE/renderer/metal/ProgramMtl.h:
+        * src/libANGLE/renderer/metal/ProgramMtl.mm:
+        (rx::ProgramMtl::ProgramMtl):
+        (rx::ProgramMtl::linkImplSpirv):
+        (rx::ProgramMtl::linkImplDirect):
+        (rx::ProgramMtl::linkTranslatedShaders):
+
+2021-03-23  Kyle Piddington  <kpiddington@apple.com>
+
+        ANGLE Metal fixes for program generation bugs
+        https://bugs.webkit.org/show_bug.cgi?id=223627
+
+        Reviewed by Dean Jackson.
+
+           webgl/2.0.0/conformance2/glsl3/texture-offset-uniform-texture-coordinate.html is fixed by dropping 'thread' qualifiers on pregenerated functions
+           webgl/2.0.0/conformance/glsl/bugs/compound-assignment-type-combination.html is fixed by introducing new operators for matrix +/- scalars
+           webgl/2.0.0/conformance/glsl/bugs/complex-glsl-does-not-crash.html is fixed by adding a pre-pass to rename any reserved keywords, such as 'vertex'
+
+        * src/compiler/translator/TranslatorMetalDirect/EmitMetal.cpp:
+        (BuildExternalAttributeIndexMap):
+        * src/compiler/translator/TranslatorMetalDirect/ProgramPrelude.cpp:
+        * src/compiler/translator/TranslatorMetalDirect/RewriteKeywords.cpp:
+        (sh::Rewriter::maybeCreateNewName):
+        (sh::Rewriter::visitSymbolPost):
+        (sh::Rewriter::predefineName):
+        (sh::RewriteKeywords):
+
+2021-03-23  Kimmo Kinnunen  <kkinnunen@apple.com>
+
+        ANGLE is missing the explicit context headers
+        https://bugs.webkit.org/show_bug.cgi?id=223470
+
+        Reviewed by Alexey Proskuryakov.
+
+        Add the autogenerated .inc files for explicit context
+        API into the ANGLE public headers.
+
+        * ANGLE.xcodeproj/project.pbxproj:
+        * adjust-angle-include-paths.py:
+        (replace):
+
+2021-03-19  Kyle Piddington  <kpiddington@apple.com>
+
+        Metal-Angle on Simulator does not support D24S8 correctly
+        https://bugs.webkit.org/show_bug.cgi?id=223494
+
+        Reviewed by Dean Jackson.
+
+        Re-ran autogen script for format table to add the missing format
+        Corrected texture swizzle support. Swizzle is unsupported on simulator.
+
+        * src/libANGLE/renderer/metal/mtl_format_table_autogen.mm:
+        (rx::mtl::Format::init):
+
+2021-03-19  Alex Christensen  <achristensen@webkit.org>
+
+        libANGLE-shared.dylib needs INSTALL_PATH when building Catalyst roots
+        https://bugs.webkit.org/show_bug.cgi?id=223499
+
+        Reviewed by Dean Jackson.
+
+        INSTALL_PATH was empty, so no dylib was being included in the root.
+        This is needed to fix the Catalyst build after bug 218539
+
+        * Configurations/ANGLE-dynamic.xcconfig:
+
+2021-03-06  Dean Jackson  <dino@apple.com>
+
+        Metal-ANGLE can ASSERT because MTL signal event code is compiled out
+        https://bugs.webkit.org/show_bug.cgi?id=222859
+        <rdar://problem/75132180>
+
+        Reviewed by Ken Russell.
+
+        With the Metal backend enabled, the test
+        webgl/2.0.0/conformance2/state/gl-object-get-calls.html will
+        occasionally crash in mtl_command_buffer when it hits unreachable
+        code because ANGLE_MTL_EVENT_AVAILABLE hasn't been defined. This is
+        available on macOS 10.14 and above, so should be enabled.
+
+        At the same time, it doesn't make sense to call the method that has
+        unreachable code, so guard against that in mtl_command_buffer.
+
+        * src/libANGLE/renderer/metal/mtl_command_buffer.mm:
+        (rx::mtl::CommandBuffer::setPendingEvents):
+        * src/libANGLE/renderer/metal/mtl_common.h: Define ANGLE_MTL_EVENT_AVAILABLE.
+
+2021-03-18  Kyle Piddington  <kpiddington@apple.com>
+
+        'MTLLanguageVersion1_0' is unavailable on Catalyst
+        https://bugs.webkit.org/show_bug.cgi?id=223392
+
+        Reviewed by Jon Lee.
+
+        Disable switch case in catalyst builds
+
+        * src/compiler/translator/TranslatorMetalDirect/EmitMetal.cpp:
+        (GetOperatorString):
+        * src/compiler/translator/TranslatorMetalDirect/ProgramPrelude.cpp:
+        * src/libANGLE/renderer/metal/FrameBufferMtl.mm:
+        (rx::FramebufferMtl::readPixels):
+        * src/libANGLE/renderer/metal/mtl_utils.mm:
+        (rx::mtl::GetUserSetOrHighestMSLVersion):
+
+2021-03-17  Kyle Piddington  <kpiddington@apple.com>
+
+        ANGLE Metal fixups for program generation, readPixels
+        https://bugs.webkit.org/show_bug.cgi?id=223260
+
+        Reviewed by Dean Jackson.
+
+        This diff fixes the following tests:
+        webgl/2.0.0/conformance2/glsl3/texture-offset-uniform-texture-coordinate.html Is fixed by dropping 'thread' qualifiers on our intermediate texture sampling helper functions. Previously, any uniforms used in sampling textures would have had issues with their namespace.
+        webgl/2.0.0/conformance2/reading/read-pixels-pack-parameters.html is fixed by correcting an issue with reading from outside the framebuffer. ANGLE Metal was previously reading to the start of the output array, rather than a proper offset.
+        webgl/2.0.0/conformance2/glsl3/array-equality.html is fixed by adding additional equality functions for handling arrays of structs.
+
+        * src/compiler/translator/TranslatorMetalDirect/EmitMetal.cpp:
+        (GetOperatorString):
+        * src/compiler/translator/TranslatorMetalDirect/ProgramPrelude.cpp:
+        * src/libANGLE/renderer/metal/FrameBufferMtl.mm:
+        (rx::FramebufferMtl::readPixels):
+
+2021-03-16  Kyle Piddington  <kpiddington@apple.com>
+
+        Regressions from ANGLE Metal enablement
+        https://bugs.webkit.org/show_bug.cgi?id=222239
+        
+        This patch addressed several large bits of funcitonality that was missing from the original patch.
+        1) Introduce support for UBO's. This patch adds a DEQP-conformant implementation for UBO structs. This includes changes to the translator,
+and the frontend.
+        2) Introduce support for Transform feedback to the translator. We use a series of substitution macros at program link time to produce a transform-feedback varient shader, and use a vertex pre-pass to emulate transform feedback.
+        3) Various fixes to handle a few webgl2 asserts, such as large uniform buffers. This change  (in ProgramMtl.mm) will reserve a uniform buffer of twice the normal size (4kb) if the program uniforms exceed that limit. (Fixes webgl/2.0.0/conformance/glsl/bugs/complex-glsl-does-not-crash.html webgl/2.0.0/conformance/glsl/misc/shader-with-too-many-uniforms.html webgl/2.0.0/conformance/uniforms/gl-uniform-arrays.html)
+
+        Reviewed by Jon Lee.
+
+        * ANGLE.xcodeproj/project.pbxproj:
+        * include/platform/FeaturesMtl.h:
+        * src/compiler.gni:
+        * src/compiler/translator/BaseTypes.h:
+        (sh::getQualifierString):
+        * src/compiler/translator/TranslatorMetalDirect.cpp:
+        (sh::TranslatorMetalDirect::insertSampleMaskWritingLogic):
+        (sh::metalShaderTypeFromGLSL):
+        (sh::TranslatorMetalDirect::translateImpl):
+        (sh::TranslatorMetalDirect::translate):
+        * src/compiler/translator/TranslatorMetalDirect.h:
+        (sh::TranslatorMetalReflection::TranslatorMetalReflection):
+        (sh::TranslatorMetalReflection::addUserUniformBufferBinding):
+        (sh::TranslatorMetalReflection::addUniformBufferBinding):
+        (sh::TranslatorMetalReflection::getUserUniformBufferBindings const):
+        (sh::TranslatorMetalReflection::getUserUniformBufferBinding const):
+        (sh::TranslatorMetalReflection::getUniformBufferBinding const):
+        (sh::TranslatorMetalReflection::reset):
+        * src/compiler/translator/TranslatorMetalDirect/EmitMetal.cpp:
+        (GenMetalTraverser::~GenMetalTraverser):
+        (GenMetalTraverser::emitOpeningPointerParen):
+        (GenMetalTraverser::emitClosingPointerParen):
+        (GetOperatorString):
+        (GenMetalTraverser::emitPostQualifier):
+        (GenMetalTraverser::emitType):
+        (GenMetalTraverser::emitFieldDeclaration):
+        (GenMetalTraverser::emitAttributeDeclaration):
+        (GenMetalTraverser::emitUniformBufferDeclaration):
+        (GenMetalTraverser::emitStructDeclaration):
+        (GenMetalTraverser::emitOrdinaryVariableDeclaration):
+        (GenMetalTraverser::visitSymbol):
+        (GenMetalTraverser::visitBinary):
+        (GenMetalTraverser::emitFunctionSignature):
+        (GenMetalTraverser::emitFunctionReturn):
+        (GenMetalTraverser::emitFunctionParameter):
+        (GenMetalTraverser::visitFunctionDefinition):
+        (GenMetalTraverser::visitAggregate):
+        (RequiresSemicolonTerminator):
+        (GenMetalTraverser::visitBlock):
+        (GenMetalTraverser::visitBranch):
+        * src/compiler/translator/TranslatorMetalDirect/FixTypeConstructors.cpp:
+        * src/compiler/translator/TranslatorMetalDirect/IntroduceVertexIndexID.cpp: Added.
+        (sh::Rewriter::Rewriter):
+        (sh::IntroduceVertexAndInstanceIndex):
+        * src/compiler/translator/TranslatorMetalDirect/IntroduceVertexIndexID.h: Added.
+        * src/compiler/translator/TranslatorMetalDirect/Layout.cpp:
+        * src/compiler/translator/TranslatorMetalDirect/Layout.h:
+        * src/compiler/translator/TranslatorMetalDirect/ModifyStruct.cpp:
+        (sh::TryCreateModifiedStruct):
+        * src/compiler/translator/TranslatorMetalDirect/ModifyStruct.h:
+        * src/compiler/translator/TranslatorMetalDirect/Pipeline.cpp:
+        (Pipeline::uses const):
+        (Pipeline::getStructTypeName const):
+        (Pipeline::getStructInstanceName const):
+        (AllowPacking):
+        (AllowPadding):
+        (SaturateVectorOf):
+        (Pipeline::externalStructModifyConfig const):
+        (Pipeline::alwaysRequiresLocalVariableDeclarationInMain const):
+        (Pipeline::isPipelineOut const):
+        (Pipeline::externalAddressSpace const):
+        (PipelineStructs::matches const):
+        * src/compiler/translator/TranslatorMetalDirect/Pipeline.h:
+        (sh::PipelineScoped::matches const):
+        * src/compiler/translator/TranslatorMetalDirect/ProgramPrelude.cpp:
+        (sh::ProgramPrelude::ProgramPrelude):
+        * src/compiler/translator/TranslatorMetalDirect/ProgramPrelude.h:
+        (sh::ProgramPreludeConfig::ProgramPreludeConfig):
+        * src/compiler/translator/TranslatorMetalDirect/ReduceInterfaceBlocks.cpp:
+        (sh::Reducer::Reducer):
+        * src/compiler/translator/TranslatorMetalDirect/RewritePipelines.cpp:
+        (sh::GeneratePipelineStruct::exec):
+        (sh::GeneratePipelineStruct::createInternalPipelineStruct):
+        (sh::PipelineFunctionEnv::getUpdatedFunction):
+        (sh::RewritePipelines):
+        * src/compiler/translator/TranslatorMetalDirect/SymbolEnv.cpp:
+        (SymbolEnv::removeSpace):
+        (SymbolEnv::removePointer):
+        (SymbolEnv::markAsUBO):
+        (SymbolEnv::isUBO const):
+        * src/compiler/translator/TranslatorMetalDirect/SymbolEnv.h:
+        * src/compiler/translator/tree_ops/NameNamelessUniformBuffers.cpp: Added.
+        (sh::NameNamelessUniformBuffers):
+        * src/compiler/translator/tree_ops/NameNamelessUniformBuffers.h: Added.
+        * src/compiler/translator/util.cpp:
+        (sh::IsBuiltinOutputVariable):
+        * src/libANGLE/renderer/gl/cgl/ContextCGL.cpp:
+        * src/libANGLE/renderer/metal/BufferMtl.h:
+        * src/libANGLE/renderer/metal/BufferMtl.mm:
+        (rx::IndexConversionBufferMtl::IndexConversionBufferMtl):
+        (rx::IndexConversionBufferMtl::getRangeForConvertedBuffer):
+        * src/libANGLE/renderer/metal/ContextMtl.h:
+        * src/libANGLE/renderer/metal/ContextMtl.mm:
+        (rx::ContextMtl::handleDirtyDriverUniforms):
+        (rx::ContextMtl::handleDirtyGraphicsTransformFeedbackBuffersEmulation):
+        (rx::ContextMtl::handleDirtyDepthBias):
+        * src/libANGLE/renderer/metal/DisplayMtl.mm:
+        (rx::DisplayMtl::getMaxSupportedESVersion const):
+        (rx::DisplayMtl::generateConfigs):
+        (rx::DisplayMtl::ensureCapsInitialized const):
+        (rx::DisplayMtl::initializeFeatures):
+        (rx::DisplayMtl::initializeShaderLibrary):
+        * src/libANGLE/renderer/metal/FrameBufferMtl.h:
+        * src/libANGLE/renderer/metal/ProgramMtl.h:
+        (rx::ProgramMtl::createMslShaderLib):
+        (rx::ProgramMtl::getXfbBindings const):
+        (rx::ProgramMtl::getTranslatedShaderSource const):
+        (rx::ProgramMtl::getXfbMslSource const): Deleted.
+        * src/libANGLE/renderer/metal/ProgramMtl.mm:
+        (rx::ProgramMtl::ProgramMtl):
+        (rx::ProgramMtl::destroy):
+        (rx::ProgramMtl::reset):
+        (rx::ProgramMtl::saveTranslatedShaders):
+        (rx::ProgramMtl::loadTranslatedShaders):
+        (rx::ProgramMtl::linkImplSpirv):
+        (rx::ProgramMtl::linkImplDirect):
+        (rx::ProgramMtl::linkImpl):
+        (rx::ProgramMtl::linkTranslatedShaders):
+        (rx::ProgramMtl::getBufferPool):
+        (rx::ProgramMtl::resizeDefaultUniformBlocksMemory):
+        (rx::ProgramMtl::getSpecializedShader):
+        (rx::ProgramMtl::createMslShaderLib):
+        (rx::ProgramMtl::commitUniforms):
+        * src/libANGLE/renderer/metal/QueryMtl.h:
+        * src/libANGLE/renderer/metal/RenderBufferMtl.mm:
+        (rx::RenderbufferMtl::setStorageImpl):
+        * src/libANGLE/renderer/metal/RenderTargetMtl.mm:
+        (rx::RenderTargetMtl::setWithImplicitMSTexture):
+        (rx::RenderTargetMtl::reset):
+        * src/libANGLE/renderer/metal/ShaderMtl.mm:
+        (rx::ShaderMtl::compile):
+        * src/libANGLE/renderer/metal/SurfaceMtl.mm:
+        (rx::WindowSurfaceMtl::initialize):
+        * src/libANGLE/renderer/metal/TextureMtl.mm:
+        (rx::TextureMtl::ensureSamplerStateCreated):
+        (rx::TextureMtl::setPerSliceSubImage):
+        (rx::TextureMtl::initializeContents):
+        * src/libANGLE/renderer/metal/TransformFeedbackMtl.mm:
+        * src/libANGLE/renderer/metal/VertexArrayMtl.mm:
+        (rx::VertexArrayMtl::getIndexBuffer):
+        * src/libANGLE/renderer/metal/mtl_common.h:
+        * src/libANGLE/renderer/metal/mtl_constants.h:
+        * src/libANGLE/renderer/metal/mtl_format_map.json:
+        * src/libANGLE/renderer/metal/mtl_format_table_autogen.mm:
+        (rx::mtl::Format::init):
+        * src/libANGLE/renderer/metal/mtl_format_utils.mm:
+        (rx::mtl::FormatTable::initialize):
+        * src/libANGLE/renderer/metal/mtl_glslang_mtl_utils.h:
+        * src/libANGLE/renderer/metal/mtl_glslang_mtl_utils.mm:
+        (rx::mtl::updateShaderAttributes):
+        (rx::mtl::SubstituteTransformFeedbackMarkers):
+        (rx::mtl::GenerateTransformFeedbackVaryingOutput):
+        (rx::mtl::GenerateTransformFeedbackEmulationOutputs):
+        (rx::mtl::getReflectionFromCompiler):
+        (rx::mtl::GlslangGetMSL):
+        * src/libANGLE/renderer/metal/mtl_render_utils.mm:
+        (rx::mtl::TransformFeedbackUtils::createMslXfbLibrary):
+        (rx::mtl::TransformFeedbackUtils::getTransformFeedbackRenderPipeline):
+        * src/libANGLE/renderer/metal/mtl_resources.h:
+        * src/libANGLE/renderer/metal/mtl_resources.mm:
+        (rx::mtl::Texture::Texture):
+        * src/libANGLE/renderer/metal/mtl_state_cache.mm:
+        (rx::mtl::SamplerDesc::SamplerDesc):
+        (rx::mtl::SamplerDesc::reset):
+        (rx::mtl::RenderPipelineCache::RenderPipelineCache):
+        (rx::mtl::RenderPipelineCache::createRenderPipelineState):
+        * src/libANGLE/renderer/metal/mtl_utils.h:
+        * src/libANGLE/renderer/metal/mtl_utils.mm:
+        (rx::mtl::GetUserSetOrHighestMSLVersion):
+        (rx::mtl::CreateShaderLibrary):
+        (rx::mtl::GetHighestSupportedMSLVersion): Deleted.
+        * src/libANGLE/renderer/metal/shaders/blit.metal:
+        * src/libANGLE/renderer/metal/shaders/format_autogen.h:
+        * src/libANGLE/renderer/metal/shaders/mtl_default_shaders_src_autogen.inc:
+
+2021-03-03  Kyle Piddington  <kpiddington@apple.com>
+
+        Support Depth24_Stencil8 simulation in the MTLSimulator
+        https://bugs.webkit.org/show_bug.cgi?id=222624
+
+        Reviewed by Dean Jackson.
+
+        Fixes the following tests:
+        fast/canvas/webgl/context-creation-attributes.html
+        fast/canvas/webgl/webgl-depth-texture.html
+        webgl/1.0.3/conformance/misc/webgl-specific.html
+        webgl/1.0.3/conformance/renderbuffers/framebuffer-object-attachment.html
+
+        * src/libANGLE/renderer/metal/mtl_format_map.json:
+        * src/libANGLE/renderer/metal/mtl_format_table_autogen.mm:
+        (rx::mtl::Format::init):
+
+2021-02-26  Kyle Piddington  <kpiddington@apple.com>
+
+        Support  fast/canvas/webgl/copyBufferSubData.html, fix bugs in fast/canvas/webgl/getBufferSubData-webgl1.html in Metal ANGLE on Simulator
+        https://bugs.webkit.org/show_bug.cgi?id=222508
+
+        Reviewed by Dean Jackson.
+
+        * src/libANGLE/renderer/metal/BufferMtl.mm:
+        (rx::BufferMtl::unmap):
+        * src/libANGLE/renderer/metal/DisplayMtl.mm:
+        (rx::DisplayMtl::getMaxSupportedESVersion const):
+
+2021-02-26  Kyle Piddington  <kpiddington@apple.com>
+
+        Fix iOS simulator crashes due to unsupported simulator pixel formats: r8Unorm_srgb, a1bgr5Unorm, b5g6r5Unorm, abgr4Unorm, bgr5A1Unorm, and program generation asserts.
+
+        iOS Simulator doesn't support the following packed 16 bit formats natively. While some of these can be emulated, we should fix up the crashing cases first.
+
+        Also fix up program generation issues for void fragment shaders
+
+        Disable support for PVRTC temporarily, as Non-square / NPOT PVRTC textures are not supported nativley on metal.
+
+        https://bugs.webkit.org/show_bug.cgi?id=222458
+
+        Reviewed by Dean Jackson.
+
+        * src/compiler/translator/TranslatorMetalDirect/EmitMetal.cpp:
+        (GenMetalTraverser::emitStructDeclaration):
+        (GenMetalTraverser::emitFunctionReturn):
+        (GenMetalTraverser::emitFunctionParameter):
+        * src/compiler/translator/TranslatorMetalDirect/Pipeline.cpp:
+        (PipelineStructs::matches const):
+        * src/compiler/translator/TranslatorMetalDirect/Pipeline.h:
+        (sh::PipelineScoped::matches const):
+        * src/libANGLE/renderer/metal/TextureMtl.mm:
+        (rx::TextureMtl::setPerSliceSubImage):
+        * src/libANGLE/renderer/metal/gen_mtl_format_table.py:
+        * src/libANGLE/renderer/metal/mtl_format_map.json:
+        * src/libANGLE/renderer/metal/mtl_format_table_autogen.mm:
+        (rx::mtl::Format::init):
+        (rx::mtl::VertexFormat::init):
+        (rx::mtl::FormatTable::initNativeFormatCapsAutogen):
+        * src/libANGLE/renderer/metal/mtl_format_utils.mm:
+        (rx::mtl::FormatTable::initialize):
+        * src/libANGLE/renderer/metal/mtl_resources.mm:
+        (rx::mtl::Texture::Make2DTexture):
+        (rx::mtl::Texture::MakeTexture):
+
+2021-02-26  Kimmo Kinnunen  <kkinnunen@apple.com>
+
+        Textures Fail to Render in WebGL from HLS Stream on iPhone 12 [iOS 14.2]
+        https://bugs.webkit.org/show_bug.cgi?id=218637
+        <rdar://problem/71102126>
+
+        Reviewed by Kenneth Russell.
+
+        Remove incorrect validation that IOSurface pixel format matches
+        the pixel format of the texture image being specified.
+
+        The "Element" in IOSurface is a block of pixels, while the validation assumed
+        it means one pixel. The validation failed for a compressed format.
+
+        Currently we map non-public YUV formats, to which there is no elequent way
+        of implementing the validation.
+        Most likely this started to reproduce if IOSurfaceGetBytesPerElementOfPlane
+        was changed to produce correct results for the above YUV format.
+
+        Later commits could add the validation back for formats that we know the
+        pixel format type.
+
+        * src/libANGLE/renderer/gl/eagl/IOSurfaceSurfaceEAGL.mm:
+        (rx::IOSurfaceSurfaceEAGL::validateAttributes):
+
+2021-02-25  Kyle Piddington  <kpiddington@apple.com>
+
+        Fix crashes in fast/canvas/webgl/texImage video tests
+        Refactor IOSurfaceSurfaceMtl to match open source implementation.
+        Additional cleanup
+
+        https://bugs.webkit.org/show_bug.cgi?id=222331
+
+        Reviewed by Dean Jackson.
+
+
+        * src/libANGLE/renderer/metal/ContextMtl.h:
+        * src/libANGLE/renderer/metal/ContextMtl.mm:
+        (rx::ContextMtl::onBackbufferResized):
+        * src/libANGLE/renderer/metal/DisplayMtl.mm:
+        (rx::DisplayMtl::createPbufferSurface):
+        (rx::DisplayMtl::createPbufferFromClientBuffer):
+        * src/libANGLE/renderer/metal/FrameBufferMtl.h:
+        (rx::FramebufferMtl::getAttachedBackbuffer const):
+        * src/libANGLE/renderer/metal/FrameBufferMtl.mm:
+        (rx::FramebufferMtl::FramebufferMtl):
+        * src/libANGLE/renderer/metal/IOSurfaceSurfaceMtl.h:
+        * src/libANGLE/renderer/metal/IOSurfaceSurfaceMtl.mm:
+        (rx::IOSurfaceSurfaceMtl::IOSurfaceSurfaceMtl):
+        (rx::IOSurfaceSurfaceMtl::~IOSurfaceSurfaceMtl):
+        (rx::IOSurfaceSurfaceMtl::bindTexImage):
+        (rx::IOSurfaceSurfaceMtl::releaseTexImage):
+        (rx::IOSurfaceSurfaceMtl::getAttachmentRenderTarget):
+        (rx::IOSurfaceSurfaceMtl::ensureColorTextureCreated):
+        (rx::IOSurfaceSurfaceMtl::ValidateAttributes):
+        * src/libANGLE/renderer/metal/SurfaceMtl.h:
+        (rx::SurfaceMtl::getColorTexture):
+        (rx::SurfaceMtl::getSamples const):
+        (rx::SurfaceMtl::hasRobustResourceInit const):
+        (rx::WindowSurfaceMtl::preserveBuffer const):
+        * src/libANGLE/renderer/metal/SurfaceMtl.mm:
+        (rx::SurfaceMtl::SurfaceMtl):
+        * src/libANGLE/renderer/metal/TextureMtl.h:
+        * src/libANGLE/renderer/metal/TextureMtl.mm:
+        (rx::TextureMtl::ensureTextureCreated):
+        (rx::TextureMtl::ensureSamplerStateCreated):
+        (rx::TextureMtl::bindTexImage):
+        (rx::TextureMtl::releaseTexImage):
+        (rx::TextureMtl::getAttachmentRenderTarget):
+        * src/libANGLE/renderer/metal/mtl_common.h:
+
+2021-02-19  Kyle Piddington  <kpiddington@apple.com>
+
+        Fix a number of functional regressions caused by enabling the Metal ANGLE backend by default.
+        https://bugs.webkit.org/show_bug.cgi?id=220895
+        <rdar://problem/73539537>
+
+        Reviewed by Kenneth Russell.
+
+        Take two of this commit - this time with the new files FixTypeConstructors and NameEmbeddedUniformStructsMetal.
+        
+        Fixed webgl/1.0.3/conformance/context/context-hidden-alpha.html
+
+        MTL Translator direct fixes for webgl/1.0.3/conformance/glsl/constructors/glsl-construct-*vec2 tests, Plus fix for GL_VertexIndex
+
+        Fix EmitMetal crash for missing function textureRect.
+
+        Additional fixes for 73675990, shaders-with-invariance.html, shaders-with-uniform-structs.html, struct-specifiers-in-uniforms.html, framebuffer-object-attachment.html
+
+        Fixed clamping of array elements.
+
+        * ANGLE.xcodeproj/project.pbxproj:
+        * src/compiler/translator/TranslatorMetalDirect.cpp:
+        (sh::TranslatorMetalDirect::translateImpl):
+        * src/compiler/translator/TranslatorMetalDirect/EmitMetal.cpp:
+        (GenMetalTraverser::emitPostQualifier):
+        (GenMetalTraverser::visitBinary):
+        (GenMetalTraverser::BuildFuncToName):
+        * src/compiler/translator/TranslatorMetalDirect/FixTypeConstructors.cpp: Added.
+        (sh::FixTypeTraverser::FixTypeTraverser):
+        (sh::FixTypeConstructors):
+        * src/compiler/translator/TranslatorMetalDirect/FixTypeConstructors.h: Added.
+        * src/compiler/translator/TranslatorMetalDirect/NameEmbeddedUniformStructsMetal.cpp: Added.
+        (sh::NameEmbeddedStructUniformsMetal):
+        * src/compiler/translator/TranslatorMetalDirect/NameEmbeddedUniformStructsMetal.h: Added.
+        * src/compiler/translator/TranslatorMetalDirect/Pipeline.cpp:
+        (SaturateVectorOf):
+        * src/compiler/translator/TranslatorMetalDirect/ProgramPrelude.cpp:
+        (sh::ProgramPrelude::ProgramPrelude):
+        * src/compiler/translator/TranslatorMetalDirect/ReduceInterfaceBlocks.cpp:
+        (sh::Reducer::Reducer):
+        (sh::ReduceInterfaceBlocks):
+        * src/compiler/translator/TranslatorMetalDirect/ReduceInterfaceBlocks.h:
+        * src/compiler/translator/TranslatorMetalDirect/SeparateCompoundStructDeclarations.cpp:
+        * src/libANGLE/renderer/load_functions_table_autogen.cpp:
+        * src/libANGLE/renderer/metal/ContextMtl.mm:
+        (rx::ContextMtl::drawElementsImpl):
+        * src/libANGLE/renderer/metal/IOSurfaceSurfaceMtl.h:
+        * src/libANGLE/renderer/metal/IOSurfaceSurfaceMtl.mm:
+        (rx::IOSurfaceSurfaceMtl::IOSurfaceSurfaceMtl):
+        (rx::IOSurfaceSurfaceMtl::createBackingTexture):
+        * src/libANGLE/renderer/metal/RenderBufferMtl.mm:
+        (rx::RenderbufferMtl::setStorageImpl):
+        * src/libANGLE/renderer/metal/VertexArrayMtl.h:
+        * src/libANGLE/renderer/metal/VertexArrayMtl.mm:
+        (rx::VertexArrayMtl::getIndexBuffer):
+        (rx::VertexArrayMtl::convertIndexBuffer):
+        (rx::VertexArrayMtl::streamIndexBufferFromClient):
+        * src/libANGLE/renderer/metal/mtl_utils.mm:
+        (rx::mtl::InitializeDepthStencilTextureContentsGPU):
+        * src/libANGLE/renderer/metal/shaders/blit.metal:
+        * src/libANGLE/renderer/metal/shaders/mtl_default_shaders_src_autogen.inc:
+
+2021-02-19  Chris Dumez  <cdumez@apple.com>
+
+        Unreviewed, reverting r273188.
+
+        Broke the build: Is missing a cpp file
+
+        Reverted changeset:
+
+        "Fix a number of functional regressions caused by enabling the
+        Metal ANGLE backend by default."
+        https://bugs.webkit.org/show_bug.cgi?id=220895
+        https://commits.webkit.org/r273188
+
+2021-02-19  Kyle Piddington  <kpiddington@apple.com>
+
+        Fix a number of functional regressions caused by enabling the Metal ANGLE backend by default.
+        https://bugs.webkit.org/show_bug.cgi?id=220895
+        <rdar://problem/73539537>
+
+        Reviewed by Kenneth Russell.
+
+        Fixed webgl/1.0.3/conformance/context/context-hidden-alpha.html
+
+        MTL Translator direct fixes for webgl/1.0.3/conformance/glsl/constructors/glsl-construct-*vec2 tests, Plus fix for GL_VertexIndex
+
+        Fix EmitMetal crash for missing function textureRect.
+
+        Additional fixes for 73675990, shaders-with-invariance.html, shaders-with-uniform-structs.html, struct-specifiers-in-uniforms.html, framebuffer-object-attachment.html
+
+        Fixed clamping of array elements.
+
+        * ANGLE.xcodeproj/project.pbxproj:
+        * src/compiler/translator/TranslatorMetalDirect.cpp:
+        (sh::TranslatorMetalDirect::translateImpl):
+        * src/compiler/translator/TranslatorMetalDirect/EmitMetal.cpp:
+        (GenMetalTraverser::emitPostQualifier):
+        (GenMetalTraverser::visitBinary):
+        (GenMetalTraverser::BuildFuncToName):
+        * src/compiler/translator/TranslatorMetalDirect/FixTypeConstructors.cpp: Added.
+        (sh::FixTypeTraverser::FixTypeTraverser):
+        (sh::FixTypeConstructors):
+        * src/compiler/translator/TranslatorMetalDirect/FixTypeConstructors.h: Added.
+        * src/compiler/translator/TranslatorMetalDirect/NameEmbeddedUniformStructsMetal.cpp: Added.
+        (sh::NameEmbeddedStructUniformsMetal):
+        * src/compiler/translator/TranslatorMetalDirect/NameEmbeddedUniformStructsMetal.h: Added.
+        * src/compiler/translator/TranslatorMetalDirect/Pipeline.cpp:
+        (SaturateVectorOf):
+        * src/compiler/translator/TranslatorMetalDirect/ProgramPrelude.cpp:
+        (sh::ProgramPrelude::ProgramPrelude):
+        * src/compiler/translator/TranslatorMetalDirect/ReduceInterfaceBlocks.cpp:
+        (sh::Reducer::Reducer):
+        (sh::ReduceInterfaceBlocks):
+        * src/compiler/translator/TranslatorMetalDirect/ReduceInterfaceBlocks.h:
+        * src/compiler/translator/TranslatorMetalDirect/SeparateCompoundStructDeclarations.cpp:
+        * src/libANGLE/renderer/load_functions_table_autogen.cpp:
+        * src/libANGLE/renderer/metal/ContextMtl.mm:
+        (rx::ContextMtl::drawElementsImpl):
+        * src/libANGLE/renderer/metal/IOSurfaceSurfaceMtl.h:
+        * src/libANGLE/renderer/metal/IOSurfaceSurfaceMtl.mm:
+        (rx::IOSurfaceSurfaceMtl::IOSurfaceSurfaceMtl):
+        (rx::IOSurfaceSurfaceMtl::createBackingTexture):
+        * src/libANGLE/renderer/metal/RenderBufferMtl.mm:
+        (rx::RenderbufferMtl::setStorageImpl):
+        * src/libANGLE/renderer/metal/VertexArrayMtl.h:
+        * src/libANGLE/renderer/metal/VertexArrayMtl.mm:
+        (rx::VertexArrayMtl::getIndexBuffer):
+        (rx::VertexArrayMtl::convertIndexBuffer):
+        (rx::VertexArrayMtl::streamIndexBufferFromClient):
+        * src/libANGLE/renderer/metal/mtl_utils.mm:
+        (rx::mtl::InitializeDepthStencilTextureContentsGPU):
+        * src/libANGLE/renderer/metal/shaders/blit.metal:
+        * src/libANGLE/renderer/metal/shaders/mtl_default_shaders_src_autogen.inc:
+
+2021-02-19  Kyle Piddington  <kpiddington@apple.com>
+
+        Crash in readPixels with ANGLE Metal backend
+        https://bugs.webkit.org/show_bug.cgi?id=220877
+
+        RenderbufferMtl::initializeContents is sometimes bound with a
+        default level index, which doesn't specify type, layer count, or
+        other information. When this path is called with an invalid index,
+        assume a 2d index.
+
+        Reviewed by Dean Jackson.
+
+        * src/libANGLE/renderer/metal/RenderBufferMtl.mm:
+        (rx::RenderbufferMtl::initializeContents):
+
+2021-02-17  Dean Jackson  <dino@apple.com>
+
+        Metal-Angle on IOS fails in ValidateCreatePbufferFromClientBuffer
+        https://bugs.webkit.org/show_bug.cgi?id=222069
+
+        Reviewed by Simon Fraser.
+
+        Due to the differences between OpenGL and OpenGLES, WebCore
+        binds its IOSurfaces to a different texture target on macOS and iOS.
+        This isn't really needed with the Metal-ANGLE backend, but while we're
+        still supporting the OpenGL backend it is easier to have the Metal backend
+        use both targets.
+
+        * src/libANGLE/renderer/metal/DisplayMtl.mm:
+        (rx::DisplayMtl::generateConfigs): Look for EGL_TEXTURE_2D on iOS. Note
+        we don't have to worry about the weird "iOS App on macOS" situation since
+        that only applies to using OpenGLES on macOS. Yay for Metal!
+
+2021-01-13  Kenneth Russell  <kbr@chromium.org>
+
+        [WebGL2] fbostatequery, negativebufferapi, negativevertexarrayapi, shaderstatequery conformance failures
+        https://bugs.webkit.org/show_bug.cgi?id=220372
+
+        Reviewed by Darin Adler.
+
+        Add a needed early-out in drawArraysInstanced validation when the
+        primitive count is zero. This patch will be upstreamed to ANGLE
+        afterward.
+
+        * src/libANGLE/validationES.h:
+        (gl::ValidateDrawArraysAttribs):
+        (gl::ValidateDrawArraysCommon):
+
+2021-01-08  Kyle Piddington  <kpiddington@apple.com>
+
+        Failures of attribute location conformance tests with Metal backend
+        https://bugs.webkit.org/show_bug.cgi?id=220137
+
+        Reviewed by Dean Jackson.
+
+        * src/compiler/translator/TranslatorMetalDirect/EmitMetal.cpp:
+        (GenMetalTraverser::emitAttributeDeclaration):
+        * src/libANGLE/renderer/metal/mtl_glslang_mtl_utils.mm:
+        (rx::mtl::updateShaderAttributes):
+        (rx::mtl::GlslangGetMSL):
+
+2021-01-04  Fujii Hironori  <Hironori.Fujii@sony.com>
+
+        [WinCairo][CMake][MSBuild][ANGLE] entry_points_*.h was generated twice both in LibGLESv2EntryPointsHeaders and GLESv2 projects
+        https://bugs.webkit.org/show_bug.cgi?id=220251
+
+        Reviewed by Kenneth Russell.
+
+        WinCairo port is supporting both CMake Visual Studio generator and
+        Ninja generator. However, CMake Visual Studio builds was failing
+        as the following error.
+
+        > ANGLE\Headers\ANGLE/entry_points_egl.h(13,10): fatal error C1083: Cannot open include file: 'export.h': No such file or directory (compiling source file ...\texmap\ANGLEContext.cpp)
+
+        entry_points_egl.h was generated twice both in
+        LibGLESv2EntryPointsHeaders and GLESv2 projects. However, the
+        post-process script adjust-angle-include-paths.py was invoked only
+        in LibGLESv2EntryPointsHeaders project.
+
+        GLESv2 target needs to have a direct or indirect dependency to
+        LibGLESv2EntryPointsHeaders target for CMake Visual Studio
+        generator to eliminate duplicated custom commands.
+
+        * CMakeLists.txt: Added add_dependencies(GLESv2 LibGLESv2EntryPointsHeaders) only if WIN32.
+
+2021-01-02  James Darpinian  <jdarpinian@chromium.org>
+
+        Enable some ANGLE workarounds on iOS
+        https://bugs.webkit.org/show_bug.cgi?id=220203
+
+        Reviewed by Kenneth Russell.
+
+        Running ANGLE's unit tests on iOS upstream exposed the need to enable a couple of existing
+        workaround flags. https://crrev.com/c/2601106 and https://crrev.com/c/2606657 are the
+        upstream changes corresponding to these fixes.
+
+        * src/libANGLE/renderer/gl/FramebufferGL.cpp:
+        (rx::FramebufferGL::blit):
+        * src/libANGLE/renderer/gl/renderergl_utils.cpp:
+        (rx::nativegl_gl::InitializeFeatures):
+
+2020-12-23  Kyle Piddington  <kpiddington@apple.com>
+
+        [ANGLE] Metal backend renders tdl.js samples as red
+        https://bugs.webkit.org/show_bug.cgi?id=220129
+
+        Reviewed by Kenneth Russell.
+
+        * src/libANGLE/renderer/metal/FrameBufferMtl.mm:
+        (rx::FramebufferMtl::blitWithDraw):
+
+2020-12-22  Michael Catanzaro  <mcatanzaro@gnome.org>
+
+        warning: enumerated and non-enumerated type in conditional expression in Compiler.cpp
+        https://bugs.webkit.org/show_bug.cgi?id=220062
+
+        Reviewed by Dean Jackson.
+
+        Building ANGLE with -Wextra is too aggressive. -Wextra is great for code that we control,
+        where the burden of squashing warnings is relatively low. But with ANGLE, we have to either
+        land fixes upstream, or carry them downstream forever. It doesn't make sense to bother with
+        this for minor build warning fixes when upstream is clearly not using the same warning flags
+        and/or same compiler that we do.
+
+        Since we add -Wextra in our global flags, we have to manually override it here. We can now
+        also stop explicitly disabling other warnings that are implied by -Wextra.
+
+        Finally, note that changes.diff is not modified because this is, confusingly, a downstream
+        WebKit build file.
+
+        * CMakeLists.txt:
+
+2020-12-22  Kenneth Russell  <kbr@chromium.org>
+
+        [WebGL2] deqp/functional/gles3/texturespecification RGB4444 and RGB565 failures on Mac AMD
+        https://bugs.webkit.org/show_bug.cgi?id=220093
+
+        Reviewed by Alex Christensen.
+
+        Promote the RGBA4444 and RGB565 texture formats to RGB[A]8 in
+        order to work around OpenGL driver bugs on macOS with AMD GPUs.
+
+        * include/platform/FeaturesGL.h:
+        * src/libANGLE/renderer/gl/formatutilsgl.cpp:
+        (rx::nativegl::GetNativeInternalFormat):
+        * src/libANGLE/renderer/gl/renderergl_utils.cpp:
+        (rx::nativegl_gl::InitializeFeatures):
+
+2020-12-16  Fujii Hironori  <Hironori.Fujii@sony.com>
+
+        [WinCairo] Enable USE_ANGLE
+        https://bugs.webkit.org/show_bug.cgi?id=219421
+
+        Reviewed by Don Olmstead.
+
+        * CMakeLists.txt: Added entry_points_egl_ext.h to libglesv2_entry_points_headers.
+
+2020-12-14  Alex Christensen  <achristensen@webkit.org>
+
+        Fix build.
+
+        * src/gpu_info_util/SystemInfo_apple.mm:
+        (angle::GetSystemInfo):
+        ##if should be #if
+
+2020-12-14  Dean Jackson  <dino@apple.com>
+
+        Build fix for Mac Catalyst. Remove code that was accidentally
+        included in the previous commit.
+
+        * src/gpu_info_util/SystemInfo_apple.mm:
+        (angle::GetSystemInfo):
+
+2020-12-12  Kyle Piddington  <kpiddington@apple.com>
+
+        Improved Metal backend for ANGLE, with direct GLSL to Metal compiler translation
+        https://bugs.webkit.org/show_bug.cgi?id=219759
+        <rdar://problem/72200222>
+
+        Reviewed by Dean Jackson.
+
+        Reviewer's note: While this patch is landing in WebKit now, it will
+        be submitted to the main ANGLE project for official review, then re-merged
+        back into WebKit. The feature provided here is not enabled by default.
+
+        Provide a WebGL1 compliant transpiler for GLSL content. With this
+        change, we can leverage the already present open source work in the
+        ANGLE project to enable webgl to run on top of Metal. In addition,
+        this patch contains a number of fixes to the existing ANGLE Metal backend.
+
+        Test: Tests were validated with the dEQP test suite with ANGLE, in
+        addition to running standard layout tests.
+
+2020-12-04  Adam Roben  <aroben@apple.com>
+
+        More FALLBACK_PLATFORM adoption
+        https://bugs.webkit.org/show_bug.cgi?id=219545
+
+        Reviewed by Tim Horton.
+
+        * Configurations/SDKVariant.xcconfig:
+        WK_EMPTY_$(THIS_IS_NOT_EMPTY) evaluates to the empty string, not to
+        NO.
+
+2020-12-04  Rob Buis  <rbuis@igalia.com>
+
+        WebGL2: Null pointer dereference in std::string implementation in gl::Shader::getTransformFeedbackVaryingMappedName
+        https://bugs.webkit.org/show_bug.cgi?id=218602
+
+        Reviewed by Dean Jackson.
+
+        Skip varying if field is not found since in this
+        case we have no match for the varying parameter name.
+
+        * src/libANGLE/Shader.cpp:
+        (gl::Shader::getTransformFeedbackVaryingMappedName):
+
+2020-12-03  Adam Roben  <aroben@apple.com>
+
+        Adopt FALLBACK_PLATFORM
+        https://bugs.webkit.org/show_bug.cgi?id=219504
+
+        Reviewed by Tim Horton.
+
+        * Configurations/SDKVariant.xcconfig: Use FALLBACK_PLATFORM it if it's
+        defined, otherwise use PLATFORM_NAME as before.
+
+2020-12-02  Dean Jackson  <dino@apple.com>
+
+        Build fix for Mac Catalyst. Include the SystemInfo header.
+
+        * src/libANGLE/renderer/gl/apple/DisplayApple_api.cpp:
+
+2020-12-02  Rob Buis  <rbuis@igalia.com>
+
+        Fix ANGLE CMakeLists.txt warnings
+        https://bugs.webkit.org/show_bug.cgi?id=219260
+
+        Reviewed by Philippe Normand.
+
+        Fix warning when building on GTK:
+        Make Warning (dev) at Source/ThirdParty/ANGLE/CMakeLists.txt:103:
+        Syntax Warning in cmake code at column 37
+
+        Argument not separated from preceding token by whitespace.
+        This warning is for project developers.  Use -Wno-dev to suppress it.
+
+        * CMakeLists.txt:
+
+2020-12-02  James Darpinian  <jdarpinian@chromium.org>
+
+        Update ANGLE 2020-11-12
+        https://bugs.webkit.org/show_bug.cgi?id=218877
+
+        Reviewed by Kenneth Russell.
+
+        * Excessively large list of upstream changes omitted.
+
+2020-11-30  Ryan Haddad  <ryanhaddad@apple.com>
+
+        Unreviewed, reverting r270129, r270194, and r270258.
+
+        r270129 broke macCatalyst build
+
+        Reverted changesets:
+
+        "Update ANGLE 2020-11-12"
+        https://bugs.webkit.org/show_bug.cgi?id=218877
+        https://trac.webkit.org/changeset/270129
+
+        "Fix ANGLE CMakeLists.txt warnings"
+        https://bugs.webkit.org/show_bug.cgi?id=219260
+        https://trac.webkit.org/changeset/270194
+
+        "Attempted build fix for Mac Catalyst. Include the SystemInfo
+        header."
+        https://trac.webkit.org/changeset/270258
+
+2020-11-30  Dean Jackson  <dino@apple.com>
+
+        Attempted build fix for Mac Catalyst. Include the SystemInfo header.
+
+        * src/libANGLE/renderer/gl/apple/DisplayApple_api.cpp:
+
+2020-11-27  Fujii Hironori  <Hironori.Fujii@sony.com>
+
+        [ANGLE] Convert adjust-angle-include-paths.sh to a Python script for Windows without Cygwin
+        https://bugs.webkit.org/show_bug.cgi?id=219299
+
+        Reviewed by Kenneth Russell.
+
+        WinCairo port can't use shell scripts because it isn't using
+        Cygwin.
+
+        * ANGLE.xcodeproj/project.pbxproj:
+        * CMakeLists.txt:
+        * adjust-angle-include-paths.py: Added.
+        * adjust-angle-include-paths.sh: Removed.
+
+2020-11-27  Rob Buis  <rbuis@igalia.com>
+
+        Fix ANGLE CMakeLists.txt warnings
+        https://bugs.webkit.org/show_bug.cgi?id=219260
+
+        Reviewed by Philippe Normand.
+
+        Fix warning when building on GTK:
+        Make Warning (dev) at Source/ThirdParty/ANGLE/CMakeLists.txt:103:
+        Syntax Warning in cmake code at column 37
+
+        Argument not separated from preceding token by whitespace.
+        This warning is for project developers.  Use -Wno-dev to suppress it.
+
+        * CMakeLists.txt:
+
+2020-11-20  James Darpinian  <jdarpinian@chromium.org>
+
+        Update ANGLE 2020-11-12
+        https://bugs.webkit.org/show_bug.cgi?id=218877
+
+        Reviewed by Kenneth Russell.
+
+        * Excessively large list of upstream changes omitted.
+
+2020-11-19  James Darpinian  <jdarpinian@chromium.org>
+
+        Improve update-angle script and move to Tools/Scripts
+        https://bugs.webkit.org/show_bug.cgi?id=218831
+
+        Reviewed by Kenneth Russell.
+
+        update-angle fetches changes from upstream ANGLE into Source/ThirdParty/ANGLE,
+        updates WebKit's build files and helps merge WebKit's local changes.
+
+          - Moved to Tools/Scripts so that it doesn't overwrite itself during the
+            update process.
+          - Reversed direction of rebase. Before the script rebased ANGLE on WebKit;
+            now it rebases WebKit's ANGLE changes on upstream ANGLE master. This
+            makes a lot more sense and results in fewer changes to rebase. This
+            requires the use of git-filter-repo to make the rebase not prohibitively
+            slow.
+          - Removed bash dependency.
+          - Fixed all issues identified by shellcheck.
+          - Fixed changes.diff to show added files, while filtering files added by
+            WebKit's build process.
+          - Fixed changes.diff to ignore whitespace changes.
+          - Added --regenerate-changes-diff option to update changes.diff in between
+            ANGLE updates.
+          - Updated [angle_]commit.h generation for upstream changes.
+          - Removed need to run the script multiple times during the rebase process.
+
+        * update-angle.sh: Removed.
+
+2020-11-19  Dean Jackson  <dino@apple.com>
+
+        Add schemes for ANGLE to Xcode project
+        https://bugs.webkit.org/show_bug.cgi?id=217546
+        rdar://69062082
+
+        Reviewed by Alex Christensen.
+
+        * Configurations/Base.xcconfig: Update paths for built frameworks.
+        * ANGLE.xcodeproj/xcshareddata/xcschemes/ANGLE (dynamic).xcscheme: Added.
+        * ANGLE.xcodeproj/xcshareddata/xcschemes/ANGLE (static).xcscheme: Added.
+        * ANGLE.xcodeproj/xcshareddata/xcschemes/ANGLE.xcscheme: Added.
+
+2020-11-04  David Kilzer  <ddkilzer@apple.com>
+
+        WebKit should remove unused debug variant support
+        <https://webkit.org/b/218315>
+        <rdar://problem/70785369>
+
+        Reviewed by Darin Adler.
+
+        Remove support for building the debug variant since it is
+        currently unused. We now set default values for the
+        DEAD_CODE_STRIPPING, DEBUG_DEFINES, GCC_OPTIMIZATION_LEVEL and
+        STRIP_INSTALLED_PRODUCT variables.
+
+        Also move these values out of the Xcode project into
+        Base.xcconfig files using the [config=Debug] specifier so that
+        these overrides are next to the definitions.
+
+        Additional changes in behavior are noted below.
+
+        * Configurations/ANGLE-dynamic.xcconfig:
+        - Move DEBUG_DEFINES to Base.xcconfig.
+        - Set up DEAD_CODE_STRIPPING and STRIP_INSTALLED_PRODUCT the
+          same as for other WebKit projects. Previously dead code and
+          symbols were never stipped in Release or Production builds.
+
+        * Configurations/ANGLE-static.xcconfig:
+        - Move DEBUG_DEFINES to Base.xcconfig.
+
+        * Configurations/Base.xcconfig:
+        - Set up DEBUG_DEFINES and GCC_OPTIMIZATION_LEVEL the same as
+          other WebKit projects. Previously Debug builds were built with
+          -Os instead of -O0.
+
+2020-11-03  David Kilzer  <ddkilzer@apple.com>
+
+        Stop building ANGLE source files twice
+        <https://webkit.org/b/218469>
+
+        Reviewed by Dean Jackson.
+
+        * ANGLE.xcodeproj/project.pbxproj:
+        (ANGLE (dynamic)):
+        - Replace sources with empty.cpp. Xcode requires a single source
+          file to be compiled to create a dylib, even if the static
+          library contains all necessary symbols.
+        - Add dependency on "ANGLE (static)" target.
+        * Configurations/ANGLE-dynamic.xcconfig:
+        (ANGLE_OTHER_LDFLAGS):
+        - Add $(ANGLE_STATIC_LIB_OTHER_LDFLAGS).
+        (ANGLE_STATIC_LIB_OTHER_LDFLAGS): Add.
+        - Special linker command-line switch to load all symbols from
+          libANGLE.a when linking libANGLE-shared.dylib.
+        * src/empty.cpp: Add.
+        - See above why this is needed by Xcode.
+
+2020-10-12  Dean Jackson  <dino@apple.com>
+
+        Add schemes for ANGLE to Xcode project
+        https://bugs.webkit.org/show_bug.cgi?id=217546
+        rdar://69062082
+
+        Reviewed by Alex Christensen.
+
+        * ANGLE.xcodeproj/xcshareddata/xcschemes/ANGLE (dynamic).xcscheme: Added.
+        * ANGLE.xcodeproj/xcshareddata/xcschemes/ANGLE (static).xcscheme: Added.
+        * ANGLE.xcodeproj/xcshareddata/xcschemes/ANGLE.xcscheme: Added.
+
+2020-10-28  Tim Horton  <timothy_horton@apple.com>
+
+        macCatalyst WebGL on Apple Silicon devices is using a software renderer
+        https://bugs.webkit.org/show_bug.cgi?id=218303
+        <rdar://problem/70587571>
+
+        Reviewed by Geoffrey Garen.
+
+        * src/gpu_info_util/SystemInfo.h:
+        * src/gpu_info_util/SystemInfo_apple.mm:
+        (angle::GetSystemInfo):
+        We can just use the macOS version of GetSystemInfo in macCatalyst.
+
+        * src/gpu_info_util/SystemInfo_macos.mm:
+        (angle::GetSystemInfo_mac):
+        * src/libANGLE/Display.cpp:
+        * src/libANGLE/formatutils.cpp:
+        (gl::BuildInternalFormatInfoMap):
+        * src/libANGLE/renderer/gl/renderergl_utils.cpp:
+        (rx::nativegl_gl::GenerateCaps):
+        It turns out we must use EAGL in macCatalyst on Apple Silicon in all cases,
+        not just in-process in iOS apps (the problem is not just about coexistence
+        of the two GLs, but actually about our ability to load the accelerated
+        renderer /at all/ in macCatalyst processes).
+
+        I left the runtime switching in place, because there is a future in which
+        we /can/ use CGL in non-iOS-app processes, but that future is not now.
+
+2020-10-13  Keith Rollin  <krollin@apple.com>
+
+        Remove leftover MACOSX_DEPLOYMENT_TARGET_macosx support
+        https://bugs.webkit.org/show_bug.cgi?id=217649
+        <rdar://problem/70236877>
+
+        Reviewed by Darin Adler.
+
+        Bug 42796 introduced MACOSX_DEPLOYMENT_TARGET_<PLATFORM> as "support
+        for compiling WebKit against iOS SDKs". Support for the iOS part of
+        this feature was later removed in several changes, including Bug
+        139212, Bug 139463 and Bug 144762. However, vestiges have remained for
+        five or six years in the form of MACOSX_DEPLOYMENT_TARGET_macosx. The
+        inclusion of the platform in MACOSX_DEPLOYMENT_TARGET is no longer
+        needed and can be removed.
+
+        This changes brings most projects in conformance with other projects
+        that don't support including the platform in MACOSX_DEPLOYMENT_TARGET,
+        including WebEditingTester, gtest, WebKitTestRunner, MiniBrowser, and
+        TestWebKitAPI.
+
+        Along the way, remove a couple of left-over references to macOS 10.16,
+        and a couple of places where [sdk=macosx*] was still being used.
+
+        With this change, initialization of MACOSX_DEPLOYMENT_TARGET should be
+        consistent across all projects, with two exceptions: WebKitLauncher
+        (which hardcodes it to 10.12) and libwebrtc's copy of googletest
+        (which hardcodes it to 10.4). The reasons for these hard-coded values
+        is not apparent, so leave them be.
+
+        * Configurations/DebugRelease.xcconfig:
+
+2020-10-12  Luming Yin  <luming_yin@apple.com>
+
+        [macOS] Workaround for MAC_OS_X_VERSION_MAJOR incorrectly including minor version when building 
+        with Xcode 12 on macOS Big Sur SUs
+        https://bugs.webkit.org/show_bug.cgi?id=217602
+        rdar://70194453
+
+        Reviewed by Darin Adler.
+
+        The previous workaround turns out to be ineffective because we can't set the value of 
+        TARGET_MAC_OS_X_VERSION_MAJOR based on a previous value of itself. Introduce a new 
+        variable TARGET_MAC_OS_X_VERSION_MAJOR to determine whether we need to explicitly 
+        adjust MAC_OS_X_VERSION_MAJOR to 110000.
+
+        * Configurations/DebugRelease.xcconfig:
+
+2020-10-12  Luming Yin  <luming_yin@apple.com>
+
+        [macOS] Workaround for MAC_OS_X_VERSION_MAJOR incorrectly including minor version when building 
+        with Xcode 12 on macOS Big Sur SUs
+        https://bugs.webkit.org/show_bug.cgi?id=217602
+        rdar://70194453
+
+        Reviewed by Darin Adler.
+
+        Due to a bug in Xcode (rdar://70185899), Xcode 12.0 and Xcode 12.1 Beta incorrectly includes the 
+        minor release number in MAC_OS_X_VERSION_MAJOR, which causes Debug and Release builds of WebKit 
+        to be misconfigured when building on macOS Big Sur SUs, leading to webpages failing to load.
+
+        To work around the Xcode bug, when the MAC_OS_X_VERSION_MAJOR includes the minor version number, 
+        drop the minor version number by explicitly setting TARGET_MAC_OS_X_VERSION_MAJOR to 110000.
+
+        Note: This change should be reverted after <rdar://70185899> is resolved.
+
+        * Configurations/DebugRelease.xcconfig:
+
+2020-10-11  Luming Yin  <luming_yin@apple.com>
+
+        Strip patch version from TARGET_MAC_OS_X_VERSION_MAJOR when building for macOS Big Sur 
+        or later
+        https://bugs.webkit.org/show_bug.cgi?id=217594
+        rdar://70188497
+
+        Reviewed by Darin Adler.
+
+        To ensure successful Mac Catalyst WebKit builds, strip the patch version from 
+        TARGET_MAC_OS_X_VERSION_MAJOR by using two `base:`s on MACOSX_DEPLOYMENT_TARGET.
+
+        * Configurations/Base.xcconfig:
+
+2020-10-11  Luming Yin  <luming_yin@apple.com>
+
+        Ignore deployment suffix and identifier when computing major OS version for macOS 
+        Big Sur and newer
+        https://bugs.webkit.org/show_bug.cgi?id=217584
+        rdar://70168426
+
+        Reviewed by Darin Adler.
+
+        Stop using MACOSX_DEPLOYMENT_TARGET:suffix:identifier to compute major OS versions. 
+        Only use the deployment target base for macOS Big Sur and newer. Keep the manual 
+        definitions for legacy versions of macOS.
+
+        * Configurations/Base.xcconfig:
+
+2020-10-07  Keith Rollin  <krollin@apple.com>
+
+        Update post-processing rules for headers to not unnecessarily change timestamps
+        https://bugs.webkit.org/show_bug.cgi?id=217371
+        <rdar://problem/69992230>
+
+        Reviewed by Darin Adler.
+
+        Under XCBuild, the scripts employed in custom build rules can be
+        invoked in innocuous situations. A common example is when the user is
+        building from the command-line and they change the `make` output from
+        stdout to a file, or vice-versa. Changing the output changes the
+        setting of the COLOR_DIAGNOSTICS environment variable, which is enough
+        to cause XCBuild to think something is different and that the custom
+        build rule needs to be invoked. For the script's part, nothing
+        significant has changed, yet it post-processes the header files,
+        causing their modification dates to change, causing downstream
+        rebuilds to occur.
+
+        Fix this problem by adopting an approach that doesn't modify the
+        post-processed header files unless their contents actually change.
+
+        * adjust-angle-include-paths-rule:
+
+2020-10-02  Kimmo Kinnunen  <kkinnunen@apple.com>
+
+        [iOS WK1] Crashes when using ANGLE WebGL from another thread
+        https://bugs.webkit.org/show_bug.cgi?id=216106
+        <rdar://problem/68602452>
+
+        Reviewed by Kenneth Russell.
+
+        Add two extensions for EAGL and CGL backends to declare the
+        underlying platform context being "volatile". It means that
+        the thread-global current context is being modified behind
+        ANGLE. If ANGLE context is marked volatile for a particular
+        API, it will sync the underlying context for every EGL
+        function that needs the context. Most intuitive use is
+        for the client to call eglMakeCurrent before calling any
+        gl function if the client knowns the platform state might
+        be dirty.
+
+        Implement eglReleaseThread for EAGL and CGL backends.
+        Releasing thread will unset the platform current context.
+
+        Fix a bug of omitting EGL_ANGLE_device_eagl from being
+        advertised.
+
+        * extensions/EGL_ANGLE_platform_angle_device_context_volatile_cgl.txt: Added.
+        * extensions/EGL_ANGLE_platform_angle_device_context_volatile_eagl.txt: Added.
+        * include/EGL/eglext_angle.h:
+        * src/libANGLE/Caps.cpp:
+        (egl::DeviceExtensions::getStrings const):
+        (egl::ClientExtensions::getStrings const):
+        * src/libANGLE/Caps.h:
+        * src/libANGLE/Display.cpp:
+        (egl::Display::prepareForCall):
+        (egl::Display::releaseThread):
+        (egl::GenerateClientExtensions):
+        * src/libANGLE/Display.h:
+        * src/libANGLE/renderer/DisplayImpl.cpp:
+        (rx::DisplayImpl::prepareForCall):
+        (rx::DisplayImpl::releaseThread):
+        * src/libANGLE/renderer/DisplayImpl.h:
+        * src/libANGLE/renderer/gl/cgl/DisplayCGL.h:
+        * src/libANGLE/renderer/gl/cgl/DisplayCGL.mm:
+        (rx::DisplayCGL::initialize):
+        (rx::DisplayCGL::terminate):
+        (rx::DisplayCGL::prepareForCall):
+        (rx::DisplayCGL::releaseThread):
+        (rx::DisplayCGL::makeCurrent):
+        * src/libANGLE/renderer/gl/eagl/DisplayEAGL.h:
+        * src/libANGLE/renderer/gl/eagl/DisplayEAGL.mm:
+        (rx::DisplayEAGL::initialize):
+        (rx::DisplayEAGL::terminate):
+        (rx::DisplayEAGL::prepareForCall):
+        (rx::DisplayEAGL::releaseThread):
+        * src/libANGLE/validationEGL.cpp:
+        * src/libGLESv2/entry_points_egl.cpp:
+        * src/libGLESv2/entry_points_egl_ext.cpp:
+
+2020-09-29  James Darpinian  <jdarpinian@chromium.org>
+
+        Fix EXT_color_buffer_half_float on iOS
+        https://bugs.webkit.org/show_bug.cgi?id=217107
+
+        Reviewed by Kenneth Russell.
+
+        * src/libANGLE/Context.cpp:
+        (gl::Context::generateSupportedExtensions const):
+        * src/libANGLE/renderer/gl/renderergl_utils.cpp:
+        (rx::nativegl_gl::GenerateTextureFormatCaps):
+
+2020-09-24  Dean Jackson  <dino@apple.com>
+
+        WebGL should use GLES in iOS apps running on Apple Silicon
+        https://bugs.webkit.org/show_bug.cgi?id=216722
+        <rdar://problem/68976337>
+
+        Reviewed by Tim Horton.
+
+        Change ANGLE to dynamically load either EAGL (OpenGLES) or CGL (OpenGL) depending
+        on both compile and runtime configurations.
+            Intel Mac -> CGL
+            Intel Mac Catalyst -> CGL
+            Intel iOS Simulator -> EAGL
+            iOS Device -> EAGL
+            Apple Silicon Mac -> CGL
+            Apple Silicon Mac Catalyst (with Mac app) -> CGL
+            Apple Silicon Mac Catalyst (with iOS app) -> EAGL
+
+        The trickiest bit is Apple Silicon Mac Catalyst, which depends on the
+        type of the application it is attempting to run. In that case ANGLE must compile
+        both the CGL and EAGL interfaces and then pick one to use after launch.
+
+        * ANGLE.xcodeproj/project.pbxproj: Add new files.
+
+        * Configurations/ANGLE-dynamic.xcconfig: Remove all the OpenGL* linking.
+        * Configurations/ANGLE-static.xcconfig:
+
+        * GLESv2.cmake: New files.
+
+        * src/common/platform.h: New definitions for CPU type on Apple Systems.
+
+        * src/gpu_info_util/SystemInfo.h: Split SystemInfo for Apple into two
+        files, for iOS and Mac. Added a field for isiOSAppOnMac that will only
+        be true when running an iOS binary on Apple Silicon.
+        * src/gpu_info_util/SystemInfo_apple.mm: Added. Decides which SystemInfo
+        to call.
+        (angle::GetSystemInfo):
+        * src/gpu_info_util/SystemInfo_ios.cpp:
+        (angle::GetSystemInfo_ios):
+        (angle::GetSystemInfo): Deleted.
+        * src/gpu_info_util/SystemInfo_macos.mm:
+        (angle::GetSystemInfo_mac):
+        (angle::GetSystemInfo): Deleted.
+
+        * src/libANGLE/Caps.cpp: Can no longer just check for PLATFORM_IOS. This
+        might still need a runtime check.
+        (gl::DetermineDepthTextureANGLESupport):
+        (gl::DetermineDepthTextureOESSupport):
+
+        * src/libANGLE/Display.cpp: This is the main initialization point for
+        ANGLE, which decides at compile/runtime which variant of Display to
+        create.
+
+        * src/libANGLE/formatutils.cpp: Add the correct formats.
+        (gl::BuildInternalFormatInfoMap):
+
+        * src/libANGLE/renderer/gl/SoftLinking_apple.h: Added. Macros to help soft-link
+        functions and ObjC classes.
+        * src/libANGLE/renderer/gl/cgl/CGLFunctions.cpp: Added. Where we soft-link all
+        the OpenGL/CGL API.
+        * src/libANGLE/renderer/gl/cgl/CGLFunctions.h: Added.
+
+        * src/libANGLE/renderer/gl/cgl/DisplayCGL.mm: Use the soft-linked methods.
+        * src/libANGLE/renderer/gl/cgl/IOSurfaceSurfaceCGL.cpp:
+        * src/libANGLE/renderer/gl/cgl/WindowSurfaceCGL.h:
+        * src/libANGLE/renderer/gl/cgl/WindowSurfaceCGL.mm: Rename WebSwapLayer to WebSwapLayerCGL
+        otherwise it clashes with the EAGL version.
+        (rx::WindowSurfaceCGL::initialize):
+        (-[WebSwapLayer initWithSharedState:withContext:withFunctions:]): Deleted.
+        (-[WebSwapLayer copyCGLPixelFormatForDisplayMask:]): Deleted.
+        (-[WebSwapLayer copyCGLContextForPixelFormat:]): Deleted.
+        (-[WebSwapLayer canDrawInCGLContext:pixelFormat:forLayerTime:displayTime:]): Deleted.
+        (-[WebSwapLayer drawInCGLContext:pixelFormat:forLayerTime:displayTime:]): Deleted.
+
+        * src/libANGLE/renderer/gl/eagl/DeviceEAGL.cpp: Similar changes to the CGL implementation.
+        * src/libANGLE/renderer/gl/eagl/DeviceEAGL.h:
+        * src/libANGLE/renderer/gl/eagl/DisplayEAGL.h:
+        * src/libANGLE/renderer/gl/eagl/DisplayEAGL.mm:
+        (rx::DisplayEAGL::initialize):
+        (rx::DisplayEAGL::terminate):
+        (rx::WorkerContextEAGL::~WorkerContextEAGL):
+        (rx::WorkerContextEAGL::makeCurrent):
+        (rx::WorkerContextEAGL::unmakeCurrent):
+        (rx::DisplayEAGL::createWorkerContext):
+        * src/libANGLE/renderer/gl/eagl/EAGLFunctions.h: Added.
+        * src/libANGLE/renderer/gl/eagl/EAGLFunctions.mm: Added.
+        * src/libANGLE/renderer/gl/eagl/IOSurfaceSurfaceEAGL.mm:
+        * src/libANGLE/renderer/gl/eagl/PbufferSurfaceEAGL.cpp:
+        * src/libANGLE/renderer/gl/eagl/RendererEAGL.cpp:
+        * src/libANGLE/renderer/gl/eagl/WindowSurfaceEAGL.h:
+        * src/libANGLE/renderer/gl/eagl/WindowSurfaceEAGL.mm:
+        (-[WebSwapLayerEAGL display]):
+        (rx::WindowSurfaceEAGL::initialize):
+        (-[WebSwapLayer initWithSharedState:withContext:withFunctions:]): Deleted.
+        (-[WebSwapLayer display]): Deleted.
+
+        * src/libANGLE/renderer/gl/renderergl_utils.cpp: Runtime check.
+        (rx::nativegl_gl::GenerateCaps):
+
+2020-09-25  James Darpinian  <jdarpinian@chromium.org>
+
+        Support EXT_float_blend
+        https://bugs.webkit.org/show_bug.cgi?id=216949
+
+        Reviewed by Kenneth Russell.
+
+        * src/libANGLE/renderer/gl/renderergl_utils.cpp:
+        (rx::nativegl_gl::GenerateCaps):
+
+2020-09-24  Kimmo Kinnunen  <kkinnunen@apple.com>
+
+        REGRESSION: Textures Fail to Render in WebGL from HLS Stream [iOS 14]
+        https://bugs.webkit.org/show_bug.cgi?id=215908
+        <rdar://problem/68000962>
+
+        Reviewed by Dean Jackson.
+
+        Disable ANGLE workers until EAGL implementation is more complete.
+        Current implementation fails to compile any shader, since the
+        compilation happens in the worker thread and worker EAGL context
+        which does not use the same sharegroup as the main context.
+        The shader objects are created in the main context but the shader
+        source setting and compilation happens in the worker context.
+        EAGL needs a flush between state changes, and adding that
+        correctly is a bigger change to be done later.
+
+        Use sized formats when calling [EAGLContext -texImageIOSurface]
+        from EGL_ANGLE_iosurface_client_buffer code. The texImageIOSurface
+        accepts parameters with glTexImage2D logic. On ES3, some of the
+        internal formats must be sized formats. The EAGLContext instantiated
+        by ANGLE is ES3, even if the ANGLE context would be ES2.
+
+        No tests added since this should be caught with the many video
+        related tests. It's unclear why this is not the case -- at
+        least on real hw. This is to be investigated later, too.
+
+        * src/libANGLE/renderer/driver_utils.h:
+        (rx::IsIOS):
+        * src/libANGLE/renderer/gl/eagl/IOSurfaceSurfaceEAGL.mm:
+        * src/libANGLE/renderer/gl/renderergl_utils.cpp:
+        (rx::nativegl_gl::InitializeFeatures):
+
+2020-09-11  James Darpinian  <jdarpinian@chromium.org>
+
+        [WebGL2] Support EXT_color_buffer_half_float on WebGL 2.0 contexts
+        https://bugs.webkit.org/show_bug.cgi?id=216010
+
+        Reviewed by Kenneth Russell.
+
+        * src/libANGLE/formatutils.cpp:
+        (gl::SizedHalfFloatRGTextureAttachmentSupport):
+        (gl::SizedHalfFloatRGBTextureAttachmentSupport):
+        (gl::SizedHalfFloatRGBRenderbufferSupport):
+        (gl::SizedHalfFloatRGBATextureAttachmentSupport):
+
+2020-09-03  Kimmo Kinnunen  <kkinnunen@apple.com>
+
+        Mark uniform samplers in an array unused per element
+        https://bugs.webkit.org/show_bug.cgi?id=215630
+
+        Reviewed by Dean Jackson.
+
+        Mark uniform samplers in an uniform sampler array unused per
+        element, if driver informs the element being unused.
+        Before, one element would mark the whole array as being
+        unused, and samplers that were in use would not be updated.
+
+        * src/libANGLE/Context.cpp:
+        (gl::StateCache::updateActiveImageUnitIndices):
+        * src/libANGLE/Program.cpp:
+        (gl::SamplerBinding::SamplerBinding):
+        (gl::ImageBinding::ImageBinding):
+        (gl::Program::getSamplerUniformBinding const):
+        (gl::Program::getImageUniformBinding const):
+        (gl::Program::linkSamplerAndImageBindings):
+        (gl::Program::updateSamplerUniform):
+        (gl::Program::serialize const):
+        (gl::Program::deserialize):
+        * src/libANGLE/ProgramExecutable.cpp:
+        (gl::ProgramExecutable::updateActiveSamplers):
+        (gl::ProgramExecutable::updateActiveImages):
+        (gl::ProgramExecutable::setSamplerUniformTextureTypeAndFormat):
+        * src/libANGLE/ProgramExecutable.h:
+        * src/libANGLE/renderer/gl/ProgramGL.cpp:
+        (rx::ProgramGL::markUnusedUniformLocations):
+        * src/libANGLE/renderer/metal/ProgramMtl.mm:
+        (rx::ProgramMtl::updateTextures):
+        * src/libANGLE/renderer/vulkan/ProgramExecutableVk.cpp:
+        (rx::ProgramExecutableVk::updateImagesDescriptorSet):
+        (rx::ProgramExecutableVk::updateTexturesDescriptorSet):
+        * src/tests/gl_tests/ComputeShaderTest.cpp:
+        * src/tests/gl_tests/UniformTest.cpp:
+
+2020-09-01  David Kilzer  <ddkilzer@apple.com>
+
+        [ANGLE] InternalFormat::blendSupport is uninitialized by constructor
+        <https://webkit.org/b/216053>
+        <rdar://problem/68166032>
+
+        Reviewed by Kenneth Russell.
+
+        * changes.diff: Add this patch.
+        * src/libANGLE/formatutils.cpp:
+        (gl::InternalFormat::InternalFormat):
+        - Initialize blendSupport to NeverSupported.
+
+2020-08-31  James Darpinian  <jdarpinian@chromium.org>
+
+        Implement WEBGL_compressed_texture_s3tc_srgb extension
+        https://bugs.webkit.org/show_bug.cgi?id=215973
+
+        Reviewed by Dean Jackson.
+
+        * src/libANGLE/renderer/gl/formatutilsgl.cpp:
+        (rx::nativegl::ExtAndVersionOrExt):
+        (rx::nativegl::BuildInternalFormatInfoMap):
+
+2020-08-12  Keith Rollin  <krollin@apple.com>
+
+        Remove the need for defining USE_NEW_BUILD_SYSTEM
+        https://bugs.webkit.org/show_bug.cgi?id=215439
+
+        Reviewed by Darin Adler.
+
+        When building WebKit for XCBuild, we currently require that the
+        external build system (such as the Makefile, build-webkit, etc.)
+        defines the USE_NEW_BUILD_SYSTEM=YES build setting. This build setting
+        controls parts of our build instructions that are sensitive to when
+        XCBuild or the Legacy build system are being used. Notably, we need to
+        know when to use our custom “copy and modify” scripts with copying
+        certain header files (used with the Legacy build system) vs. using the
+        enhanced Copy Headers build phase that’s enabled with
+        APPLY_RULES_IN_COPY_HEADERS=YES (introduced with and used by XCBuild).
+        The choice of which method to copy headers is used is controlled by
+        USE_NEW_BUILD_SYSTEM.
+
+        There is no built-in build setting that we can probe to help us
+        determine which approach to take when copying and modifying headers,
+        which is why we need to define USE_NEW_BUILD_SYSTEM ourselves. But it
+        turns out that we can *detect* which build system is being used by
+        taking advantage of a subtle difference between the two systems. As
+        noted in:
+
+            https://developer.apple.com/documentation/xcode-release-notes/build-system-release-notes-for-xcode-10
+
+            “When an .xcconfig file contains multiple assignments of the same
+             build setting, later assignments using $(inherited) or
+             $(<setting_name>) will inherit from earlier assignments in the
+             .xcconfig. The legacy build system caused every use of
+             $(inherited) or $(<setting_name>) skip any other values defined
+             within the .xcconfig.”
+
+        This difference can be exploited as follows:
+
+            WK_WHICH_BUILD_SYSTEM = not_
+            WK_WHICH_BUILD_SYSTEM = $(inherited)legacy
+            WK_USE_NEW_BUILD_SYSTEM = $(WK_USE_NEW_BUILD_SYSTEM_$(WK_WHICH_BUILD_SYSTEM))
+            WK_USE_NEW_BUILD_SYSTEM_legacy = NO
+            WK_USE_NEW_BUILD_SYSTEM_not_legacy = YES
+
+        We can then use WK_USE_NEW_BUILD_SYSTEM where we used to use the
+        externally-defined USE_NEW_BUILD_SYSTEM.
+
+        * ANGLE.xcodeproj/project.pbxproj:
+        * Configurations/ANGLE-dynamic.xcconfig:
+        * Configurations/ANGLE-static.xcconfig:
+        * Configurations/Base.xcconfig:
+
+2020-08-07  Dean Jackson  <dino@apple.com>
+
+        ANGLE: No need to check for Catalyst in the iOS build
+        https://bugs.webkit.org/show_bug.cgi?id=215249
+        <rdar://problem/66655478>
+
+        Reviewed by Tim Horton.
+
+        The DisplayEAGL class is never used for Catalyst, so doesn't
+        need to handle it.
+
+        * src/libANGLE/renderer/gl/eagl/DisplayEAGL.mm:
+        (rx::DisplayEAGL::generateConfigs):
+
+2020-08-05  Tim Horton  <timothy_horton@apple.com>
+
+        Remove all references to non-existent 10.16
+        https://bugs.webkit.org/show_bug.cgi?id=215202
+
+        Reviewed by Wenson Hsieh.
+
+        * Configurations/Base.xcconfig:
+        * Configurations/DebugRelease.xcconfig:
+        * Configurations/Version.xcconfig:
+        * Configurations/WebKitTargetConditionals.xcconfig:
+
+2020-07-29  Michael Catanzaro  <mcatanzaro@gnome.org>
+
+        [GTK] 2.29.4 fails to link on armv7hl
+        https://bugs.webkit.org/show_bug.cgi?id=214934
+
+        Reviewed by Carlos Alberto Lopez Perez.
+
+        Link ANGLE to with -ldl
+
+        * CMakeLists.txt:
+
+2020-07-29  Kenneth Russell  <kbr@chromium.org>
+
+        Roll ANGLE to 2020-07-28
+        https://bugs.webkit.org/show_bug.cgi?id=214897
+
+        Reviewed by Alex Christensen.
+
+        Roll to current ANGLE revision. Large ChangeLog below has been
+        truncated except for a few significant files.
+
+        Add dependency on zlib wrapper in third_party/zlib/google for both
+        Xcode and CMake builds. Small change to this wrapper for the
+        WinCairo build's system zlib, which doesn't define z_const.
+
+        * .gitignore:
+        * ANGLE.plist:
+        * ANGLE.xcodeproj/project.pbxproj:
+        * CMakeLists.txt:
+        * Configurations/ANGLE-dynamic.xcconfig:
+        * Configurations/ANGLE-static.xcconfig:
+        * GLESv2.cmake:
+        * PlatformWin.cmake:
+        * third_party/zlib/google/compression_utils_portable.cc: Added.
+        * third_party/zlib/google/compression_utils_portable.h: Added.
+
+2020-07-28  Kenneth Russell  <kbr@chromium.org>
+
+        Pause during ANGLE roll script after rebasing and before deleting temporary Git repo
+        https://bugs.webkit.org/show_bug.cgi?id=212717
+
+        Reviewed by Dean Jackson.
+
+        Give the user the opportunity to manually examine the changes
+        relative to upstream ANGLE, and to undo any accidental or
+        undesired ones, before finishing the roll.
+
+        * update-angle.sh:
+
+2020-07-22  Conrad Shultz  <conrad_shultz@apple.com>
+
+        Update macOS Version macros
+        https://bugs.webkit.org/show_bug.cgi?id=214653
+
+        Reviewed by Tim Horton.
+
+        * Configurations/Base.xcconfig:
+        * Configurations/DebugRelease.xcconfig:
+        * Configurations/Version.xcconfig:
+        * Configurations/WebKitTargetConditionals.xcconfig:
+
+2020-07-17  Kenneth Russell  <kbr@chromium.org>
+
+        [WebGL2] Fix validation of pixel unpack parameters
+        https://bugs.webkit.org/show_bug.cgi?id=214509
+
+        Reviewed by Dean Jackson.
+
+        Fix small error discovered while upstreaming the previous fix to
+        the ANGLE project.
+
+        * src/libANGLE/validationES3.cpp:
+        (gl::ValidateES3TexImageParametersBase):
+
+2020-07-17  Kenneth Russell  <kbr@chromium.org>
+
+        [WebGL2] ReadPixels updates
+        https://bugs.webkit.org/show_bug.cgi?id=209516
+
+        Reviewed by Dean Jackson.
+
+        Add workaround for OpenGL driver bug on macOS where
+        GL_PACK_SKIP_ROWS and GL_PACK_SKIP_PIXELS are ignored.
+
+        Add WebGL 2.0-specific validation constraints for pixel pack and
+        unpack parameters.
+
+        These changes are being upstreamed to ANGLE in
+        http://crbug.com/angleproject/4849 .
+
+        * include/platform/FeaturesGL.h:
+        * src/libANGLE/ErrorStrings.h:
+        * src/libANGLE/renderer/gl/FramebufferGL.cpp:
+        (rx::FramebufferGL::readPixels):
+        * src/libANGLE/renderer/gl/renderergl_utils.cpp:
+        (rx::nativegl_gl::InitializeFeatures):
+        * src/libANGLE/validationES.cpp:
+        (gl::ValidatePixelPack):
+        * src/libANGLE/validationES3.cpp:
+        (gl::ValidateES3TexImageParametersBase):
+
+2020-07-10  Kenneth Russell  <kbr@chromium.org>
+
+        Remove glBindFramebuffer flush workaround from ANGLE
+        https://bugs.webkit.org/show_bug.cgi?id=214104
+
+        Reviewed by Dean Jackson.
+
+        Remove this driver bug workaround, which very likely had no
+        effect, and which was never upstreamed to ANGLE.
+
+        * include/platform/FeaturesGL.h:
+        * src/libANGLE/renderer/gl/StateManagerGL.cpp:
+        (rx::StateManagerGL::bindFramebuffer):
+        * src/libANGLE/renderer/gl/renderergl_utils.cpp:
+        (rx::nativegl_gl::InitializeFeatures):
+
+2020-07-08  Darin Adler  <darin@apple.com>
+
+        Fix adjust-angle-include-paths.sh error seen building ANGLE library
+        https://bugs.webkit.org/show_bug.cgi?id=214059
+
+        Reviewed by Alexey Proskuryakov.
+
+        * ANGLE.xcodeproj/project.pbxproj: Remove the build step that adjusts paths.
+        Dean Jackson told me we don't need it for the static library target.
+
+2020-06-30  Andy Estes  <aestes@apple.com>
+
+        [Xcode] Enable the "My Mac (Mac Catalyst)" destination in WebKit Xcode projects
+        https://bugs.webkit.org/show_bug.cgi?id=213740
+
+        Reviewed by Darin Adler.
+
+        * Configurations/Base.xcconfig: Set SUPPORTS_MACCATALYST to YES to tell Xcode that this
+        project supports building for Mac Catalyst.
+
+2020-06-22  Tim Horton  <timothy_horton@apple.com>
+
+        Update macOS version macros
+        https://bugs.webkit.org/show_bug.cgi?id=213484
+
+        Reviewed by Alexey Proskuryakov.
+
+        * Configurations/Base.xcconfig:
+        * Configurations/DebugRelease.xcconfig:
+        * Configurations/Version.xcconfig:
+        * Configurations/WebKitTargetConditionals.xcconfig:
+
+2020-06-22  Tim Horton  <timothy_horton@apple.com>
+
+        WebGL cannot create a context if there is no GPU on the PCIe bus
+        https://bugs.webkit.org/show_bug.cgi?id=213479
+
+        Reviewed by Maciej Stachowiak and Dean Jackson.
+
+        * src/gpu_info_util/SystemInfo_macos.mm:
+        (angle::GetSystemInfo):
+        Do not bail from WebGL initialization if there are no GPUs on the PCIe bus.
+        Instead, continue on to context creation, and allow the system frameworks
+        to return an error if there truly is no GPU.
+
+2020-06-19  Jonathan Bedard  <jbedard@apple.com>
+
+        [ANGLE] Correct Catalyst guards
+        https://bugs.webkit.org/show_bug.cgi?id=211410
+        <rdar://problem/62891185>
+
+        Reviewed by Dean Jackson.
+
+        * src/libANGLE/renderer/gl/eagl/DeviceEAGL.cpp: Do not compile on Mac.
+        * src/libANGLE/renderer/gl/eagl/DeviceEAGL.h:  Definitions should not be available on Mac.
+        * src/libANGLE/renderer/gl/eagl/DisplayEAGL.h: Definitions should not be available on Mac.
+        * src/libANGLE/renderer/gl/eagl/DisplayEAGL.mm: Do not compile on Mac.
+
+2020-06-10  Dean Jackson  <dino@apple.com>
+
+        Add a dynamic library target for ANGLE
+        https://bugs.webkit.org/show_bug.cgi?id=207591
+
+        Reviewed by Tim Horton.
+
+        In preparation for moving to a dynamic library, start
+        by compiling and linking it. It isn't used anywhere
+        but getting it into the build will help Apple's
+        build system remain happy as we migrate, as well
+        as have the system know it exists for building
+        the shared system cache.
+
+        * ANGLE.xcodeproj/project.pbxproj:
+        * Configurations/ANGLE-dynamic.xcconfig: Added.
+        * Configurations/ANGLE-static.xcconfig: Added.
+        * Configurations/ANGLE.xcconfig: Removed.
+        * Configurations/Base.xcconfig:
+        * Configurations/DebugRelease.xcconfig:
+
+2020-06-07  James Darpinian  <jdarpinian@chromium.org>
+
+        [ANGLE - iOS] fast/canvas/webgl/uninitialized-test.html is still failing
+        https://bugs.webkit.org/show_bug.cgi?id=212249
+
+        Reviewed by Dean Jackson.
+
+        copyTexImage2D is broken in some way on iOS. Work around it by reimplementing
+        it with ANGLE's BlitGL class.
+
+        * include/platform/FeaturesGL.h:
+        * src/libANGLE/renderer/gl/BlitGL.cpp:
+        (rx::BlitGL::blitColorBufferWithShader):
+        * src/libANGLE/renderer/gl/BlitGL.h:
+        * src/libANGLE/renderer/gl/TextureGL.cpp:
+        (rx::TextureGL::copyImage):
+        (rx::TextureGL::copySubImage):
+        * src/libANGLE/renderer/gl/renderergl_utils.cpp:
+        (rx::nativegl_gl::InitializeFeatures):
+        * src/tests/gl_tests/CopyTexImageTest.cpp:
+        * src/tests/gl_tests/TextureTest.cpp:
+        * src/tests/test_utils/angle_test_configs.cpp:
+        (angle::operator<<):
+        * src/tests/test_utils/angle_test_configs.h:
+        (angle::WithEmulateCopyTexImage2DFromRenderbuffers):
+        * util/EGLPlatformParameters.h:
+        (EGLPlatformParameters::tie const):
+        * util/EGLWindow.cpp:
+        (EGLWindow::initializeDisplay):
+
+2020-06-04  Tim Horton  <timothy_horton@apple.com>
+
+        Work around broken system version macro
+        https://bugs.webkit.org/show_bug.cgi?id=212726
+
+        Reviewed by Dan Bernstein.
+
+        * Configurations/DebugRelease.xcconfig:
+
+2020-06-02  Keith Rollin  <krollin@apple.com>
+
+        Change ANGLE's header postprocessing script to not rely on timestamps
+        https://bugs.webkit.org/show_bug.cgi?id=212623
+        <rdar://problem/63856997>
+
+        Reviewed by David Kilzer.
+        Reviewed by Kennneth Russell.
+
+        Some WebKit builds involve multiple passes, where each pass is a
+        superset of the previous pass. In the cases where each pass produces
+        the same files, it is required that files be produced in exactly the
+        same way in each of those passes. A build process that relies on a
+        file containing a timestamp trips up that prerequisite.
+
+        adjust-angle-include-paths.sh uses such a mechanism, using a timestamp
+        file to determine if any exported headers need to be post-processed.
+        Since this violates our prerequisite, we need a different approach.
+        Instead of using a timestamp, always perform the post-processing, but
+        write the output to a temporary location. Then see if it differs from
+        what's in the actual final destination. If the two files diff, then
+        copy the one from the temporary location to the final destination.
+
+        This approach does cause more work in the area of post-processing.
+        However, this post-processing is actually very cheap. And avoiding the
+        post-processing is not actually the original goal of the timestamp.
+        The actual goal is to avoid touching the modification dates of the
+        exported headers, which would then cause a lot of downstream
+        rebuilding. The new approach with the temporary files also achieves
+        that goal.
+
+        * CMakeLists.txt:
+        * adjust-angle-include-paths.sh:
+
+2020-06-02  Kenneth Russell  <kbr@chromium.org>
+
+        Revise PVRTC compressed texture validation in ANGLE backend for WebGL
+        https://bugs.webkit.org/show_bug.cgi?id=212612
+
+        Reviewed by Dean Jackson.
+
+        Correct the block sizes of PVRTC textures, and incorporate minimum
+        block sizes for width and height, as required by these formats.
+
+        * src/libANGLE/formatutils.cpp:
+        (gl::BuildInternalFormatInfoMap):
+        (gl::InternalFormat::computeCompressedImageSize const):
+        (gl::InternalFormat::getCompressedImageMinBlocks const):
+        * src/libANGLE/formatutils.h:
+
+2020-05-29  Keith Rollin  <krollin@apple.com>
+
+        Revert switch to XCBuild
+        https://bugs.webkit.org/show_bug.cgi?id=212530
+        <rdar://problem/63764632>
+
+        Unreviewed build fix.
+
+        Bug 209890 enabled the use of XCBuild by default. Since then, some
+        build issues have shown up. While addressing them, temporarily turn
+        off the use of XCBuild by default.
+
+        * ANGLE.xcodeproj/project.pbxproj:
+        * Configurations/ANGLE.xcconfig:
+
+2020-05-27  Keith Rollin  <krollin@apple.com>
+
+        Enable the use of XCBuild by default in Apple builds
+        https://bugs.webkit.org/show_bug.cgi?id=209890
+        <rdar://problem/44182078>
+
+        Unreviewed build fix. Check the value of XCODE_VERSION_ACTUAL rather
+        than XCODE_VERSION_MAJOR when determining whether to use the XCBuild
+        or non-XCBuild method of running header post-processing scripts.
+
+        * ANGLE.xcodeproj/project.pbxproj:
+
+2020-05-26  Keith Rollin  <krollin@apple.com>
+
+        Enable the use of XCBuild by default in Apple builds
+        https://bugs.webkit.org/show_bug.cgi?id=209890
+        <rdar://problem/44182078>
+
+        Reviewed by Darin Adler.
+
+        Switch from the "legacy" Xcode build system to the "new" build system
+        (also known as "XCBuild"). Switching to the new system speeds up
+        builds by a small percentage, better validates projects for
+        build-related issues (such as dependency cycles), lets WebKit benefit
+        from future improvements in XCBuild such as those coming from the
+        underlying llbuild open source project, and prepares us for any other
+        tools built for this new ecosystem.
+
+        Specific changes:
+
+        - Remove Xcode project and workspace settings that selected the Build
+          system, allowing the default to take hold (which is currently the
+          New build system).
+        - Updated webkitdirs.pm with a terser check for Xcode version.
+        - Update build-webkit and Makefile.shared to be explicit when using
+          the old build system (no longer treat it as a default or fall-back
+          configuration).
+        - Update various xcconfig files similarly to treat the default as
+          using the new build system.
+        - Update various post-processing build steps to check for Xcode 11.4
+          and to no longer treat the default as using the old build system.
+
+        * ANGLE.xcodeproj/project.pbxproj:
+        * Configurations/ANGLE.xcconfig:
+
+2020-05-22  Kenneth Russell  <kbr@chromium.org>
+
+        [ANGLE - iOS] webgl/1.0.3/conformance/extensions/ext-sRGB.html is failing
+        https://bugs.webkit.org/show_bug.cgi?id=212277
+
+        Reviewed by Dean Jackson.
+
+        Properly translate GL_EXT_sRGB enums to ES 3.0 enums when
+        GL_EXT_sRGB is not supported.
+
+        * src/libANGLE/renderer/gl/formatutilsgl.cpp:
+        (rx::nativegl::GetNativeInternalFormat):
+        (rx::nativegl::GetNativeFormat):
+
+2020-05-22  Kenneth Russell  <kbr@chromium.org>
+
+        [ANGLE - iOS] fast/canvas/webgl/webgl-depth-texture.html is failing
+        https://bugs.webkit.org/show_bug.cgi?id=212271
+
+        Reviewed by Dean Jackson.
+
+        Use ES 3.0 sized internal formats for unsized depth/stencil
+        textures when the OES_depth_texture extension is unavailable - as
+        is the case in iOS's ES 3.0 driver.
+
+        * src/libANGLE/renderer/gl/formatutilsgl.cpp:
+        (rx::nativegl::GetNativeInternalFormat):
+
+2020-05-21  Dean Jackson  <dino@apple.com>
+
+        PVRTC compressed textures are failing with ANGLE backend
+        https://bugs.webkit.org/show_bug.cgi?id=212240
+        <rdar://problem/63517385>
+
+        Reviewed by Ken Russell (representing ANGLE).
+
+        The values used for the PVRTC formats were incorrect.
+
+        * src/libANGLE/formatutils.cpp:
+        (gl::BuildInternalFormatInfoMap):
+
+2020-05-21  Kenneth Russell  <kbr@chromium.org>
+
+        Roll ANGLE to 2020-05-21
+        https://bugs.webkit.org/show_bug.cgi?id=212228
+
+        Reviewed by Dean Jackson.
+
+        Roll ANGLE to 96a80283cc0fe604d03c0bc0b3f9eb100edd22f9 in the
+        upstream repository using jdarpinian's excellent update-angle.sh
+        script.
+
+        Manually undo the fix from Bug 210992, which was fixed differently
+        upstream.
+
+2020-05-21  Kenneth Russell  <kbr@chromium.org>
+
+        EXT_color_buffer_half_float not exposed on iOS
+        https://bugs.webkit.org/show_bug.cgi?id=212181
+
+        Reviewed by Dean Jackson.
+
+        Remove OES_texture_half_float requirement for advertising
+        EXT_color_buffer_half_float in ANGLE. This is implicit in ES 3.0.
+
+        * src/libANGLE/renderer/gl/formatutilsgl.cpp:
+        (rx::nativegl::BuildInternalFormatInfoMap):
+
+2020-05-20  Kenneth Russell  <kbr@chromium.org>
+
+        OES_texture_half_float_linear unavailable on WebGL 1.0 on iOS with ANGLE
+        https://bugs.webkit.org/show_bug.cgi?id=212170
+
+        Reviewed by Dean Jackson.
+
+        Now that FP16 luminance/alpha texture formats are correctly
+        emulated on ES 3.0, advertise them as filterable.
+
+        * src/libANGLE/renderer/gl/formatutilsgl.cpp:
+        (rx::nativegl::BuildInternalFormatInfoMap):
+
+2020-05-20  Kenneth Russell  <kbr@chromium.org>
+
+        OES_texture_float / OES_texture_half_float unavailable in WebGL 1.0 on iOS Simulator with ANGLE
+        https://bugs.webkit.org/show_bug.cgi?id=210524
+
+        Reviewed by Dean Jackson.
+
+        Emulate LUMINANCE, ALPHA and LUMINANCE_ALPHA floating-point
+        textures on top of RED / RG textures when the underlying
+        OES_texture_float/half_float OpenGL ES extensions are unavailable.
+
+        This makes the conformance/extensions/oes-texture{-half}-float*
+        tests run and pass in the iOS Simulator.
+
+        This change is being reviewed upstream in the ANGLE repository and
+        is only being uploaded here for testing purposes. It will be
+        rolled in with the next ANGLE update.
+
+        * src/libANGLE/renderer/gl/TextureGL.cpp:
+        (rx::TextureGL::setSwizzle):
+        * src/libANGLE/renderer/gl/formatutilsgl.cpp:
+        (rx::nativegl::BuildInternalFormatInfoMap):
+        (rx::nativegl::IsLUMAFormat):
+        (rx::nativegl::EmulateLUMAFormat):
+        (rx::nativegl::EmulateLUMA):
+        (rx::nativegl::GetNativeInternalFormat):
+        (rx::nativegl::GetNativeFormat):
+        (rx::nativegl::GetNativeType):
+        (rx::nativegl::GetTexImageFormat):
+        (rx::nativegl::GetTexSubImageFormat):
+
+2020-05-18  James Darpinian  <jdarpinian@chromium.org>
+
+        Enable regenerateStructNames workaround on iOS
+        https://bugs.webkit.org/show_bug.cgi?id=212056
+
+        Reviewed by Dean Jackson.
+
+        The WebGL conformance test conformance/glsl/misc/shader-struct-scope.html
+        was failing on iOS. The workaround that fixes this test was enabled only on
+        desktop GL, but it's necessary for iOS as well.
+
+        * src/libANGLE/renderer/gl/renderergl_utils.cpp:
+        (rx::nativegl_gl::InitializeFeatures):
+
+2020-05-14  James Darpinian  <jdarpinian@chromium.org>
+
+        REGRESSION (r259589): Google Maps background layer fades out and back in
+        https://bugs.webkit.org/show_bug.cgi?id=210992
+
+        Reviewed by Dean Jackson.
+
+        ANGLE rendering feedback loop detection was incorrect if a texture attached
+        to a framebuffer was also bound to an active texture unit, and then that texture
+        unit became inactive because a sampler uniform was set.
+
+        * src/libANGLE/Context.cpp:
+        (gl::Context::onSamplerUniformChange):
+        * src/libANGLE/State.cpp:
+        (gl::State::setTextureIndexInactive):
+        * src/libANGLE/State.h:
+
+2020-05-14  Kenneth Russell  <kbr@chromium.org>
+
+        Update ANGLE to 2020-03-27
+        https://bugs.webkit.org/show_bug.cgi?id=209689
+
+        Reviewed by Darin Adler.
+
+        Re-applying this patch now that we have a fix for 210992.
+
+        Use update-angle.sh script by James Darpinian to roll ANGLE to
+        commit b387ce9389ede6a4ed3b831ab1b8187927fa295f in
+        https://chromium.googlesource.com/angle/angle .
+
+        changes.diff has been auto-updated with Apple's diffs relative to
+        upstream. No additional manual changes are made in this roll.
+        Long autogenerated file list omitted.
+
+2020-05-08  David Kilzer  <ddkilzer@apple.com>
+
+        Remove empty directories from from svn.webkit.org repository
+        <https://webkit.org/b/211644>
+
+        Reviewed by Darin Adler.
+
+        * include/vulkan: Removed.
+        * src/android_system_settings: Removed.
+        * third_party/glmark2: Removed.
+        * tools/flex-bison: Removed.
+
+2020-05-07  James Darpinian  <jdarpinian@chromium.org>
+
+        Fix Google Maps rendering corruption in simulator with ANGLE
+        https://bugs.webkit.org/show_bug.cgi?id=211398
+
+        glReadPixels call needs to respect the row stride of the IOSurface.
+
+        Reviewed by Alex Christensen.
+
+        * src/libANGLE/renderer/gl/eagl/IOSurfaceSurfaceEAGL.h:
+        * src/libANGLE/renderer/gl/eagl/IOSurfaceSurfaceEAGL.mm:
+        (rx::IOSurfaceSurfaceEAGL::IOSurfaceSurfaceEAGL):
+        (rx::IOSurfaceSurfaceEAGL::releaseTexImage):
+
+2020-05-07  Dean Jackson  <dino@apple.com>
+
+        Update ANGLE to 2020-03-27
+        https://bugs.webkit.org/show_bug.cgi?id=209689
+
+        Reverting r259589. It caused
+        https://bugs.webkit.org/show_bug.cgi?id=210992
+
+2020-05-05  Saam Barati  <sbarati@apple.com>
+
+        Unreviewed, reverting r261176.
+
+        It broke the build
+
+        Reverted changeset:
+
+        "[ANGLE] Declarations should match definitions"
+        https://bugs.webkit.org/show_bug.cgi?id=211410
+        https://trac.webkit.org/changeset/261176
+
+2020-05-05  Jonathan Bedard  <jbedard@apple.com>
+
+        [ANGLE] Declarations should match definitions
+        https://bugs.webkit.org/show_bug.cgi?id=211410
+
+        Reviewed by Alex Christensen.
+
+        * src/libANGLE/renderer/gl/eagl/DisplayEAGL.h: Skip definitions for platforms
+        where class is undefined.
+        * src/libANGLE/renderer/gl/eagl/DisplayEAGL.mm:
+        (rx::DisplayEAGL::generateConfigs): Function is not defined for for MacCatalyst.
+        * src/libANGLE/renderer/gl/eagl/IOSurfaceSurfaceEAGL.h: Skip definitions for platforms
+        where class is undefined.
+        * src/libANGLE/renderer/gl/eagl/IOSurfaceSurfaceEAGL.mm:
+        * src/libANGLE/renderer/gl/eagl/WindowSurfaceEAGL.h: Skip definitions for platforms
+        where class is undefined.
+        * src/libANGLE/renderer/gl/eagl/WindowSurfaceEAGL.mm:
+
+2020-04-28  ChangSeok Oh  <changseok@webkit.org>
+
+        [GTK] Fix build failures for ANGLE_WEBGL after r259589
+        https://bugs.webkit.org/show_bug.cgi?id=211116
+
+        Reviewed by Alex Christensen.
+
+        The ANGLE_WEBGL is broken after ANGLE is updated in r259589. Missing sources
+        should be added to the build target.
+
+        * PlatformGTK.cmake: Add libangle_gl_egl_sources and libangle_gl_egl_dl_sources.
+
+2020-04-27  Dean Jackson  <dino@apple.com>
+
+        Temporarily skip GL_DEPTH_COMPONENT32_OES requirement for depth textures on iOS
+        https://bugs.webkit.org/show_bug.cgi?id=211055
+        <rdar://problem/62410499>
+
+        Reviewed by Darin Adler.
+
+        ANGLE requires GL_DEPTH_COMPONENT32_OES be available in order to expose the
+        depth texture extension. However, this format is not supported on iOS.
+        Temporarily remove this restriction while investigating other bugs.
+
+        This also allows us to see the failing results in
+        fast/canvas/webgl/webgl-depth-texture.html
+        webgl/1.0.3/conformance/extensions/webgl-depth-texture.html
+
+        * src/libANGLE/Caps.cpp:
+        (gl::DetermineDepthTextureANGLESupport):
+        (gl::DetermineDepthTextureOESSupport):
+
+2020-04-25  Darin Adler  <darin@apple.com>
+
+        [Cocoa] Deal with another round of Xcode upgrade checks
+        https://bugs.webkit.org/show_bug.cgi?id=211027
+
+        Reviewed by Alexey Proskuryakov.
+
+        * ANGLE.xcodeproj/project.pbxproj: Bump the upgrade check version.
+        Add a harmless base localization, rename English localization to en,
+        remove Japanese, French, German; this project contains nothing localized.
+
+2020-04-08  Truitt Savell  <tsavell@apple.com>
+
+        Unreviewed, reverting r259708.
+
+        Broke the iOS device Build
+
+        Reverted changeset:
+
+        "Enable the use of XCBuild by default in Apple builds"
+        https://bugs.webkit.org/show_bug.cgi?id=209890
+        https://trac.webkit.org/changeset/259708
+
+2020-04-08  Keith Rollin  <krollin@apple.com>
+
+        Enable the use of XCBuild by default in Apple builds
+        https://bugs.webkit.org/show_bug.cgi?id=209890
+        <rdar://problem/44182078>
+
+        Reviewed by Darin Adler.
+
+        Switch from the "legacy" Xcode build system to the "new" build system
+        (also known as "XCBuild"). Switching to the new system speeds up
+        builds by a small percentage, better validates projects for
+        build-related issues (such as dependency cycles), lets WebKit benefit
+        from future improvements in XCBuild such as those coming from the
+        underlying llbuild open source project, and prepares us for any other
+        tools built for this new ecosystem.
+
+        Specific changes:
+
+        - Remove Xcode project and workspace settings that selected the Build
+          system, allowing the default to take hold (which is currently the
+          New build system).
+        - Updated webkitdirs.pm with a terser check for Xcode version.
+        - Update build-webkit and Makefile.shared to be explicit when using
+          the old build system (no longer treat it as a default or fall-back
+          configuration).
+        - Update various xcconfig files similarly to treat the default as
+          using the new build system.
+        - Update various post-processing build steps to check for Xcode 11.4
+          and to no longer treat the default as using the old build system.
+
+        * ANGLE.xcodeproj/project.pbxproj:
+        * Configurations/ANGLE.xcconfig:
+
+2020-04-06  Kenneth Russell  <kbr@chromium.org>
+
+        Update ANGLE to 2020-03-27
+        https://bugs.webkit.org/show_bug.cgi?id=209689
+
+        Reviewed by Darin Adler.
+
+        Use update-angle.sh script by James Darpinian to roll ANGLE to
+        commit b387ce9389ede6a4ed3b831ab1b8187927fa295f in
+        https://chromium.googlesource.com/angle/angle .
+
+        changes.diff has been auto-updated with Apple's diffs relative to
+        upstream. No additional manual changes are made in this roll.
+        Long autogenerated file list omitted.
+
+2020-04-03  Kenneth Russell  <kbr@chromium.org>
+
+        Fix bugs related to VideoTextureCopierCV and ANGLE roll script
+        https://bugs.webkit.org/show_bug.cgi?id=209943
+
+        Reviewed by Dean Jackson.
+
+        Update the update-angle.sh script to take into account the new
+        procedure for generating ANGLE's commit ID header file. This
+        enables ANGLE rolls into WebKit again.
+
+        * update-angle.sh:
+
+2020-04-03  Keith Rollin  <krollin@apple.com>
+
+        Do not link with OpenGL on Apple platforms
+        https://bugs.webkit.org/show_bug.cgi?id=209946
+        <rdar://problem/61237956>
+
+        Reviewed by Sam Weinig.
+
+        OpenGL is not used in our build of ANGLE. Attempting to link with it
+        causes warnings, which can turn into errors in some cases (in
+        particular, when building with Xcode's "new" build system).
+
+        * ANGLE.xcodeproj/project.pbxproj:
+
+2020-04-03  David Kilzer  <ddkilzer@apple.com>
+
+        [Xcode] Replace ASAN_OTHER_CFLAGS and ASAN_OTHER_CPLUSPLUSFLAGS with $(inherited)
+        <https://webkit.org/b/209963>
+        <rdar://problem/61257504>
+
+        Reviewed by Alexey Proskuryakov.
+
+        * ANGLE.xcodeproj/project.pbxproj:
+        * Configurations/Base.xcconfig:
+        - Remove ASAN_OTHER_CFLAGS, ASAN_OTHER_CPLUSPLUSFLAGS and
+          ASAN_OTHER_LDFLAGS.
+
+2020-03-27  Kenneth Russell  <kbr@chromium.org>
+
+        Use ANGLE_robust_client_memory to replace framebuffer/texture validation
+        https://bugs.webkit.org/show_bug.cgi?id=209098
+
+        Reviewed by Dean Jackson.
+
+        Incorporated fix from anglebug.com/4504 to make
+        fast/canvas/webgl/uninitialized-test.html pass.
+
+        Incorporated fix from anglebug.com/4518 to make:
+         webgl/2.0.0/conformance2/renderbuffers/invalidate-framebuffer.html
+         webgl/2.0.0/conformance2/rendering/blitframebuffer-test.html
+         webgl/2.0.0/conformance2/rendering/rgb-format-support.html
+         webgl/2.0.0/conformance2/state/gl-object-get-calls.html
+         webgl/2.0.0/conformance2/textures/misc/tex-new-formats.html
+        pass.
+
+        * src/libANGLE/Texture.cpp:
+        (gl::Texture::copySubImage):
+        (gl::Texture::ensureSubImageInitialized):
+        * src/libANGLE/renderer/gl/renderergl_utils.cpp:
+        (rx::nativegl_gl::InitializeFeatures):
+
+2020-03-21  Keith Rollin  <krollin@apple.com>
+
+        Set INSTALLHDRS_SCRIPT_PHASE in ANGLE builds
+        https://bugs.webkit.org/show_bug.cgi?id=209384
+        <rdar://problem/59513380>
+
+        Reviewed by Dan Bernstein.
+
+        Production ANGLE builds are technically non-compliant. During the
+        installhdrs build action, ANGLE headers are exported but are not
+        post-processed. This differs from the install build action, where the
+        exported headers *are* post-processed. The headers need to be treated
+        identically under both actions. The post-processing is enabled by
+        setting the INSTALLHDRS_SCRIPT_PHASE build setting to YES. Most other
+        WebKit projects already set this setting (see, for example,
+        https://trac.webkit.org/changeset/155787,
+        https://trac.webkit.org/changeset/110327, and
+        https://trac.webkit.org/changeset/41417).
+
+        * Configurations/ANGLE.xcconfig:
+
+2020-03-15  Michael Catanzaro  <mcatanzaro@gnome.org>
+
+        [ANGLE] Source/ThirdParty/ANGLE/src/common/utilities.cpp:10: warning: ignoring #pragma clang diagnostic [-Wunknown-pragmas]
+        https://bugs.webkit.org/show_bug.cgi?id=209014
+
+        Reviewed by Darin Adler.
+
+        Silence compiler warning.
+
+        * changes.diff:
+        * src/common/utilities.cpp:
+
+2020-03-15  Michael Catanzaro  <mcatanzaro@gnome.org>
+
+        [ANGLE] Source/ThirdParty/ANGLE/src/libANGLE/Display.h:221:73: warning: implicitly-declared ‘egl::AttributeMap& egl::AttributeMap::operator=(const egl::AttributeMap&)’ is deprecated [-Wdeprecated-copy]
+        https://bugs.webkit.org/show_bug.cgi?id=209015
+
+        Reviewed by Darin Adler.
+
+        Suppress compiler warning. If this were WebKit code, I might take the time to fix it, but
+        with third-party code it's probably best to just turn off warnings that upstream is not
+        using.
+
+        * CMakeLists.txt:
+
+2020-03-02  Alan Coon  <alancoon@apple.com>
+
+        Add new Mac target numbers
+        https://bugs.webkit.org/show_bug.cgi?id=208398
+
+        Reviewed by Alexey Proskuryakov.
+
+        * Configurations/Base.xcconfig:
+        * Configurations/DebugRelease.xcconfig:
+        * Configurations/Version.xcconfig:
+        * Configurations/WebKitTargetConditionals.xcconfig:
+
+2020-02-12  Michael Catanzaro  <mcatanzaro@gnome.org>
+
+        Multiple GCC 10 build failures in ANGLE
+        https://bugs.webkit.org/show_bug.cgi?id=207365
+
+        Reviewed by Carlos Alberto Lopez Perez.
+
+        * changes.diff: Updated.
+        * include/platform/Platform.h: Add missing #include to get size_t.
+        * src/common/PackedEnums.h: Remove problematic const_casts.
+
+2020-02-12  Dean Jackson  <dino@apple.com>
+
+        ANGLE has unused bison and glmark2 code
+        https://bugs.webkit.org/show_bug.cgi?id=207597
+        rdar://59361460
+
+        Reviewed by Maciej Stachowiak.
+
+        Remove some unused files.
+
+        * changes.diff:
+        * src/tests/perf_tests/glmark2Benchmark.cpp: Removed.
+        * third_party/glmark2/BUILD.gn: Removed.
+        * third_party/glmark2/README.angle: Removed.
+        * tools/flex-bison/README.md: Removed.
+        * tools/flex-bison/linux/bison.sha1: Removed.
+        * tools/flex-bison/linux/flex.sha1: Removed.
+        * tools/flex-bison/third_party/.gitattributes: Removed.
+        * tools/flex-bison/third_party/m4sugar/LICENSE: Removed.
+        * tools/flex-bison/third_party/m4sugar/README.chromium: Removed.
+        * tools/flex-bison/third_party/m4sugar/foreach.m4: Removed.
+        * tools/flex-bison/third_party/m4sugar/m4sugar.m4: Removed.
+        * tools/flex-bison/third_party/skeletons/LICENSE: Removed.
+        * tools/flex-bison/third_party/skeletons/README.chromium: Removed.
+        * tools/flex-bison/third_party/skeletons/bison.m4: Removed.
+        * tools/flex-bison/third_party/skeletons/c-like.m4: Removed.
+        * tools/flex-bison/third_party/skeletons/c.m4: Removed.
+        * tools/flex-bison/third_party/skeletons/yacc.c: Removed.
+        * tools/flex-bison/update_flex_bison_binaries.py: Removed.
+        * tools/flex-bison/windows/bison.exe.sha1: Removed.
+        * tools/flex-bison/windows/flex.exe.sha1: Removed.
+        * tools/flex-bison/windows/m4.exe.sha1: Removed.
+        * tools/flex-bison/windows/msys-2.0.dll.sha1: Removed.
+        * tools/flex-bison/windows/msys-iconv-2.dll.sha1: Removed.
+        * tools/flex-bison/windows/msys-intl-8.dll.sha1: Removed.
+
+2020-02-09  Keith Rollin  <krollin@apple.com>
+
+        Re-enable LTO for ARM builds
+        https://bugs.webkit.org/show_bug.cgi?id=207402
+        <rdar://problem/49190767>
+
+        Reviewed by Sam Weinig.
+
+        Bug 190758 re-enabled LTO for Production builds for x86-family CPUs.
+        Enabling it for ARM was left out due to a compiler issue. That issue
+        has been fixed, and so now we can re-enable LTO for ARM.
+
+        * Configurations/Base.xcconfig:
+
+2020-02-07  Kenneth Russell  <kbr@chromium.org>
+
+        Try adding glBindFramebuffer flush workaround to ANGLE as remedy for flaky WebGL tests
+        https://bugs.webkit.org/show_bug.cgi?id=206625
+
+        Reviewed by Dean Jackson.
+
+        * include/platform/FeaturesGL.h:
+        * src/libANGLE/renderer/gl/StateManagerGL.cpp:
+        (rx::StateManagerGL::bindFramebuffer):
+        * src/libANGLE/renderer/gl/renderergl_utils.cpp:
+        (rx::nativegl_gl::InitializeFeatures):
+
+2020-02-05  Dean Jackson  <dino@apple.com>
+
+        Fix MacCatalyst build.
+
+        * src/libANGLE/validationEGL.cpp:
+        (egl::ValidateCreatePbufferFromClientBuffer):
+
+2020-02-04  James Darpinian  <jdarpinian@chromium.org>
+
+        Update ANGLE
+        https://bugs.webkit.org/show_bug.cgi?id=206318
+
+        Several important changes to fix layout test failures and timeouts in this update.
+        - Made expensive validation non-default in debug mode to reduce timeouts.
+        - Optimize disabling ARB_texture_rectangle to make shader compilation much faster.
+        - Flush before texture deletion to work around Mac Intel driver bug.
+
+        Reviewed by Dean Jackson.
+
+        * ANGLE.plist: update commit hash
+        * ANGLE.xcodeproj/project.pbxproj: Add/remove files
+        * Compiler.cmake: Translated from compiler.gni
+        * GLESv2.cmake: Translated from libGLESv2.gni
+        * changes.diff: Now lists all changes from upstream.
+        * update-angle.sh: Diff command was wrong.
+        * Plus a whole lot of changes from upstream.
+
+2020-01-30  James Darpinian  <jdarpinian@chromium.org>
+
+        Update ANGLE
+        https://bugs.webkit.org/show_bug.cgi?id=206318
+
+        Take two!
+
+        Several important changes to fix layout test failures and timeouts in this update.
+        - Made expensive validation non-default in debug mode to reduce timeouts.
+        - Optimize disabling ARB_texture_rectangle to make shader compilation much faster.
+        - Flush before texture deletion to work around Mac Intel driver bug.
+
+        Reviewed by Dean Jackson.
+
+        * ANGLE.plist: update commit hash
+        * ANGLE.xcodeproj/project.pbxproj: Add/remove files
+        * Compiler.cmake: Translated from compiler.gni
+        * GLESv2.cmake: Translated from libGLESv2.gni
+        * changes.diff: Now lists all changes from upstream.
+        * update-angle.sh: Diff command was wrong.
+        * Plus a whole lot of changes from upstream.
+
+2020-01-22  James Darpinian  <jdarpinian@chromium.org>
+
+        Update ANGLE
+        https://bugs.webkit.org/show_bug.cgi?id=206318
+
+        Several important changes to fix layout test failures and timeouts in this update.
+        - Made expensive validation non-default in debug mode to reduce timeouts.
+        - Optimize disabling ARB_texture_rectangle to make shader compilation much faster.
+        - Flush before texture deletion to work around Mac Intel driver bug.
+
+        Reviewed by Dean Jackson.
+
+        * ANGLE.plist: update commit hash
+        * ANGLE.xcodeproj/project.pbxproj: Add/remove files
+        * Compiler.cmake: Translated from compiler.gni
+        * GLESv2.cmake: Translated from libGLESv2.gni
+        * changes.diff: Now lists all changes from upstream.
+        * update-angle.sh: Diff command was wrong.
+        * Plus a whole lot of changes from upstream.
+
+2020-01-22  James Darpinian  <jdarpinian@chromium.org>
+
+        REGRESSION (r253926): webgl/1.0.3/conformance/rendering/many-draw-calls.html is much slower, times out in debug
+        https://bugs.webkit.org/show_bug.cgi?id=205668
+
+        Disable asserts when compiling ANGLE in release mode by defining
+        NDEBUG.
+
+        Reviewed by Dean Jackson.
+
+        * Configurations/ANGLE.xcconfig:
+
+2020-01-14  Dean Jackson  <dino@apple.com>
+
+        Build ANGLE as a dynamic library
+        https://bugs.webkit.org/show_bug.cgi?id=204708
+        rdar://57349384
+
+        Rolling this out for the 2nd time.
+
+        - it caused issues with the shared dyld cache, because the
+        cache doesn't know to include the libary until it already
+        exists in the build
+        - probably related to the above, we saw some performance
+        regressions directly related to this change
+
+        * ANGLE.xcodeproj/project.pbxproj:
+        * Configurations/ANGLE.xcconfig:
+        * Configurations/Base.xcconfig:
+        * Configurations/DebugRelease.xcconfig:
+        * include/CMakeLists.txt:
+        * include/GLSLANG/ShaderLang.h:
+        * include/GLSLANG/ShaderVars.h:
+        * src/libANGLE/renderer/gl/cgl/DisplayCGL.mm:
+        (rx::DisplayCGL::isValidNativeWindow const):
+        * src/libANGLE/renderer/gl/cgl/WindowSurfaceCGL.mm:
+        (rx::WindowSurfaceCGL::WindowSurfaceCGL):
+        (rx::WindowSurfaceCGL::~WindowSurfaceCGL):
+        * src/libANGLE/renderer/gl/eagl/DisplayEAGL.mm:
+        (rx::DisplayEAGL::terminate):
+        (rx::DisplayEAGL::isValidNativeWindow const):
+        (rx::WorkerContextEAGL::~WorkerContextEAGL):
+        * src/libANGLE/renderer/gl/eagl/WindowSurfaceEAGL.mm:
+        (rx::WindowSurfaceEAGL::WindowSurfaceEAGL):
+        (rx::WindowSurfaceEAGL::~WindowSurfaceEAGL):
+
+2020-01-14  Kenneth Russell  <kbr@chromium.org>
+
+        Need workaround for crash in Intel OpenGL driver related to texture copying feedback loops
+        https://bugs.webkit.org/show_bug.cgi?id=205843
+
+        Remove ANGLE workaround introduced in bug 205707, as it was
+        discovered to be incomplete, and was never upstreamed. The correct
+        workaround will be integrated in the next ANGLE roll.
+
+        Reviewed by Dean Jackson.
+
+        * include/platform/FeaturesGL.h:
+        * src/libANGLE/renderer/gl/StateManagerGL.cpp:
+        (rx::StateManagerGL::bindFramebuffer):
+        * src/libANGLE/renderer/gl/renderergl_utils.cpp:
+        (rx::nativegl_gl::InitializeFeatures):
+
+2020-01-08  Kenneth Russell  <kbr@chromium.org>
+
+        Remove some #ifdefs related to iOS port of ANGLE
+        https://bugs.webkit.org/show_bug.cgi?id=205781
+
+        Since the port to the iOS Simulator in
+        https://bugs.webkit.org/show_bug.cgi?id=205618 , these #ifdefs
+        should no longer be needed.
+
+        Reviewed by Dean Jackson.
+
+        * src/common/PackedEnums.cpp:
+        (egl_gl::EGLTextureTargetToTextureType):
+        * src/libANGLE/validationES2.cpp:
+        (gl::ValidateFramebufferTexture2D):
+
+2020-01-05  Kenneth Russell  <kbr@chromium.org>
+
+        REGRESSION (r253926): Flaky crashes on webgl/1.0.3/conformance/textures/texture-copying-feedback-loops.html and webgl/2.0.0/conformance/textures/misc/texture-copying-feedback-loops.html
+        https://bugs.webkit.org/show_bug.cgi?id=205707
+
+        Work around bugs in Intel's graphics driver where operations can
+        be incorrectly reordered across glBindFramebuffer calls by
+        flushing before/after these calls. Conclusively addresses this
+        crash; may also address other layout test flakiness seen when
+        switching to ANGLE backend for WebGL.
+
+        Reviewed by Dean Jackson.
+
+        * include/platform/FeaturesGL.h:
+        * src/libANGLE/renderer/gl/StateManagerGL.cpp:
+        (rx::StateManagerGL::bindFramebuffer):
+        * src/libANGLE/renderer/gl/renderergl_utils.cpp:
+        (rx::nativegl_gl::InitializeFeatures):
+
+2020-01-04  Kenneth Russell  <kbr@chromium.org>
+
+        Add support for iOS Simulator to ANGLE backend for WebGL
+        https://bugs.webkit.org/show_bug.cgi?id=205618
+
+        Extend EGL_ANGLE_iosurface_client_buffer extension to require use
+        of TEXTURE_2D target on iOS, and to provide read/write usage hints
+        for the pbuffer created from the IOSurface.
+
+        Emulate missing [EAGLContext texImageIOSurface:...] via texture
+        upload in eglBindTexImage and readback in eglReleaseTexImage.
+
+        These changes will be upstreamed in
+        https://bugs.chromium.org/p/angleproject/issues/detail?id=4256 .
+
+        Reviewed by Dean Jackson.
+
+        * extensions/EGL_ANGLE_iosurface_client_buffer.txt:
+        * include/EGL/eglext_angle.h:
+        * src/libANGLE/renderer/gl/eagl/DisplayEAGL.mm:
+        (rx::DisplayEAGL::initialize):
+        * src/libANGLE/renderer/gl/eagl/IOSurfaceSurfaceEAGL.h:
+        * src/libANGLE/renderer/gl/eagl/IOSurfaceSurfaceEAGL.mm:
+        (rx::IOSurfaceSurfaceEAGL::IOSurfaceSurfaceEAGL):
+        (rx::IOSurfaceSurfaceEAGL::bindTexImage):
+        (rx::IOSurfaceSurfaceEAGL::releaseTexImage):
+        (rx::IOSurfaceSurfaceEAGL::validateAttributes):
+        (rx::IOSurfaceSurfaceEAGL::createDefaultFramebuffer):
+        (rx::IOSurfaceSurfaceEAGL::getIOSurfaceLockOptions const):
+        * src/libANGLE/validationEGL.cpp:
+        (egl::ValidateCreatePbufferFromClientBuffer):
+
+2019-12-25  Dean Jackson  <dino@apple.com>
+
+        [WebGL] Enable ANGLE by default for Cocoa platforms (except simulator)
+        https://bugs.webkit.org/show_bug.cgi?id=205483
+        rdar://56925821
+
+        Reviewed by Simon Fraser.
+
+        Export entry_points_gles_ext_autogen.h.
+
+        * ANGLE.xcodeproj/project.pbxproj:
+
+2019-12-19  Dean Jackson  <dino@apple.com>
+
+        Build ANGLE as a dynamic library
+        https://bugs.webkit.org/show_bug.cgi?id=204708
+        rdar://57349384
+
+        Reviewed by Tim Horton.
+
+        Take 2 at attempting this. The first time was rolled out
+        due to failures in Apple's upstream build system.
+
+        Modify ANGLE to build as a dynamic library. My (not thorough) testing suggests
+        this will reduce the in-flight binary size on Apple's build systems by at least
+        a factor of 10 (it was over 1G). Building release for x86_64-only:
+            - Previously: libANGLE.a -- 306 MB
+            - Now: libANGLE-shared.dylib -- 6.7 MB
+
+        In order to do this, some symbols needed to be exported from the
+        "sh" namespace (which are used in ANGLEWebKitBridge, but not when
+        ANGLE's rendering backend is active).
+
+        While here, I turned on some more build options, like ARC.
+
+        Lastly, I added a build phase that creates a fake libANGLE.a
+        because Apple's build system thinks that WebCore still needs it.
+
+        * ANGLE.xcodeproj/project.pbxproj: Link with IOKit and IOSurface frameworks, and
+        product a dylib product.
+        * Configurations/ANGLE.xcconfig: Update the configuration for a dynamic library.
+        * Configurations/Base.xcconfig:
+        * Configurations/DebugRelease.xcconfig:
+        * include/GLSLANG/ShaderLang.h: Add ANGLE_EXPORT to some functions to make
+        sure they will be visible in the exported library.
+        * include/GLSLANG/ShaderVars.h:
+        * src/libANGLE/renderer/gl/cgl/DisplayCGL.mm: Change reinterpret_cast to a normal
+        C cast so it can be annotated with __bridge.
+        (rx::DisplayCGL::isValidNativeWindow const):
+        * src/libANGLE/renderer/gl/cgl/WindowSurfaceCGL.mm: Ditto.
+        (rx::WindowSurfaceCGL::WindowSurfaceCGL):
+        (rx::WindowSurfaceCGL::~WindowSurfaceCGL):
+        * src/libANGLE/renderer/gl/eagl/DisplayEAGL.mm: Ditto.
+        * src/libANGLE/renderer/gl/eagl/WindowSurfaceEAGL.mm: Ditto.
+
+2019-12-19  ChangSeok Oh  <changseok@webkit.org>
+
+        [GTK] Build fix for ANGLE_WEBGL after r253650
+        https://bugs.webkit.org/show_bug.cgi?id=205426
+
+        Reviewed by Carlos Alberto Lopez Perez.
+
+        libglesv2_entry_points_headers was removed in r253650 that updated CMake for ANGLE.
+        GLESv2.cmake seems to be susceptible to ANGLE changes, so it might not be
+        a good place where any platform specific configuration is located.
+        Let's move the entry points header set to CMakeLists.txt.
+
+        * CMakeLists.txt:
+
+2019-12-18  Dean Jackson  <dino@apple.com>
+
+        Reverting libANGLE.a -> libANGLE-shared.dylib.
+
+        Follow-up to remove the build phase that was trying
+        to fool Apple's build system.
+
+        * ANGLE.xcodeproj/project.pbxproj:
+
+2019-12-18  Dean Jackson  <dino@apple.com>
+
+        Reverting libANGLE.a -> libANGLE-shared.dylib.
+
+        The internal Apple build systems are still unhappy with
+        this change, so I'm reverting it until I can be sure
+        they'll accept it.
+
+        * ANGLE.xcodeproj/project.pbxproj:
+        * Configurations/ANGLE.xcconfig:
+        * Configurations/Base.xcconfig:
+        * Configurations/DebugRelease.xcconfig:
+        * include/CMakeLists.txt:
+        * include/GLSLANG/ShaderLang.h:
+        * include/GLSLANG/ShaderVars.h:
+        * src/libANGLE/renderer/gl/cgl/DisplayCGL.mm:
+        (rx::DisplayCGL::isValidNativeWindow const):
+        * src/libANGLE/renderer/gl/cgl/WindowSurfaceCGL.mm:
+        (rx::WindowSurfaceCGL::WindowSurfaceCGL):
+        (rx::WindowSurfaceCGL::~WindowSurfaceCGL):
+        * src/libANGLE/renderer/gl/eagl/DisplayEAGL.mm:
+        (rx::DisplayEAGL::terminate):
+        (rx::DisplayEAGL::isValidNativeWindow const):
+        (rx::WorkerContextEAGL::~WorkerContextEAGL):
+        * src/libANGLE/renderer/gl/eagl/WindowSurfaceEAGL.mm:
+        (rx::WindowSurfaceEAGL::WindowSurfaceEAGL):
+        (rx::WindowSurfaceEAGL::~WindowSurfaceEAGL):
+
+2019-12-17  Fujii Hironori  <Hironori.Fujii@sony.com>
+
+        Unreviewed build fix for WinCairo port
+        https://bugs.webkit.org/show_bug.cgi?id=204914
+        <rdar://problem/58023118>
+
+        * include/CMakeLists.txt: Replaced '$libangle_includes' with '${libangle_includes}".
+
+2019-12-17  James Darpinian  <jdarpinian@chromium.org>
+
+        Improve update-angle.sh and add gni-to-cmake.py
+        https://bugs.webkit.org/show_bug.cgi?id=204914
+
+        update-angle.sh now performs a git rebase. This automatically merges
+        upstream changes with WebKit's local changes where possible and
+        highlights any conflicts for manual resolution.
+
+        Also, it runs a new script gni-to-cmake.py to automatically update the
+        CMake files with upstream changes to the gni files. Along with the
+        changes to include/CMakeLists.txt, this should prevent build breaks
+        like the recently fixed WinCairo one. Additionally, diffing the CMake
+        files provides a concise list of build changes that can be referenced
+        when manually updating the XCode project file.
+
+        Reviewed by Dean Jackson.
+
+        * CMakeLists.txt:
+        * Compiler.cmake:
+        * GLESv2.cmake:
+        * gni-to-cmake.py: Added.
+        * include/CMakeLists.txt:
+        * update-angle.sh:
+
+2019-12-17  ChangSeok Oh  <changseok@webkit.org>
+
+        Unreviewed build fix for USE_ANGLE_WEBGL after r252994
+
+        * CMakeLists.txt: Add a missing directory separator.
+
+2019-12-13  Dean Jackson  <dino@apple.com>
+
+        MacCatalyst build of libANGLE is installed in the incorrect location
+        https://bugs.webkit.org/show_bug.cgi?id=205219
+        <rdar://problem/57713353>
+
+        Reviewed by Simon Fraser.
+
+        Rename libANGLE.dylib into libANGLE-shared.dylib, so we can
+        avoid accidentally trying to link to the libANGLE.a that was
+        removed recently (but still exists in the SDK for now).
+
+        Also, make sure that we install into the correct location for
+        a Catalyst build.
+
+        * ANGLE.xcodeproj/project.pbxproj:
+        * Configurations/ANGLE.xcconfig:
+        * Configurations/Base.xcconfig:
+
+2019-12-11  Dean Jackson  <dino@apple.com>
+
+        Produce a dummy libANGLE.a file to fool Apple's build test infrastructure
+        https://bugs.webkit.org/show_bug.cgi?id=205068
+        <rdar://problem/57713353>
+
+        Unreviewed followup to apply the script to Mac Catalyst builds.
+
+        Note that this phase can be removed in a few days when Apple's Test
+        Platform realises it doesn't need libANGLE.a any more.
+
+        * ANGLE.xcodeproj/project.pbxproj:
+
+2019-12-10  Dean Jackson  <dino@apple.com>
+
+        Produce a dummy libANGLE.a file to fool Apple's build test infrastructure
+        https://bugs.webkit.org/show_bug.cgi?id=205068
+        <rdar://problem/57713353>
+
+        Reviewed by Alex Christensen.
+
+        Create a dummy libANGLE.a file until our infrastructure realises it
+        doesn't need that file any more. Hopefully the fact that it isn't
+        really a static library, but just a text file, is ok.
+
+        * ANGLE.xcodeproj/project.pbxproj: Add a new shell script phase that
+        creates a dummy file.
+
+2019-12-06  Dean Jackson  <dino@apple.com>
+
+        Restrict libANGLE to link only with WebCore
+        https://bugs.webkit.org/show_bug.cgi?id=204957
+        <rdar://problem/57708644>
+
+        Reviewed by Brian Burg.
+
+        Restrict to WebCore and WebCoreTestSupport.
+
+        * Configurations/ANGLE.xcconfig:
+
+2019-12-05  James Darpinian  <jdarpinian@chromium.org>
+
+        Finish ANGLE update
+        https://bugs.webkit.org/show_bug.cgi?id=204911
+
+        The last ANGLE update patch didn't include all the changed files.
+        This patch updates the rest of the files.
+
+        Reviewed by Alex Christensen.
+
+        * src/tests: Lots of changed files from upstream ANGLE.
+        * src/third_party/compiler/README.chromium:
+        * third_party/VK-GL-CTS/README.angle: Added.
+        * third_party/deqp/README.angle: Removed.
+        * third_party/googletest/README.angle: Removed.
+        * third_party/libpng/BUILD.gn:
+        * third_party/spirv-cross/README.angle: Added.
+        * util/OSWindow.h:
+        * util/egl_loader_autogen.cpp:
+        (angle::LoadEGL):
+        * util/egl_loader_autogen.h:
+        * util/fuchsia/ScenicWindow.cpp:
+        (ScenicWindow::resetNativeWindow):
+        * util/fuchsia/ScenicWindow.h:
+        * util/gles_loader_autogen.cpp:
+        (angle::LoadGLES):
+        * util/gles_loader_autogen.h:
+        * util/osx/OSXWindow.h:
+        * util/osx/OSXWindow.mm:
+        (OSXWindow::initialize):
+        * util/ozone/OzoneWindow.h:
+        * util/posix/crash_handler_posix.cpp:
+        (angle::InitCrashHandler):
+        * util/posix/test_utils_posix.cpp:
+        (angle::GetTempDir):
+        (angle::CreateTemporaryFileInDir):
+        (angle::DeleteFile):
+        (angle::LaunchProcess):
+        (angle::NumberOfProcessors):
+        * util/shader_utils.cpp:
+        (CompileShaderFromFile):
+        (CompileProgramFromFiles):
+        * util/test_utils.cpp: Added.
+        (angle::CreateTemporaryFile):
+        (angle::GetFileSize):
+        (angle::ReadEntireFileToString):
+        (angle::ProcessHandle::ProcessHandle):
+        (angle::ProcessHandle::~ProcessHandle):
+        (angle::ProcessHandle::operator=):
+        (angle::ProcessHandle::reset):
+        * util/test_utils.h:
+        * util/test_utils_unittest.cpp: Added.
+        (angle::NormalizeNewLines):
+        (angle::TEST):
+        * util/test_utils_unittest_helper.cpp: Added.
+        (main):
+        * util/test_utils_unittest_helper.h: Added.
+        * util/util.gni:
+        * util/windows/WGLWindow.cpp:
+        * util/windows/test_utils_win.cpp:
+        (angle::InitCrashHandler):
+        (angle::TerminateCrashHandler):
+        (angle::LaunchProcess):
+        (angle::GetTempDir):
+        (angle::CreateTemporaryFileInDir):
+        (angle::DeleteFile):
+        (angle::NumberOfProcessors):
+        * util/windows/win32/Win32Window.cpp:
+        (Win32Window::initialize):
+        * util/windows/win32/test_utils_win32.cpp:
+        (angle::StabilizeCPUForBenchmarking):
+        * util/x11/X11Window.h:
+
+2019-12-02  Ross Kirsling  <ross.kirsling@sony.com>
+
+        Unreviewed WinCairo build fix following r252989.
+
+        * include/CMakeLists.txt:
+
+2019-12-02  Dean Jackson  <dino@apple.com>
+
+        Clean up ANGLE header post-process script
+        https://bugs.webkit.org/show_bug.cgi?id=204711
+
+        Reviewed by Tim Horton.
+
+        Since `sed` on macOS requires the in-place argument to have a zero-length string
+        to avoid making backups, this script was attempting to pass ''. However, this was
+        being evaluated, creating a bunch of files with \'\' suffixes. Fix this by using
+        an array when expanding the arguments.
+
+        Also fix a typo where the character "3" was being printed.
+
+        Lastly, only print out the basename of the header file being converted.
+
+        * adjust-angle-include-paths.sh:
+
+2019-11-30  Dean Jackson  <dino@apple.com>
+
+        Build ANGLE as a dynamic library
+        https://bugs.webkit.org/show_bug.cgi?id=204708
+        rdar://57349384
+
+        Reviewed by Tim Horton.
+
+        Modify ANGLE to build as a dynamic library. My (not thorough) testing suggests
+        this will reduce the in-flight binary size on Apple's build systems by at least
+        a factor of 10 (it was over 1G). Building release for x86_64-only:
+            - Previously: libANGLE.a -- 306 MB
+            - Now: libANGLE.dylib -- 6.7 MB
+
+        In order to do this, some symbols needed to be exported from the
+        "sh" namespace (which are used in ANGLEWebKitBridge, but not when
+        ANGLE's rendering backend is active).
+
+        While here, I turned on some more build options, like ARC.
+
+        * ANGLE.xcodeproj/project.pbxproj: Link with IOKit and IOSurface frameworks, and
+        product a dylib product.
+        * Configurations/ANGLE.xcconfig: Update the configuration for a dynamic library.
+        * Configurations/Base.xcconfig:
+        * Configurations/DebugRelease.xcconfig:
+        * Configurations/Version.xcconfig: Added.
+        * Configurations/WebKitTargetConditionals.xcconfig: Added.
+
+        * include/GLSLANG/ShaderLang.h: Add ANGLE_EXPORT to some functions to make
+        sure they will be visible in the exported library.
+        * include/GLSLANG/ShaderVars.h:
+        * src/libANGLE/renderer/gl/cgl/DisplayCGL.mm: Change reinterpret_cast to a normal
+        C cast so it can be annotated with __bridge.
+        (rx::DisplayCGL::isValidNativeWindow const):
+        * src/libANGLE/renderer/gl/cgl/WindowSurfaceCGL.mm: Ditto.
+        (rx::WindowSurfaceCGL::WindowSurfaceCGL):
+        (rx::WindowSurfaceCGL::~WindowSurfaceCGL):
+        * src/libANGLE/renderer/gl/eagl/DisplayEAGL.mm: Ditto.
+        * src/libANGLE/renderer/gl/eagl/WindowSurfaceEAGL.mm: Ditto.
+
+2019-12-02  James Darpinian  <jdarpinian@chromium.org>
+
+        Update ANGLE
+        https://bugs.webkit.org/show_bug.cgi?id=204595
+
+        Reviewed by Alex Christensen.
+
+        * ANGLE.plist: Updated commit hash.
+        * ANGLE.xcodeproj/project.pbxproj: Changes mirroring gn changes upstream.
+        * Compiler.cmake: Changes mirroring gn changes upstream.
+        * GLESv2.cmake: Changes mirroring gn changes upstream.
+        * CMakeLists.txt: Changes mirroring gn changes upstream.
+
+        * Many other files added/removed/changed from upstream.
+
+
+2019-11-20  ChangSeok Oh  <changseok@webkit.org>
+
+        [GTK] Add ANGLE backend to GTK port
+        https://bugs.webkit.org/show_bug.cgi?id=199060
+
+        Reviewed by Žan Doberšek.
+
+        * CMakeLists.txt: When USE_ANGLE_WEBGL is enabled, necessary glesv2 entry points headers
+          are installed in the derived source directory. And then adjust-angle-include-path.sh is applied
+          to change include paths in the entry points header files.
+        * GLESv2.cmake: libglesv2_entry_points_headers is newly defined, which is a gathering of
+          entry point headers of libGLESv2.
+        * PlatformGTK.cmake: In this file, we append gl and glx related angle code as a build target.
+          Since we want gl context and gles context simultaneously, we remove gl prototype calls
+          from the generated libGLESv2 library. Instead, we invoke egl and gl calls of ANGLE
+          via their non-prototype function names.
+        * adjust-angle-include-paths.sh: sed is slightly different in unix and linux systems.
+          In particular, its inplace option needs to be changed for better compatibility on linux.
+        * include/CMakeLists.txt: ANGLE_WEBGL_HEADERS is newly defined. It gathers header files of ANGLE
+          for WebGL support.
+
+2019-11-08  Dean Jackson  <dino@apple.com>
+
+        Add ANGLE backend for iOS device
+        https://bugs.webkit.org/show_bug.cgi?id=202159
+        <rdar://57000166>
+
+        Build fix. Don't include IOSurface.h on iOS (public SDK doesn't have it).
+
+        * src/libANGLE/renderer/gl/eagl/IOSurfaceSurfaceEAGL.mm:
+
+2019-11-07  Dean Jackson  <dino@apple.com>
+
+        Add ANGLE backend for iOS device
+        https://bugs.webkit.org/show_bug.cgi?id=202159
+        <rdar://57000166>
+
+        Reviewed by Myles Maxfield.
+
+        Add an OpenGLES backend over EAGL for iOS to ANGLE.
+
+        This is basically a copy of all the files in
+        libANGLE/renderer/gl/cgl into libANGLE/renderer/gl/eagl, then with
+        modifications to make it work on iOS's OpenGL ES. Most notably,
+        some format enums and the manner in which you bind an IOSurface to
+        a GL texture are different.
+
+        This introduces a few places where we have to do a compile time
+        switch for iOS, some of which might actually be applicable to
+        other OpenGL ES backends.
+
+        The biggest missing piece is support for the iOS simulator. At the moment
+        this backend relies on an IOSurface binding as a rendering target.
+        But the iOS Simulator does not have the required ability to have a
+        GL ES texture backed by an IOSurface.
+
+        The WindowSurfaceEAGL code is incomplete, but was not necessary
+        in order to get WebGL operational. And even if you are using ANGLE
+        directly, you can have the client code render into a CALayer without
+        going through the WindowSurface.
+
+        * ANGLE.xcodeproj/project.pbxproj:
+        * include/EGL/eglext_angle.h:
+        * src/common/PackedEnums.cpp:
+        (egl_gl::EGLTextureTargetToTextureType):
+        * src/common/platform.h:
+        * src/gpu_info_util/SystemInfo_ios.cpp: Added.
+        (angle::GetSystemInfo):
+        * src/gpu_info_util/SystemInfo_macos.cpp: Renamed from Source/ThirdParty/ANGLE/src/gpu_info_util/SystemInfo_mac.cpp.
+        (angle::GetSystemInfo):
+        * src/libANGLE/Caps.h:
+        * src/libANGLE/Display.cpp:
+        * src/libANGLE/formatutils.cpp:
+        (gl::BuildInternalFormatInfoMap):
+        * src/libANGLE/renderer/gl/cgl/DeviceCGL.cpp:
+        * src/libANGLE/renderer/gl/cgl/DisplayCGL.mm:
+        * src/libANGLE/renderer/gl/cgl/IOSurfaceSurfaceCGL.cpp:
+        (rx::IOSurfaceSurfaceCGL::bindTexImage):
+        * src/libANGLE/renderer/gl/cgl/PbufferSurfaceCGL.cpp:
+        * src/libANGLE/renderer/gl/cgl/RendererCGL.cpp:
+        * src/libANGLE/renderer/gl/cgl/WindowSurfaceCGL.mm:
+        * src/libANGLE/renderer/gl/eagl/ContextEAGL.cpp: Added.
+        (rx::ContextEAGL::ContextEAGL):
+        * src/libANGLE/renderer/gl/eagl/ContextEAGL.h: Added.
+        * src/libANGLE/renderer/gl/eagl/DeviceEAGL.cpp: Added.
+        (rx::DeviceEAGL::DeviceEAGL):
+        (rx::DeviceEAGL::~DeviceEAGL):
+        (rx::DeviceEAGL::initialize):
+        (rx::DeviceEAGL::getAttribute):
+        (rx::DeviceEAGL::getType):
+        (rx::DeviceEAGL::generateExtensions const):
+        * src/libANGLE/renderer/gl/eagl/DeviceEAGL.h: Added.
+        * src/libANGLE/renderer/gl/eagl/DisplayEAGL.h: Added.
+        * src/libANGLE/renderer/gl/eagl/DisplayEAGL.mm: Added.
+        (rx::FunctionsGLEAGL::FunctionsGLEAGL):
+        (rx::DisplayEAGL::DisplayEAGL):
+        (rx::DisplayEAGL::~DisplayEAGL):
+        (rx::DisplayEAGL::initialize):
+        (rx::DisplayEAGL::terminate):
+        (rx::DisplayEAGL::createWindowSurface):
+        (rx::DisplayEAGL::createPbufferSurface):
+        (rx::DisplayEAGL::createPbufferFromClientBuffer):
+        (rx::DisplayEAGL::createPixmapSurface):
+        (rx::DisplayEAGL::createContext):
+        (rx::DisplayEAGL::createDevice):
+        (rx::DisplayEAGL::generateConfigs):
+        (rx::DisplayEAGL::testDeviceLost):
+        (rx::DisplayEAGL::restoreLostDevice):
+        (rx::DisplayEAGL::isValidNativeWindow const):
+        (rx::DisplayEAGL::validateClientBuffer const):
+        (rx::DisplayEAGL::getVendorString const):
+        (rx::DisplayEAGL::getEAGLContext const):
+        (rx::DisplayEAGL::getEAGLPixelFormat const):
+        (rx::DisplayEAGL::generateExtensions const):
+        (rx::DisplayEAGL::generateCaps const):
+        (rx::DisplayEAGL::waitClient):
+        (rx::DisplayEAGL::waitNative):
+        (rx::DisplayEAGL::getMaxSupportedESVersion const):
+        (rx::DisplayEAGL::makeCurrentSurfaceless):
+        (rx::WorkerContextEAGL::WorkerContextEAGL):
+        (rx::WorkerContextEAGL::~WorkerContextEAGL):
+        (rx::WorkerContextEAGL::makeCurrent):
+        (rx::WorkerContextEAGL::unmakeCurrent):
+        (rx::DisplayEAGL::createWorkerContext):
+        (rx::DisplayEAGL::initializeFrontendFeatures const):
+        (rx::DisplayEAGL::populateFeatureList):
+        * src/libANGLE/renderer/gl/eagl/IOSurfaceSurfaceEAGL.h: Added.
+        * src/libANGLE/renderer/gl/eagl/IOSurfaceSurfaceEAGL.mm: Copied from Source/ThirdParty/ANGLE/src/libANGLE/renderer/gl/cgl/IOSurfaceSurfaceCGL.cpp.
+        (rx::IOSurfaceSurfaceEAGL::IOSurfaceSurfaceEAGL):
+        (rx::IOSurfaceSurfaceEAGL::~IOSurfaceSurfaceEAGL):
+        (rx::IOSurfaceSurfaceEAGL::initialize):
+        (rx::IOSurfaceSurfaceEAGL::makeCurrent):
+        (rx::IOSurfaceSurfaceEAGL::unMakeCurrent):
+        (rx::IOSurfaceSurfaceEAGL::swap):
+        (rx::IOSurfaceSurfaceEAGL::postSubBuffer):
+        (rx::IOSurfaceSurfaceEAGL::querySurfacePointerANGLE):
+        (rx::IOSurfaceSurfaceEAGL::bindTexImage):
+        (rx::IOSurfaceSurfaceEAGL::releaseTexImage):
+        (rx::IOSurfaceSurfaceEAGL::setSwapInterval):
+        (rx::IOSurfaceSurfaceEAGL::getWidth const):
+        (rx::IOSurfaceSurfaceEAGL::getHeight const):
+        (rx::IOSurfaceSurfaceEAGL::isPostSubBufferSupported const):
+        (rx::IOSurfaceSurfaceEAGL::getSwapBehavior const):
+        (rx::IOSurfaceSurfaceEAGL::validateAttributes):
+        (rx::IOSurfaceFramebuffer::IOSurfaceFramebuffer):
+        (rx::IOSurfaceSurfaceEAGL::createDefaultFramebuffer):
+        (rx::IOSurfaceSurfaceEAGL::initializeAlphaChannel):
+        (rx::IOSurfaceSurfaceEAGL::hasEmulatedAlphaChannel const):
+        * src/libANGLE/renderer/gl/eagl/PbufferSurfaceEAGL.cpp: Copied from Source/ThirdParty/ANGLE/src/libANGLE/renderer/gl/cgl/PbufferSurfaceCGL.cpp.
+        (rx::PbufferSurfaceEAGL::PbufferSurfaceEAGL):
+        (rx::PbufferSurfaceEAGL::~PbufferSurfaceEAGL):
+        (rx::PbufferSurfaceEAGL::initialize):
+        (rx::PbufferSurfaceEAGL::makeCurrent):
+        (rx::PbufferSurfaceEAGL::swap):
+        (rx::PbufferSurfaceEAGL::postSubBuffer):
+        (rx::PbufferSurfaceEAGL::querySurfacePointerANGLE):
+        (rx::PbufferSurfaceEAGL::bindTexImage):
+        (rx::PbufferSurfaceEAGL::releaseTexImage):
+        (rx::PbufferSurfaceEAGL::setSwapInterval):
+        (rx::PbufferSurfaceEAGL::getWidth const):
+        (rx::PbufferSurfaceEAGL::getHeight const):
+        (rx::PbufferSurfaceEAGL::isPostSubBufferSupported const):
+        (rx::PbufferSurfaceEAGL::getSwapBehavior const):
+        (rx::PbufferSurfaceEAGL::createDefaultFramebuffer):
+        * src/libANGLE/renderer/gl/eagl/PbufferSurfaceEAGL.h: Added.
+        * src/libANGLE/renderer/gl/eagl/RendererEAGL.cpp: Added.
+        (rx::RendererEAGL::RendererEAGL):
+        (rx::RendererEAGL::~RendererEAGL):
+        (rx::RendererEAGL::createWorkerContext):
+        * src/libANGLE/renderer/gl/eagl/RendererEAGL.h: Added.
+        * src/libANGLE/renderer/gl/eagl/WindowSurfaceEAGL.h: Added.
+        * src/libANGLE/renderer/gl/eagl/WindowSurfaceEAGL.mm: Copied from Source/ThirdParty/ANGLE/src/libANGLE/renderer/gl/cgl/WindowSurfaceCGL.mm.
+        (-[WebSwapLayer initWithSharedState:withContext:withFunctions:]):
+        (-[WebSwapLayer display]):
+        (rx::WindowSurfaceEAGL::WindowSurfaceEAGL):
+        (rx::WindowSurfaceEAGL::~WindowSurfaceEAGL):
+        (rx::WindowSurfaceEAGL::initialize):
+        (rx::WindowSurfaceEAGL::makeCurrent):
+        (rx::WindowSurfaceEAGL::swap):
+        (rx::WindowSurfaceEAGL::postSubBuffer):
+        (rx::WindowSurfaceEAGL::querySurfacePointerANGLE):
+        (rx::WindowSurfaceEAGL::bindTexImage):
+        (rx::WindowSurfaceEAGL::releaseTexImage):
+        (rx::WindowSurfaceEAGL::setSwapInterval):
+        (rx::WindowSurfaceEAGL::getWidth const):
+        (rx::WindowSurfaceEAGL::getHeight const):
+        (rx::WindowSurfaceEAGL::isPostSubBufferSupported const):
+        (rx::WindowSurfaceEAGL::getSwapBehavior const):
+        (rx::WindowSurfaceEAGL::createDefaultFramebuffer):
+        * src/libANGLE/renderer/gl/renderergl_utils.cpp:
+        (rx::nativegl_gl::GenerateCaps):
+        * src/libANGLE/validationES2.cpp:
+        (gl::ValidateFramebufferTexture2D):
+        * src/libGLESv2/entry_points_egl_ext.cpp:
+
+2019-11-06  Dean Jackson  <dino@apple.com>
+
+        [ANGLE] IOSurfaceSurfaceCGL has format and internalFormat flipped
+        https://bugs.webkit.org/show_bug.cgi?id=203911
+        <rdar://problem/56954291>
+
+        Reviewed by Simon Fraser.
+
+        Fix a typo where internalFormat and format are used in the
+        wrong order. The table of formats also had them backwards.
+
+        * src/libANGLE/renderer/gl/cgl/IOSurfaceSurfaceCGL.cpp:
+        (rx::IOSurfaceSurfaceCGL::bindTexImage):
+
+2019-10-29  Dean Jackson  <dino@apple.com>
+
+        [ANGLE] Put Apple platform compilation guards in a better place
+        https://bugs.webkit.org/show_bug.cgi?id=203590
+        <rdar://problem/56722345>
+
+        Reviewed by Simon Fraser.
+
+        Move the #define to platform.h.
+
+        * src/common/platform.h:
+        * src/libANGLE/renderer/gl/cgl/DeviceCGL.cpp:
+        * src/libANGLE/renderer/gl/cgl/DisplayCGL.mm:
+        * src/libANGLE/renderer/gl/cgl/IOSurfaceSurfaceCGL.cpp:
+        * src/libANGLE/renderer/gl/cgl/PbufferSurfaceCGL.cpp:
+        * src/libANGLE/renderer/gl/cgl/RendererCGL.cpp:
+        * src/libANGLE/renderer/gl/cgl/WindowSurfaceCGL.mm:
+
+2019-10-29  Dean Jackson  <dino@apple.com>
+
+        [ANGLE] Window Server blocking stops single GPU systems from creating a CGLPixelFormat
+        https://bugs.webkit.org/show_bug.cgi?id=203522
+        <rdar://problem/56685302>
+
+        Reviewed by Alex Christensen.
+
+        The Web Content Process blocks access to the Window Server. For that reason, we
+        must create all CGLPixelFormats with the "offline renderer" flag, even if we're
+        not on a dual-GPU system.
+
+        * src/libANGLE/renderer/gl/cgl/DisplayCGL.mm: Always enable kCGLPFAAllowOfflineRenderers.
+        (rx::DisplayCGL::initialize):
+
+2019-10-23  Dean Jackson  <dino@apple.com>
+
+        [ANGLE] Improve compile-time macOS guards and avoid ObjC if possible
+        https://bugs.webkit.org/show_bug.cgi?id=203343
+
+        Reviewed by Simon Fraser.
+
+        Use the more official compile-time detection of Apple platforms, so that
+        it will be easier to differentiate between macOS and iOS. Also move some
+        .mm files to .cpp where possible.
+
+        * ANGLE.xcodeproj/project.pbxproj:
+        * src/gpu_info_util/SystemInfo_mac.cpp: Renamed from Source/ThirdParty/ANGLE/src/gpu_info_util/SystemInfo_mac.mm.
+        (angle::GetSystemInfo):
+        * src/libANGLE/renderer/gl/cgl/DeviceCGL.cpp:
+        * src/libANGLE/renderer/gl/cgl/DisplayCGL.mm:
+        * src/libANGLE/renderer/gl/cgl/IOSurfaceSurfaceCGL.cpp: Renamed from Source/ThirdParty/ANGLE/src/libANGLE/renderer/gl/cgl/IOSurfaceSurfaceCGL.mm.
+        * src/libANGLE/renderer/gl/cgl/PbufferSurfaceCGL.cpp: Renamed from Source/ThirdParty/ANGLE/src/libANGLE/renderer/gl/cgl/PbufferSurfaceCGL.mm.
+        * src/libANGLE/renderer/gl/cgl/RendererCGL.cpp: Renamed from Source/ThirdParty/ANGLE/src/libANGLE/renderer/gl/cgl/RendererCGL.mm.
+        * src/libANGLE/renderer/gl/cgl/WindowSurfaceCGL.mm:
+
+2019-10-23  Dean Jackson  <dino@apple.com>
+
+        Don't try to compile .inc files in ANGLE
+        https://bugs.webkit.org/show_bug.cgi?id=203315
+
+        Reviewed by Simon Fraser.
+
+        These are headers, not files we need to compile directly.
+
+        * ANGLE.xcodeproj/project.pbxproj:
+
+2019-10-15  Brent Fulgham  <bfulgham@apple.com>
+
+        Unreviewed build fix after r251018
+
+
+        * PlatformFTW.cmake: Add missing dxgi library.
+
+2019-10-12  Stephan Szabo  <stephan.szabo@sony.com>
+
+        Regression (251018): Wincairo build broken: unresolved external symbol
+        https://bugs.webkit.org/show_bug.cgi?id=202879
+
+        Reviewed by Alex Christensen.
+
+        * PlatformWin.cmake: Add dxgi library for CreateDXGIFactory1
+
+2019-10-11  Kenneth Russell  <kbr@chromium.org>
+
+        USE_ANGLE=1 build broken with last ANGLE roll
+        https://bugs.webkit.org/show_bug.cgi?id=202872
+
+        Add FrameCapture_mock.cpp to Xcode and CMake builds.
+
+        Reviewed by Alex Christensen.
+
+        * ANGLE.xcodeproj/project.pbxproj:
+        * CMakeLists.txt:
+        * GLESv2.cmake:
+
+2019-10-11  Kenneth Russell  <kbr@chromium.org>
+
+        Roll ANGLE for ETC extensions and EGL_ANGLE_device_cgl
+        https://bugs.webkit.org/show_bug.cgi?id=202780
+
+        Roll ANGLE to c5e0ac757a112a24a0118d434e652fd7b558e6a8 via new
+        update-angle.sh script.
+
+        Reviewed by Alex Christensen.
+
+        * .gitignore:
+        * ANGLE.plist:
+        * ANGLE.xcodeproj/project.pbxproj:
+        * BUILD.gn:
+        * CMakeLists.txt:
+        * CONTRIBUTORS:
+        * DEPS:
+        * GLESv2.cmake:
+        * OWNERS:
+        * PRESUBMIT.py:
+        (_CheckExportValidity):
+        (CheckChangeOnUpload):
+        (CheckChangeOnCommit):
+        * README.md:
+        * android/angle_apk.gni:
+        * build_overrides/angle.gni:
+        * changes.diff:
+        * doc/DevSetup.md:
+        * dotfile_settings.gni:
+        * extensions/ANGLE_compressed_texture_etc.txt: Added.
+        * extensions/EGL_ANGLE_device_cgl.txt: Added.
+        * extensions/EGL_ANGLE_feature_control.txt:
+        * extensions/EGL_ANGLE_platform_angle_d3d11on12.txt: Added.
+        * extensions/EGL_ANGLE_platform_angle_device_type_swiftshader.txt: Added.
+        * extensions/EGL_ANGLE_platform_angle_metal.txt: Added.
+        * gni/angle.gni:
+        * include/EGL/eglext_angle.h:
+        * include/platform/Feature.h:
+        (angle::Feature::Feature):
+        * include/platform/FeaturesD3D.h:
+        * include/platform/FeaturesGL.h:
+        * include/platform/FeaturesVk.h:
+        * include/platform/FrontendFeatures.h:
+        * samples/WindowTest/WindowTest.cpp:
+        * samples/gles1/DrawTexture.cpp:
+        * samples/multi_texture/MultiTexture.cpp:
+        * samples/multiple_draw_buffers/MultipleDrawBuffers.cpp:
+        * samples/particle_system/ParticleSystem.cpp:
+        * samples/sample_util/SampleApplication.cpp:
+        (SampleApplication::SampleApplication):
+        * samples/sample_util/SampleApplication.h:
+        * scripts/code_generation_hashes/ANGLE_format.json:
+        * scripts/code_generation_hashes/ANGLE_load_functions_table.json:
+        * scripts/code_generation_hashes/D3D11_format.json:
+        * scripts/code_generation_hashes/DXGI_format.json:
+        * scripts/code_generation_hashes/GL_EGL_WGL_loader.json:
+        * scripts/code_generation_hashes/GL_EGL_entry_points.json:
+        * scripts/code_generation_hashes/OpenGL_dispatch_table.json:
+        * scripts/code_generation_hashes/Static_builtins.json:
+        * scripts/code_generation_hashes/Vulkan_format.json:
+        * scripts/code_generation_hashes/Vulkan_internal_shader_programs.json:
+        * scripts/code_generation_hashes/Vulkan_mandatory_format_support_table.json:
+        * scripts/code_generation_hashes/proc_table.json:
+        * scripts/export_targets.py:
+        (has_all_includes):
+        * scripts/generate_entry_points.py:
+        (get_resource_id_types):
+        (format_resource_id_types):
+        (write_capture_helper_header):
+        (get_resource_id_type_from_param_type):
+        (format_param_type_to_resource_id_type_case):
+        (format_param_type_resource_id_cases):
+        (format_resource_id_type_name_case):
+        (write_capture_helper_source):
+        * scripts/generate_vulkan_layers_json.py:
+        (main):
+        * scripts/registry_xml.py:
+        * src/common/PackedEnums.cpp:
+        (gl::operator<<):
+        * src/common/PackedEnums.h:
+        (angle::EnumSize<E>):
+        (gl::FromGLenum<VertexAttribType>):
+        (gl::ToGLenum):
+        (gl::ValueEquals):
+        (gl::operator==):
+        (gl::operator!=):
+        * src/common/android_util.cpp:
+        (angle::android::NativePixelFormatToGLInternalFormat):
+        * src/common/angleutils.h:
+        * src/common/debug.h:
+        * src/common/platform.h:
+        * src/common/system_utils_winuwp.cpp: Added.
+        (angle::SetEnvironmentVar):
+        (angle::GetEnvironmentVar):
+        (angle::GetSharedLibraryExtension):
+        (angle::GetPathSeparator):
+        (angle::GetCurrentTime):
+        (angle::UwpLibrary::UwpLibrary):
+        (angle::OpenSharedLibrary):
+        (angle::IsDebuggerAttached):
+        (angle::BreakDebugger):
+        * src/common/tls.cpp:
+        (CreateTLSIndex):
+        (DestroyTLSIndex):
+        (SetTLSValue):
+        (GetTLSValue):
+        * src/common/tls.h:
+        * src/common/utilities.cpp:
+        (gl::StripLastArrayIndex):
+        * src/common/utilities.h:
+        * src/compiler.gni:
+        * src/compiler/translator/Compiler.cpp:
+        (sh::TCompiler::compileTreeImpl):
+        * src/compiler/translator/ImmutableString_ESSL_autogen.cpp:
+        * src/compiler/translator/ImmutableString_autogen.cpp:
+        * src/compiler/translator/IntermNode.h:
+        (sh::TIntermPreprocessorDirective::getDirective const): Deleted.
+        (sh::TIntermPreprocessorDirective::getCommand const): Deleted.
+        * src/compiler/translator/ParseContext.cpp:
+        (sh::TParseContext::TParseContext):
+        (sh::TParseContext::checkIsValidArraySize):
+        (sh::TParseContext::parseFunctionDeclarator):
+        * src/compiler/translator/ParseContext.h:
+        (sh::TParseContext::getOutputType const):
+        * src/compiler/translator/ShaderVars.cpp:
+        (sh::ShaderVariable::operator=):
+        * src/compiler/translator/SymbolTable.cpp:
+        (sh::TSymbolTable::setGlInArraySize):
+        (sh::TSymbolTable::gl_FragData const):
+        (sh::TSymbolTable::gl_SecondaryFragDataEXT const):
+        (sh::SymbolRule::get const):
+        (sh::FindMangledBuiltIn):
+        (sh::UnmangledEntry::matches const):
+        * src/compiler/translator/SymbolTable.h:
+        (sh::SymbolRule::SymbolRule):
+        (sh::SymbolRule::Get):
+        (sh::UnmangledEntry::UnmangledEntry):
+        (sh::SymbolEntry::SymbolEntry): Deleted.
+        * src/compiler/translator/SymbolTable_ESSL_autogen.cpp:
+        (sh::BuiltInVariable::angle_BaseInstance):
+        (sh::BuiltInVariable::angle_BaseVertex):
+        (sh::BuiltInVariable::gl_BaseInstance):
+        (sh::BuiltInVariable::gl_BaseVertex):
+        (sh::BuiltInVariable::gl_DrawID):
+        (sh::BuiltInVariable::gl_FragColor):
+        (sh::BuiltInVariable::gl_FragCoord):
+        (sh::BuiltInVariable::gl_FragDepth):
+        (sh::BuiltInVariable::gl_FrontFacing):
+        (sh::BuiltInVariable::gl_GlobalInvocationID):
+        (sh::BuiltInVariable::gl_InstanceID):
+        (sh::BuiltInVariable::gl_InstanceIndex):
+        (sh::BuiltInVariable::gl_InvocationID):
+        (sh::BuiltInVariable::gl_LastFragColor):
+        (sh::BuiltInVariable::gl_LastFragColorARM):
+        (sh::BuiltInVariable::gl_Layer):
+        (sh::BuiltInVariable::gl_LayerGS):
+        (sh::BuiltInVariable::gl_LayerVS):
+        (sh::BuiltInVariable::gl_LocalInvocationID):
+        (sh::BuiltInVariable::gl_LocalInvocationIndex):
+        (sh::BuiltInVariable::gl_NumWorkGroups):
+        (sh::BuiltInVariable::gl_PointCoord):
+        (sh::BuiltInVariable::gl_PointSize):
+        (sh::BuiltInVariable::gl_Position):
+        (sh::BuiltInVariable::gl_PrimitiveID):
+        (sh::BuiltInVariable::gl_PrimitiveIDGS):
+        (sh::BuiltInVariable::gl_PrimitiveIDIn):
+        (sh::BuiltInVariable::gl_SecondaryFragColorEXT):
+        (sh::BuiltInVariable::gl_VertexID):
+        (sh::BuiltInVariable::gl_VertexIndex):
+        (sh::BuiltInVariable::gl_ViewID_OVR):
+        (sh::BuiltInVariable::gl_ViewportIndex):
+        (sh::BuiltInVariable::gl_WorkGroupID):
+        (sh::BuiltInVariable::gl_WorkGroupSize):
+        (sh::TSymbolTable::initializeBuiltInVariables):
+        (sh::TSymbolTable::findBuiltIn const):
+        (sh::TSymbolTable::isUnmangledBuiltInName const):
+        (sh::TSymbolTable::getSymbol const): Deleted.
+        (sh::TSymbolTable::getUnmangled const): Deleted.
+        (sh::TSymbolTable::getUnmangledBuiltInForShaderVersion): Deleted.
+        * src/compiler/translator/SymbolTable_autogen.cpp:
+        (sh::BuiltInVariable::angle_BaseInstance):
+        (sh::BuiltInVariable::angle_BaseVertex):
+        (sh::BuiltInVariable::gl_BaseInstance):
+        (sh::BuiltInVariable::gl_BaseVertex):
+        (sh::BuiltInVariable::gl_DrawID):
+        (sh::BuiltInVariable::gl_FragColor):
+        (sh::BuiltInVariable::gl_FragCoord):
+        (sh::BuiltInVariable::gl_FragDepth):
+        (sh::BuiltInVariable::gl_FrontFacing):
+        (sh::BuiltInVariable::gl_GlobalInvocationID):
+        (sh::BuiltInVariable::gl_InstanceID):
+        (sh::BuiltInVariable::gl_InstanceIndex):
+        (sh::BuiltInVariable::gl_InvocationID):
+        (sh::BuiltInVariable::gl_LastFragColor):
+        (sh::BuiltInVariable::gl_LastFragColorARM):
+        (sh::BuiltInVariable::gl_Layer):
+        (sh::BuiltInVariable::gl_LayerGS):
+        (sh::BuiltInVariable::gl_LayerVS):
+        (sh::BuiltInVariable::gl_LocalInvocationID):
+        (sh::BuiltInVariable::gl_LocalInvocationIndex):
+        (sh::BuiltInVariable::gl_NumWorkGroups):
+        (sh::BuiltInVariable::gl_PointCoord):
+        (sh::BuiltInVariable::gl_PointSize):
+        (sh::BuiltInVariable::gl_Position):
+        (sh::BuiltInVariable::gl_PrimitiveID):
+        (sh::BuiltInVariable::gl_PrimitiveIDGS):
+        (sh::BuiltInVariable::gl_PrimitiveIDIn):
+        (sh::BuiltInVariable::gl_SecondaryFragColorEXT):
+        (sh::BuiltInVariable::gl_VertexID):
+        (sh::BuiltInVariable::gl_VertexIndex):
+        (sh::BuiltInVariable::gl_ViewID_OVR):
+        (sh::BuiltInVariable::gl_ViewportIndex):
+        (sh::BuiltInVariable::gl_WorkGroupID):
+        (sh::BuiltInVariable::gl_WorkGroupSize):
+        (sh::TSymbolTable::initializeBuiltInVariables):
+        (sh::TSymbolTable::findBuiltIn const):
+        (sh::TSymbolTable::isUnmangledBuiltInName const):
+        (sh::TSymbolTable::getSymbol const): Deleted.
+        (sh::TSymbolTable::getUnmangled const): Deleted.
+        (sh::TSymbolTable::getUnmangledBuiltInForShaderVersion): Deleted.
+        * src/compiler/translator/SymbolTable_autogen.h:
+        * src/compiler/translator/TranslatorVulkan.cpp:
+        (sh::TranslatorVulkan::translate):
+        * src/compiler/translator/gen_builtin_symbols.py:
+        (get_shader_version_for_level):
+        (GroupedList.__init__):
+        (GroupedList.add_entry):
+        (GroupedList.format_rule):
+        (GroupedList):
+        (GroupedList.format_rules):
+        (GroupedList.get_rules):
+        (GroupedList.get_names):
+        (GroupedList.get_offsets):
+        (GroupedList.update_arrays):
+        (GroupedList.update_arrays.add_rule):
+        (UnmangledGroupedList.add_entry):
+        (UnmangledGroupedList.get_array):
+        (define_constexpr_variable):
+        (process_single_function_group):
+        (process_function_group):
+        (process_single_variable_group):
+        (GroupedList.add_obj): Deleted.
+        (GroupedList.get_array): Deleted.
+        (UnmangledGroupedList.add_obj): Deleted.
+        * src/feature_support_util/feature_support_util.cpp:
+        * src/gpu_info_util/SystemInfo_win.cpp:
+        (angle::GetSystemInfo):
+        * src/image_util/loadimage.cpp:
+        (angle::LoadD24S8ToD32F):
+        (angle::LoadD32ToD32FX32):
+        (angle::LoadD32ToD32F):
+        * src/image_util/loadimage.h:
+        * src/libANGLE/Buffer.cpp:
+        (gl::Buffer::Buffer):
+        * src/libANGLE/Buffer.h:
+        * src/libANGLE/Caps.cpp:
+        (gl::DetermineHalfFloatTextureFilteringSupport):
+        (gl::DetermineFloatTextureFilteringSupport):
+        (gl::Extensions::setTextureExtensionSupport):
+        (gl::GetExtensionInfoMap):
+        (egl::DisplayExtensions::getStrings const):
+        (egl::DeviceExtensions::getStrings const):
+        (egl::ClientExtensions::getStrings const):
+        * src/libANGLE/Caps.h:
+        * src/libANGLE/Constants.h:
+        * src/libANGLE/Context.cpp:
+        (gl::Context::Context):
+        (gl::Context::initialize):
+        (gl::Context::onDestroy):
+        (gl::Context::bindImageTexture):
+        (gl::Context::getQueryiv):
+        (gl::Context::detachTexture):
+        (gl::Context::generateSupportedExtensions const):
+        (gl::Context::initCaps):
+        (gl::Context::onSubjectStateChange):
+        (gl::StateCache::updateActiveAttribsMask):
+        (gl::StateCache::updateVertexAttribTypesValidation):
+        * src/libANGLE/Context.h:
+        * src/libANGLE/Device.cpp:
+        (egl::Device::getAttribute):
+        (egl::Device::getDevice): Deleted.
+        * src/libANGLE/Device.h:
+        * src/libANGLE/Display.cpp:
+        (egl::Display::createContext):
+        (egl::GenerateClientExtensions):
+        (egl::Display::isValidNativeDisplay):
+        (egl::Display::initializeFrontendFeatures):
+        (egl::Display::queryStringi):
+        * src/libANGLE/ErrorStrings.h:
+        * src/libANGLE/Fence.h:
+        * src/libANGLE/FrameCapture.cpp:
+        (angle::ParamCapture::ParamCapture):
+        (angle::ParamCapture::operator=):
+        (angle::ParamBuffer::ParamBuffer):
+        (angle::ParamBuffer::operator=):
+        (angle::ParamBuffer::getParam):
+        (angle::ParamBuffer::getParam const):
+        (angle::ParamBuffer::addParam):
+        (angle::ParamBuffer::addReturnValue):
+        (angle::ParamBuffer::getClientArrayPointerParameter):
+        (angle::CallCapture::CallCapture):
+        (angle::CallCapture::operator=):
+        (angle::CallCapture::name const):
+        (angle::ReplayContext::ReplayContext):
+        (angle::ReplayContext::~ReplayContext):
+        (angle::FrameCapture::FrameCapture):
+        (angle::FrameCapture::maybeCaptureClientData):
+        (angle::FrameCapture::captureCall):
+        (angle::FrameCapture::captureUpdateResourceIDs):
+        (angle::FrameCapture::maybeUpdateResourceIDs):
+        (angle::FrameCapture::captureClientArraySnapshot):
+        (angle::FrameCapture::onEndFrame):
+        (angle::DataCounters::getAndIncrement):
+        (angle::FrameCapture::reset):
+        (angle::CaptureGenHandlesImpl):
+        (angle::WriteParamValueToStream<ParamType::TBufferID>):
+        (angle::WriteParamValueToStream<ParamType::TFenceNVID>):
+        (angle::WriteParamValueToStream<ParamType::TFramebufferID>):
+        (angle::WriteParamValueToStream<ParamType::TMemoryObjectID>):
+        (angle::WriteParamValueToStream<ParamType::TPathID>):
+        (angle::WriteParamValueToStream<ParamType::TProgramPipelineID>):
+        (angle::WriteParamValueToStream<ParamType::TQueryID>):
+        (angle::WriteParamValueToStream<ParamType::TRenderbufferID>):
+        (angle::WriteParamValueToStream<ParamType::TSamplerID>):
+        (angle::WriteParamValueToStream<ParamType::TSemaphoreID>):
+        (angle::WriteParamValueToStream<ParamType::TShaderProgramID>):
+        (angle::WriteParamValueToStream<ParamType::TTextureID>):
+        (angle::WriteParamValueToStream<ParamType::TTransformFeedbackID>):
+        (angle::WriteParamValueToStream<ParamType::TVertexArrayID>):
+        (angle::CallCapture::~CallCapture): Deleted.
+        (angle::ParamBuffer::~ParamBuffer): Deleted.
+        (angle::ParamCapture::~ParamCapture): Deleted.
+        (angle::FrameCapture::~FrameCapture): Deleted.
+        (angle::FrameCapture::anyClientArray const): Deleted.
+        (angle::FrameCapture::saveCapturedFrameAsCpp): Deleted.
+        (angle::FrameCapture::getAndIncrementCounter): Deleted.
+        (angle::FrameCapture::writeStringPointerParamReplay): Deleted.
+        (angle::FrameCapture::writeRenderbufferIDPointerParamReplay): Deleted.
+        (angle::FrameCapture::writeBinaryParamReplay): Deleted.
+        (angle::FrameCapture::writeCallReplay): Deleted.
+        * src/libANGLE/FrameCapture.h:
+        (angle::CaptureGenHandles):
+        * src/libANGLE/FrameCapture_mock.cpp: Added.
+        (angle::CallCapture::~CallCapture):
+        (angle::ParamBuffer::~ParamBuffer):
+        (angle::ParamCapture::~ParamCapture):
+        (angle::FrameCapture::FrameCapture):
+        (angle::FrameCapture::~FrameCapture):
+        (angle::FrameCapture::onEndFrame):
+        (angle::FrameCapture::replay):
+        * src/libANGLE/Framebuffer.cpp:
+        (gl::Framebuffer::formsRenderingFeedbackLoopWith const):
+        (gl::Framebuffer::formsCopyingFeedbackLoopWith const):
+        * src/libANGLE/Framebuffer.h:
+        * src/libANGLE/FramebufferAttachment.cpp:
+        (gl::FramebufferAttachment::getRedSize const):
+        (gl::FramebufferAttachment::getGreenSize const):
+        (gl::FramebufferAttachment::getBlueSize const):
+        (gl::FramebufferAttachment::getAlphaSize const):
+        (gl::FramebufferAttachment::getDepthSize const):
+        (gl::FramebufferAttachment::getStencilSize const):
+        * src/libANGLE/FramebufferAttachment.h:
+        * src/libANGLE/GLES1State.cpp:
+        (gl::GLES1State::getActiveAttributesMask const):
+        * src/libANGLE/GLES1State.h:
+        * src/libANGLE/ImageIndex.cpp:
+        * src/libANGLE/ImageIndex.h:
+        * src/libANGLE/MemoryObject.cpp:
+        (gl::MemoryObject::MemoryObject):
+        * src/libANGLE/MemoryObject.h:
+        * src/libANGLE/MemoryProgramCache.cpp:
+        * src/libANGLE/Program.cpp:
+        (gl::ProgramBindings::bindLocation):
+        (gl::ProgramBindings::getBindingByName const):
+        (gl::ProgramBindings::getBinding const):
+        (gl::ProgramBindings::begin const):
+        (gl::ProgramBindings::end const):
+        (gl::ProgramAliasedBindings::ProgramAliasedBindings):
+        (gl::ProgramAliasedBindings::~ProgramAliasedBindings):
+        (gl::ProgramAliasedBindings::bindLocation):
+        (gl::ProgramAliasedBindings::getBindingByName const):
+        (gl::ProgramAliasedBindings::getBinding const):
+        (gl::ProgramAliasedBindings::begin const):
+        (gl::ProgramAliasedBindings::end const):
+        (gl::ProgramState::getAttributeLocation const):
+        (gl::ProgramState::getFirstAttachedShaderStageType const):
+        (gl::ProgramState::getLastAttachedShaderStageType const):
+        (gl::Program::getFragmentInputBindingInfo const):
+        (gl::Program::link):
+        (gl::ProgramState::updateProgramInterfaceInputs):
+        (gl::ProgramState::updateProgramInterfaceOutputs):
+        (gl::Program::unlink):
+        (gl::Program::getActiveAttribute const):
+        (gl::Program::getActiveAttributeCount const):
+        (gl::Program::getActiveAttributeMaxLength const):
+        (gl::Program::getAttributes const):
+        (gl::Program::getInputResource const):
+        (gl::Program::getInputResourceIndex const):
+        (gl::Program::getResourceMaxNameSize const):
+        (gl::Program::getInputResourceMaxNameSize const):
+        (gl::Program::getOutputResourceMaxNameSize const):
+        (gl::Program::getResourceLocation const):
+        (gl::Program::getInputResourceLocation const):
+        (gl::Program::getOutputResourceLocation const):
+        (gl::Program::getOutputResourceIndex const):
+        (gl::Program::getResourceName const):
+        (gl::Program::getInputResourceName const):
+        (gl::Program::getOutputResourceName const):
+        (gl::Program::getUniformResourceName const):
+        (gl::Program::getBufferVariableResourceName const):
+        (gl::Program::getOutputResource const):
+        (gl::Program::getUniformLocationBindings const):
+        (gl::Program::linkUniforms):
+        (gl::Program::linkAttributes):
+        (gl::Program::linkValidateGlobalNames const):
+        (gl::Program::getMergedVaryings const):
+        (gl::Program::linkOutputVariables):
+        (gl::Program::serialize const):
+        (gl::Program::deserialize):
+        * src/libANGLE/Program.h:
+        (gl::ProgramVaryingRef::get const):
+        * src/libANGLE/ProgramLinkedResources.cpp:
+        (gl::UniformLinker::link):
+        (gl::UniformLinker::indexUniforms):
+        (gl::UniformLinker::gatherUniformLocationsAndCheckConflicts):
+        * src/libANGLE/ProgramLinkedResources.h:
+        * src/libANGLE/ProgramPipeline.cpp:
+        (gl::ProgramPipeline::ProgramPipeline):
+        * src/libANGLE/ProgramPipeline.h:
+        * src/libANGLE/Query.cpp:
+        (gl::Query::Query):
+        * src/libANGLE/Query.h:
+        * src/libANGLE/RefCountObject.h:
+        (gl::RefCountObject::RefCountObject):
+        (gl::RefCountObject::id const):
+        (gl::BindingPointer::id const):
+        * src/libANGLE/Renderbuffer.cpp:
+        (gl::Renderbuffer::Renderbuffer):
+        (gl::Renderbuffer::getId const):
+        * src/libANGLE/Renderbuffer.h:
+        * src/libANGLE/Sampler.cpp:
+        (gl::Sampler::Sampler):
+        * src/libANGLE/Sampler.h:
+        * src/libANGLE/Semaphore.cpp:
+        (gl::Semaphore::Semaphore):
+        * src/libANGLE/Semaphore.h:
+        * src/libANGLE/Shader.cpp:
+        (gl::Shader::resolveCompile):
+        (gl::Shader::getTransformFeedbackVaryingMappedName):
+        * src/libANGLE/State.cpp:
+        (gl::State::getSamplerTextureId const):
+        (gl::State::detachTexture):
+        (gl::State::detachSampler):
+        (gl::State::detachRenderbuffer):
+        (gl::State::removeTransformFeedbackBinding):
+        (gl::State::getActiveQueryId const):
+        (gl::State::detachBuffer):
+        (gl::State::getIntegerv):
+        (gl::State::getIntegeri_v):
+        (gl::State::syncImages):
+        (gl::State::onImageStateChange):
+        * src/libANGLE/State.h:
+        (gl::State::getSamplerId const):
+        (gl::State::getRenderbufferId const):
+        * src/libANGLE/Texture.cpp:
+        (gl::Texture::Texture):
+        (gl::Texture::setStorage):
+        (gl::Texture::getId const):
+        * src/libANGLE/Texture.h:
+        * src/libANGLE/TransformFeedback.cpp:
+        (gl::TransformFeedback::TransformFeedback):
+        (gl::TransformFeedback::detachBuffer):
+        * src/libANGLE/TransformFeedback.h:
+        * src/libANGLE/VaryingPacking.cpp:
+        (gl::VaryingPacking::collectAndPackUserVaryings):
+        (gl::VaryingPacking::packUserVaryings):
+        * src/libANGLE/VertexArray.cpp:
+        (gl::VertexArray::detachBuffer):
+        (gl::VertexArray::bindVertexBufferImpl):
+        * src/libANGLE/VertexArray.h:
+        * src/libANGLE/capture_gles_2_0_params.cpp:
+        (gl::CaptureDeleteBuffers_buffersPacked):
+        (gl::CaptureDeleteFramebuffers_framebuffersPacked):
+        (gl::CaptureDeleteTextures_texturesPacked):
+        (gl::CaptureGenBuffers_buffersPacked):
+        (gl::CaptureGenFramebuffers_framebuffersPacked):
+        (gl::CaptureGenRenderbuffers_renderbuffersPacked):
+        (gl::CaptureGenTextures_texturesPacked):
+        (gl::CaptureShaderSource_string):
+        * src/libANGLE/capture_gles_3_0_params.cpp:
+        (gl::CaptureDeleteQueries_idsPacked):
+        (gl::CaptureDeleteSamplers_samplersPacked):
+        (gl::CaptureDeleteTransformFeedbacks_idsPacked):
+        (gl::CaptureDeleteVertexArrays_arraysPacked):
+        (gl::CaptureGenQueries_idsPacked):
+        (gl::CaptureGenSamplers_samplersPacked):
+        (gl::CaptureGenTransformFeedbacks_idsPacked):
+        (gl::CaptureGenVertexArrays_arraysPacked):
+        * src/libANGLE/capture_gles_3_1_params.cpp:
+        (gl::CaptureDeleteProgramPipelines_pipelinesPacked):
+        (gl::CaptureGenProgramPipelines_pipelinesPacked):
+        * src/libANGLE/capture_gles_ext_params.cpp:
+        (gl::CaptureDeleteQueriesEXT_idsPacked):
+        (gl::CaptureGenQueriesEXT_idsPacked):
+        * src/libANGLE/features.h:
+        * src/libANGLE/formatutils.cpp:
+        (gl::UnsizedHalfFloatOESRGBATextureAttachmentSupport):
+        (gl::BuildInternalFormatInfoMap):
+        (gl::InternalFormat::computeDepthPitch const):
+        (gl::GetVertexFormatID):
+        (gl::GetVertexFormatFromID):
+        (gl::GetVertexFormatSize):
+        * src/libANGLE/frame_capture_utils_autogen.cpp:
+        (angle::GetResourceIDTypeFromParamType):
+        (angle::GetResourceIDTypeName):
+        * src/libANGLE/frame_capture_utils_autogen.h:
+        * src/libANGLE/queryutils.cpp:
+        (gl::GetBufferVariableResourceProperty):
+        (gl::QueryProgramResourceLocation):
+        (gl::QueryProgramResourceiv):
+        (egl::QueryContextAttrib):
+        * src/libANGLE/renderer/DeviceImpl.h:
+        * src/libANGLE/renderer/Format.h:
+        (angle::Format::isVertexTypeHalfFloat const):
+        * src/libANGLE/renderer/FormatID_autogen.h:
+        * src/libANGLE/renderer/Format_table_autogen.cpp:
+        (angle::Format::InternalFormatToID):
+        * src/libANGLE/renderer/angle_format.py:
+        (gl_format_channels):
+        (get_vertex_copy_function):
+        * src/libANGLE/renderer/angle_format_map.json:
+        * src/libANGLE/renderer/copyvertex.h:
+        * src/libANGLE/renderer/copyvertex.inc.h:
+        (rx::CopyTo32FVertexData):
+        (rx::CopyXYZ10ToXYZW32FVertexData):
+        (rx::CopyW2XYZ10ToXYZW32FVertexData):
+        * src/libANGLE/renderer/d3d/DeviceD3D.cpp:
+        (rx::DeviceD3D::getAttribute):
+        (rx::DeviceD3D::getDevice): Deleted.
+        * src/libANGLE/renderer/d3d/DeviceD3D.h:
+        * src/libANGLE/renderer/d3d/HLSLCompiler.cpp:
+        (rx::HLSLCompiler::ensureInitialized):
+        (rx::HLSLCompiler::compileToBinary):
+        * src/libANGLE/renderer/d3d/ProgramD3D.cpp:
+        (rx::ProgramD3D::getVertexExecutableForCachedInputLayout):
+        * src/libANGLE/renderer/d3d/RendererD3D.cpp:
+        (rx::DefaultGLErrorCode):
+        * src/libANGLE/renderer/d3d/ShaderD3D.cpp:
+        (rx::ShaderD3D::compile):
+        * src/libANGLE/renderer/d3d/d3d11/Buffer11.cpp:
+        (rx::Buffer11::getConstantBufferRange):
+        (rx::Buffer11::NativeStorage::FillBufferDesc):
+        * src/libANGLE/renderer/d3d/d3d11/Context11.cpp:
+        (rx::Context11::drawArrays):
+        (rx::Context11::drawArraysInstanced):
+        (rx::Context11::drawArraysInstancedBaseInstance):
+        (rx::Context11::drawArraysIndirect):
+        * src/libANGLE/renderer/d3d/d3d11/DebugAnnotator11.cpp:
+        (rx::DebugAnnotator11::initialize):
+        * src/libANGLE/renderer/d3d/d3d11/Renderer11.cpp:
+        (rx::Renderer11::Renderer11):
+        (rx::Renderer11::initialize):
+        (rx::Renderer11::callD3D11On12CreateDevice):
+        (rx::Renderer11::initializeD3DDevice):
+        (rx::Renderer11::generateDisplayExtensions const):
+        (rx::Renderer11::isValidNativeWindow const):
+        (rx::Renderer11::createNativeWindow const):
+        (rx::Renderer11::drawArrays):
+        (rx::Renderer11::release):
+        (rx::Renderer11::getShareHandleSupport const):
+        (rx::Renderer11::copyImageInternal):
+        * src/libANGLE/renderer/d3d/d3d11/Renderer11.h:
+        * src/libANGLE/renderer/d3d/d3d11/TextureStorage11.cpp:
+        (rx::TextureStorage11::getSRVForImage):
+        (rx::TextureStorage11::getUAVForImage):
+        * src/libANGLE/renderer/d3d/d3d11/Trim11.cpp:
+        (rx::Trim11::trim):
+        (rx::Trim11::registerForRendererTrimRequest):
+        (rx::Trim11::unregisterForRendererTrimRequest):
+        * src/libANGLE/renderer/d3d/d3d11/Trim11.h:
+        * src/libANGLE/renderer/d3d/d3d11/converged/CompositorNativeWindow11.cpp:
+        (rx::RoHelper::SupportedWindowsRelease):
+        * src/libANGLE/renderer/d3d/d3d11/renderer11_utils.cpp:
+        (rx::d3d11_gl::GenerateCaps):
+        (rx::d3d11::InitializeFeatures):
+        * src/libANGLE/renderer/d3d/d3d11/winrt/CoreWindowNativeWindow.h:
+        * src/libANGLE/renderer/d3d/d3d11/winrt/NativeWindow11WinRT.cpp:
+        (rx::NativeWindow11WinRT::createSwapChain):
+        * src/libANGLE/renderer/d3d/d3d11/winrt/NativeWindow11WinRT.h:
+        * src/libANGLE/renderer/d3d/d3d11/winrt/SwapChainPanelNativeWindow.h:
+        * src/libANGLE/renderer/d3d/d3d9/renderer9_utils.cpp:
+        (rx::d3d9::InitializeFeatures):
+        * src/libANGLE/renderer/gen_angle_format_table.py:
+        (ceil_int):
+        (get_channel_struct):
+        (get_mip_generation_function):
+        * src/libANGLE/renderer/gl/BlitGL.cpp:
+        (rx::BlitGL::copyImageToLUMAWorkaroundTexture):
